/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case SUBREG:
    case TRUNCATE:
      return pattern17 (x3); /* [-1, 1] */

    case MINUS:
      res = pattern18 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case REG:
      operands[2] = x5;
      if (!aarch64_simd_register (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!aarch64_simd_register (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !aarch64_simd_register (operands[1], E_DImode))
            return -1;
          return 4;

        case E_SImode:
          if (!aarch64_simd_register (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !aarch64_simd_register (operands[1], E_SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
    case TRUNCATE:
      return 0;

    case MINUS:
      res = pattern18 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case CONST_VECTOR:
    case CONST:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern30 (x1, 
E_V8QImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern30 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4HImode:
          if (pattern30 (x1, 
E_V4HImode) != 0)
            return -1;
          return 5;

        case E_V8HImode:
          if (pattern30 (x1, 
E_V8HImode) != 0)
            return -1;
          return 6;

        case E_V2SImode:
          if (pattern30 (x1, 
E_V2SImode) != 0)
            return -1;
          return 7;

        case E_V4SImode:
          if (pattern30 (x1, 
E_V4SImode) != 0)
            return -1;
          return 8;

        case E_V2DImode:
          if (pattern30 (x1, 
E_V2DImode) != 0)
            return -1;
          return 9;

        case E_VNx16QImode:
          if (pattern30 (x1, 
E_VNx16QImode) != 0)
            return -1;
          return 10;

        case E_VNx8QImode:
          if (pattern30 (x1, 
E_VNx8QImode) != 0)
            return -1;
          return 11;

        case E_VNx4QImode:
          if (pattern30 (x1, 
E_VNx4QImode) != 0)
            return -1;
          return 12;

        case E_VNx2QImode:
          if (pattern30 (x1, 
E_VNx2QImode) != 0)
            return -1;
          return 13;

        case E_VNx8HImode:
          if (pattern30 (x1, 
E_VNx8HImode) != 0)
            return -1;
          return 14;

        case E_VNx4HImode:
          if (pattern30 (x1, 
E_VNx4HImode) != 0)
            return -1;
          return 15;

        case E_VNx2HImode:
          if (pattern30 (x1, 
E_VNx2HImode) != 0)
            return -1;
          return 16;

        case E_VNx4SImode:
          if (pattern30 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 17;

        case E_VNx2SImode:
          if (pattern30 (x1, 
E_VNx2SImode) != 0)
            return -1;
          return 18;

        case E_VNx2DImode:
          if (pattern30 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 19;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern67 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode))
            return -1;
          return 0;

        case E_VNx16QImode:
          if (!register_operand (operands[0], E_VNx16QImode)
              || GET_MODE (x3) != E_VNx16QImode
              || !register_operand (operands[1], E_VNx16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != i1)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != XOR)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern66 (x3, 
E_V16QImode) != 0)
            return -1;
          return 2;

        case E_VNx16QImode:
          if (pattern66 (x3, 
E_VNx16QImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern80 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aligned_register_operand (operands[1], i1)
      || !aligned_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i3
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 15
      || pattern87 (x1, 
E_DImode, 
15) != 0)
    return -1;
  return 0;
}

int
pattern92 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern79 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern79 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern79 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern79 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern79 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern79 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern79 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_QImode:
      if (pattern79 (x3, 
E_QImode) != 0)
        return -1;
      return 7;

    case E_HImode:
      if (pattern79 (x3, 
E_HImode) != 0)
        return -1;
      return 8;

    case E_SImode:
      if (pattern79 (x3, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_DImode:
      if (pattern79 (x3, 
E_DImode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern112 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      return pattern113 (
E_VNx8QImode, 
E_VNx4QImode, 
E_VNx2QImode); /* [-1, 3] */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8BImode:
          if (!register_operand (operands[1], E_VNx8BImode)
              || !register_operand (operands[2], E_VNx8HImode))
            return -1;
          return 4;

        case E_VNx4BImode:
          if (!register_operand (operands[1], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4HImode))
            return -1;
          return 5;

        case E_VNx2BImode:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx4BImode:
          if (!register_operand (operands[1], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SImode))
            return -1;
          return 7;

        case E_VNx2BImode:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case E_DImode:
      if (pattern92 (x3, 
E_VNx2DImode, 
E_VNx2BImode, 
E_DImode) != 0)
        return -1;
      return 9;

    case E_HFmode:
      res = pattern114 (x3, 
E_VNx2HFmode, 
E_VNx4HFmode, 
E_VNx8HFmode, 
E_HFmode);
      if (res >= 0)
        return res + 10; /* [10, 12] */
      return -1;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx2BImode:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2SFmode))
            return -1;
          return 13;

        case E_VNx4BImode:
          if (!register_operand (operands[1], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SFmode))
            return -1;
          return 14;

        default:
          return -1;
        }

    case E_DFmode:
      if (pattern92 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_DFmode) != 0)
        return -1;
      return 15;

    case E_BFmode:
      res = pattern114 (x3, 
E_VNx2BFmode, 
E_VNx4BFmode, 
E_VNx8BFmode, 
E_BFmode);
      if (res >= 0)
        return res + 16; /* [16, 18] */
      return -1;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern92 (x3, 
E_VNx8HFmode, 
E_VNx8BImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern92 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern92 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_qi (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_offset_si (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern173 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x2) != E_VNx16BImode)
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x2) != E_VNx8BImode)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x2) != E_VNx4BImode)
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x2) != E_VNx2BImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      return pattern186 (x3, 
E_VNx32QImode); /* [-1, 0] */

    case E_VNx16HImode:
      if (pattern186 (x3, 
E_VNx16HImode) != 0)
        return -1;
      return 1;

    case E_VNx8SImode:
      if (pattern186 (x3, 
E_VNx8SImode) != 0)
        return -1;
      return 2;

    case E_VNx4DImode:
      if (pattern186 (x3, 
E_VNx4DImode) != 0)
        return -1;
      return 3;

    case E_VNx16BFmode:
      if (pattern186 (x3, 
E_VNx16BFmode) != 0)
        return -1;
      return 4;

    case E_VNx16HFmode:
      if (pattern186 (x3, 
E_VNx16HFmode) != 0)
        return -1;
      return 5;

    case E_VNx8SFmode:
      if (pattern186 (x3, 
E_VNx8SFmode) != 0)
        return -1;
      return 6;

    case E_VNx4DFmode:
      if (pattern186 (x3, 
E_VNx4DFmode) != 0)
        return -1;
      return 7;

    case E_VNx64QImode:
      if (pattern186 (x3, 
E_VNx64QImode) != 0)
        return -1;
      return 8;

    case E_VNx32HImode:
      if (pattern186 (x3, 
E_VNx32HImode) != 0)
        return -1;
      return 9;

    case E_VNx16SImode:
      if (pattern186 (x3, 
E_VNx16SImode) != 0)
        return -1;
      return 10;

    case E_VNx8DImode:
      if (pattern186 (x3, 
E_VNx8DImode) != 0)
        return -1;
      return 11;

    case E_VNx32BFmode:
      if (pattern186 (x3, 
E_VNx32BFmode) != 0)
        return -1;
      return 12;

    case E_VNx32HFmode:
      if (pattern186 (x3, 
E_VNx32HFmode) != 0)
        return -1;
      return 13;

    case E_VNx16SFmode:
      if (pattern186 (x3, 
E_VNx16SFmode) != 0)
        return -1;
      return 14;

    case E_VNx8DFmode:
      if (pattern186 (x3, 
E_VNx8DFmode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          return pattern193 (x2, 
E_V16QImode, 
E_V8HFmode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern193 (x2, 
E_VNx16QImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern205 (x2, 
E_V8HFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern214 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || pattern213 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern220 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_register (operands[2], i1)
      || !aarch64_simd_register (operands[3], i1))
    return -1;
  return 0;
}

int
pattern223 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx32BImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_VNx32BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  if (!aarch64_reg_or_zero (operands[2], E_DImode))
    return -1;
  switch (XWINT (x4, 0))
    {
    case 8L:
      return 0;

    case 16L:
      return 1;

    case 32L:
      return 2;

    case 64L:
      return 3;

    default:
      return -1;
    }
}

int
pattern231 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[5] = x5;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  x8 = XVECEXP (x3, 0, 4);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BFmode:
      return pattern230 (x3, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx8HFmode:
      if (pattern230 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4SFmode:
      if (pattern230 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2DFmode:
      if (pattern230 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern238 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern244 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[1], E_VNx32QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[1], E_VNx64QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx64QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[1], E_VNx16HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx16HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[1], E_VNx32HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern251 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 168)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 93)
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (!const_int_operand (x7, E_SImode))
    return -1;
  x8 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 3);
      operands[1] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[2] = x10;
      operands[3] = x7;
      switch (GET_MODE (x6))
        {
        case E_VNx4SImode:
          return pattern244 (x2, 
E_VNx4SImode); /* [-1, 3] */

        case E_VNx2DImode:
          res = pattern244 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 4; /* [4, 7] */
          return -1;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x12 = XEXP (x8, 1);
      operands[1] = x12;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 3);
      operands[2] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[3] = x10;
      operands[4] = x7;
      switch (GET_MODE (x6))
        {
        case E_VNx4SImode:
          res = pattern248 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        case E_VNx2DImode:
          res = pattern248 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 12; /* [12, 15] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern266 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  switch (GET_MODE (x5))
    {
    case E_VNx4SImode:
      return pattern264 (x2, 
E_VNx16QImode, 
E_VNx4BImode, 
E_VNx4SImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern264 (x2, 
E_VNx8HImode, 
E_VNx2BImode, 
E_VNx2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern275 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_ldff1_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern278 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 0;

    case E_VNx1TImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern281 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern285 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern287 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern289 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !aarch64_plus_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern293 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern305 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  return pattern304 (); /* [-1, 2] */
}

int
pattern308 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              return pattern305 (x1, 
E_SImode); /* [-1, 2] */

            case E_DImode:
              res = pattern305 (x1, 
E_DImode);
              if (res >= 0)
                return res + 3; /* [3, 5] */
              return -1;

            default:
              return -1;
            }

        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern306 (x1, 
E_V8HImode, 
E_V8QImode) != 0)
                return -1;
              return 6;

            case E_V4SImode:
              if (pattern306 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
                return -1;
              return 7;

            case E_V2DImode:
              if (pattern306 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
                return -1;
              return 8;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern307 (x1, 
E_V8HImode, 
E_V16QImode, 
E_V8QImode) != 0)
            return -1;
          return 9;

        case E_V4SImode:
          if (pattern307 (x1, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0)
            return -1;
          return 10;

        case E_V2DImode:
          if (pattern307 (x1, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern328 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (XINT (x1, 1))
    {
    case 169:
      x2 = XVECEXP (x1, 0, 0);
      operands[2] = x2;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 307:
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[3] = x2;
      x4 = XVECEXP (x1, 0, 2);
      operands[2] = x4;
      res = pattern20 ();
      if (res >= 0)
        return res + 1; /* [1, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern337 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern349 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern348 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern348 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern348 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern348 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 31)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 66
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x9, 1);
  operands[2] = x11;
  x12 = XVECEXP (x3, 0, 2);
  operands[3] = x12;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x13 = XEXP (x6, 0);
  operands[4] = x13;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return pattern359 (x1); /* [-1, 3] */
}

int
pattern369 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern368 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern368 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern374 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern383 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!aarch64_imm3 (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern382 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern382 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern385 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern390 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_shift_imm_si (operands[1], E_QImode)
          || !aarch64_reg_or_zero (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_shift_imm_di (operands[1], E_QImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern395 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern400 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern404 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern408 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern412 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern416 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern417 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern416 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern416 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern416 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return 3;

        case E_V8HImode:
          return 4;

        case E_V4SImode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern430 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern436 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V8QImode))
    return -1;
  return 0;
}

int
pattern441 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_int_rnd_operand (operands[4], i2)
      || !aarch64_simd_shift_imm_vec_si (operands[3], i1)
      || !register_operand (operands[1], E_V2SImode))
    return -1;
  return 0;
}

int
pattern448 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern34 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern34 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern34 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern34 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern34 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern34 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern34 (x1, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_HImode:
      if (pattern34 (x1, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_QImode:
      if (pattern34 (x1, 
E_QImode) != 0)
        return -1;
      return 8;

    case E_SImode:
      if (pattern444 (x1, pnum_clobbers, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_DImode:
      if (pattern444 (x1, pnum_clobbers, 
E_DImode) != 0)
        return -1;
      return 10;

    case E_VNx16QImode:
      if (pattern447 (x1, 
E_VNx16QImode) != 0)
        return -1;
      return 11;

    case E_VNx8HImode:
      if (pattern447 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 12;

    case E_VNx4SImode:
      if (pattern447 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 13;

    case E_VNx2DImode:
      if (pattern447 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern466 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V4HImode:
          return pattern465 (x2, 
E_V8HImode, 
E_V4HImode, 
E_V8QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern465 (x2, 
E_V16HImode, 
E_V8HImode, 
E_V16QImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V2SImode:
          if (pattern465 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V4HImode) != 0)
            return -1;
          return 2;

        case E_V4SImode:
          if (pattern465 (x2, 
E_V8SImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V2DImode:
          if (pattern465 (x2, 
E_V4DImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 4;

        case E_DImode:
          if (pattern465 (x2, 
E_V2DImode, 
E_DImode, 
E_V2SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern478 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx2QImode:
      if (!aarch64_gather_scale_operand_b (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[8], E_VNx2QImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (!aarch64_gather_scale_operand_h (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[8], E_VNx2HImode))
        return -1;
      return 1;

    case E_VNx2SImode:
      if (!aarch64_gather_scale_operand_w (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[8], E_VNx2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern488 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 4
      || XINT (x1, 1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern492 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern491 (x1, 
E_SImode); /* [-1, 3] */

    case E_DImode:
      res = pattern491 (x1, 
E_DImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern499 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[1], E_VNx16QImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[1], E_VNx8HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern510 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x3, 1);
  if (!rtx_equal_p (x8, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern509 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern509 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern509 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern509 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern509 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern509 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern521 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern530 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern535 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern540 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern539 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern539 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern539 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern549 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return pattern542 (x1); /* [-1, 2] */

    case PLUS:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != i1)
        return -1;
      x7 = XEXP (x1, 0);
      operands[4] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      x9 = XEXP (x5, 1);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern544 (x1, 
E_V8HImode, 
E_V8SImode) != 0)
            return -1;
          return 3;

        case E_V8HImode:
          if (pattern546 (x1, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern548 (x1, 
E_V2DImode, 
E_V2TImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern561 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case TRUNCATE:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != i1)
        return -1;
      x4 = XEXP (x1, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      if (!rtx_equal_p (x7, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern560 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern560 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern560 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
      res = pattern434 (x1);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case REG:
    case SUBREG:
      res = pattern435 (x1);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern579 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i5
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i4
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i3
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  return pattern578 (x8, 
i1, 
i2, 
CLOBBER); /* [-1, 0] */
}

int
pattern587 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !nonmemory_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !aarch64_reg_or_zero (operands[1], E_QImode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !aarch64_reg_or_zero (operands[1], E_HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern600 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern606 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x3))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x3))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_DImode:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x3))
        {
        case E_V4DImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 4;

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern620 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i4))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern625 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern631 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern638 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern644 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i5
      || !register_operand (operands[1], i4)
      || !vect_par_cnst_hi_half (operands[3], i4))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern654 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 2);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern663 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern669 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      return pattern668 (x1); /* [-1, 2] */

    case PLUS:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != i1)
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x5, 1);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x1) != E_V16QImode
              || !register_operand (operands[1], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || GET_MODE (x3) != E_V8SImode
              || GET_MODE (x5) != E_V8SImode
              || GET_MODE (x6) != E_V8SImode
              || !register_operand (operands[2], E_V8HImode)
              || !aarch64_int_rnd_operand (operands[4], E_V8SImode)
              || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode))
            return -1;
          return 3;

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || !register_operand (operands[1], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || GET_MODE (x3) != E_V4DImode
              || GET_MODE (x5) != E_V4DImode
              || GET_MODE (x6) != E_V4DImode
              || !register_operand (operands[2], E_V4SImode)
              || !aarch64_int_rnd_operand (operands[4], E_V4DImode)
              || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode))
            return -1;
          return 4;

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !register_operand (operands[1], E_V2SImode)
              || GET_MODE (x2) != E_V2SImode
              || GET_MODE (x3) != E_V2TImode
              || GET_MODE (x5) != E_V2TImode
              || GET_MODE (x6) != E_V2TImode
              || !register_operand (operands[2], E_V2DImode)
              || !aarch64_int_rnd_operand (operands[4], E_V2TImode)
              || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern691 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !aarch64_imm24 (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (x1))
        {
        case E_SImode:
          return 0;

        case E_DImode:
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !aarch64_imm24 (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (x1))
        {
        case E_SImode:
          return 2;

        case E_DImode:
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern703 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern707 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern712 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern718 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_vsm_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern721 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern720 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern720 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern720 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern720 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern720 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern720 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern720 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern720 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern720 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern720 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    case E_V2DImode:
      if (pattern720 (x1, 
E_V2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern732 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern738 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern743 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || !aarch64_fp_compare_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !aarch64_fp_compare_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || !aarch64_fp_compare_operand (operands[1], E_DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern754 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern760 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_imm_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern766 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern765 (x1, 
E_V4HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern765 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern773 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern780 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern784 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CC_Zmode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 66
      || GET_MODE (x7) != E_CC_Zmode
      || !register_operand (operands[0], E_DImode))
    return -1;
  return 0;
}

int
pattern796 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern804 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[3], i3)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern812 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_carry_operation (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern817 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern760 (x1, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern760 (x1, 
E_V16HImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern760 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern760 (x1, 
E_V8SImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern760 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern760 (x1, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern835 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_and_imm (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern841 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern848 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 126)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x5) != EQ)
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[5] = x6;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  x8 = XEXP (x5, 1);
  operands[3] = x8;
  x9 = XVECEXP (x2, 0, 1);
  operands[4] = x9;
  x10 = XVECEXP (x2, 0, 2);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern847 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern847 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern847 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern847 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern847 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern847 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern847 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern847 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern847 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern847 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern874 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern880 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!aarch64_sync_memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!aarch64_sync_memory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!aarch64_sync_memory_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern885 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[4], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern887 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern886 (x1, 
E_V8HImode, 
E_V16QImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern886 (x1, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern886 (x1, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern897 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern902 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern906 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern912 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_imm_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern923 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 2);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || GET_MODE (x2) != E_VNx16BImode
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx16QImode)
          || !register_operand (operands[1], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || GET_MODE (x2) != E_VNx8BImode
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || GET_MODE (x2) != E_VNx4BImode
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || GET_MODE (x2) != E_VNx2BImode
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern965 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern971 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern976 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 2);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return pattern359 (x1); /* [-1, 3] */
}

int
pattern981 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern986 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern565 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern565 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern992 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern996 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_lshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1002 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4BFmode:
      if (!register_operand (operands[3], E_V4BFmode))
        return -1;
      return 0;

    case E_V8BFmode:
      if (!register_operand (operands[3], E_V8BFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1009 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1015 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_imm_zero (operands[2], i1)
      || !aarch64_simd_imm_minus_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1024 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SImode
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || GET_MODE (x2) != E_V2SImode
      || !register_operand (operands[2], E_V8QImode)
      || !immediate_operand (operands[4], E_SImode)
      || !register_operand (operands[1], E_V2SImode)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SImode))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1031 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1040 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1038 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1038 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1038 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1038 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          if (pattern1039 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx8HFmode:
          if (pattern1039 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 5;

        case E_VNx4SFmode:
          if (pattern1039 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 6;

        case E_VNx2DFmode:
          if (pattern1039 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1064 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4DImode:
      if (!aligned_register_operand (operands[0], E_VNx4DImode)
          || GET_MODE (x1) != E_VNx4DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx4DImode)
        return -1;
      return 0;

    case E_VNx8DImode:
      if (!aligned_register_operand (operands[0], E_VNx8DImode)
          || GET_MODE (x1) != E_VNx8DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx8DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1074 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SFmode
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1083 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1089 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1099 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  if (XVECLEN (x4, 0) != 3)
    return -1;
  switch (XINT (x4, 1))
    {
    case 140:
      return pattern1097 (x1, 
140); /* [-1, 7] */

    case 141:
      res = pattern1097 (x1, 
141);
      if (res >= 0)
        return res + 8; /* [8, 15] */
      return -1;

    case 142:
      res = pattern1097 (x1, 
142);
      if (res >= 0)
        return res + 16; /* [16, 23] */
      return -1;

    case 143:
      res = pattern1097 (x1, 
143);
      if (res >= 0)
        return res + 24; /* [24, 31] */
      return -1;

    case 136:
      res = pattern1097 (x1, 
136);
      if (res >= 0)
        return res + 32; /* [32, 39] */
      return -1;

    case 137:
      res = pattern1097 (x1, 
137);
      if (res >= 0)
        return res + 40; /* [40, 47] */
      return -1;

    case 138:
      res = pattern1097 (x1, 
138);
      if (res >= 0)
        return res + 48; /* [48, 55] */
      return -1;

    case 139:
      res = pattern1097 (x1, 
139);
      if (res >= 0)
        return res + 56; /* [56, 63] */
      return -1;

    case 144:
      res = pattern1097 (x1, 
144);
      if (res >= 0)
        return res + 64; /* [64, 71] */
      return -1;

    case 145:
      res = pattern1097 (x1, 
145);
      if (res >= 0)
        return res + 72; /* [72, 79] */
      return -1;

    case 302:
      if (GET_MODE (x4) != E_VNx16BImode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[4] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_VNx16BImode))
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      operands[3] = x9;
      if (!register_operand (operands[3], E_VNx16BImode))
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      res = pattern1098 (x10, 
302);
      if (res >= 0)
        return res + 80; /* [80, 81] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern849 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 2] */

    case E_VNx4SImode:
      res = pattern849 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DImode:
      res = pattern849 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1132 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125
      || GET_MODE (x1) != E_VNx2DImode
      || !register_operand (operands[5], E_VNx2BImode))
    return -1;
  return 0;
}

int
pattern1138 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !vect_par_cnst_even_or_odd_half (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1146 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1153 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i5
      || !register_operand (operands[1], i4)
      || !vect_par_cnst_hi_half (operands[3], i4))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1166 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !aarch64_reg_or_fp_zero (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !aarch64_reg_or_fp_zero (operands[3], i1))
    return -1;
  operands[5] = x1;
  if (!aarch64_reg_or_fp_zero (operands[5], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  operands[6] = x3;
  if (!memory_operand (operands[6], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[7] = x4;
  if (!aarch64_reg_or_fp_zero (operands[7], i1))
    return -1;
  return 0;
}

int
pattern1180 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1184 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || !register_operand (operands[1], E_VNx16BImode)
          || GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[3], E_VNx16QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode)
          || GET_MODE (x2) != E_VNx8BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[3], E_VNx8QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[3], E_VNx8HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode)
          || GET_MODE (x2) != E_VNx4BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[3], E_VNx4QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[3], E_VNx4HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[3], E_VNx4SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode)
          || GET_MODE (x2) != E_VNx2BImode)
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[3], E_VNx2QImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[3], E_VNx2HImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[3], E_VNx2SImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[3], E_VNx2DImode)
              || !aarch64_sve_cmp_vsc_operand (operands[4], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x1) != E_VNx16QImode)
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode)
        return -1;
      return 2;

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x1) != E_VNx8BFmode)
        return -1;
      return 3;

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x1) != E_VNx8HFmode)
        return -1;
      return 4;

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x1) != E_VNx4SFmode)
        return -1;
      return 5;

    case E_VNx32QImode:
      if (!aligned_register_operand (operands[0], E_VNx32QImode)
          || GET_MODE (x1) != E_VNx32QImode)
        return -1;
      return 6;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[0], E_VNx16HImode)
          || GET_MODE (x1) != E_VNx16HImode)
        return -1;
      return 7;

    case E_VNx8SImode:
      if (!aligned_register_operand (operands[0], E_VNx8SImode)
          || GET_MODE (x1) != E_VNx8SImode)
        return -1;
      return 8;

    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[0], E_VNx16BFmode)
          || GET_MODE (x1) != E_VNx16BFmode)
        return -1;
      return 9;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[0], E_VNx16HFmode)
          || GET_MODE (x1) != E_VNx16HFmode)
        return -1;
      return 10;

    case E_VNx8SFmode:
      if (!aligned_register_operand (operands[0], E_VNx8SFmode)
          || GET_MODE (x1) != E_VNx8SFmode)
        return -1;
      return 11;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[0], E_VNx64QImode)
          || GET_MODE (x1) != E_VNx64QImode)
        return -1;
      return 12;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[0], E_VNx32HImode)
          || GET_MODE (x1) != E_VNx32HImode)
        return -1;
      return 13;

    case E_VNx16SImode:
      if (!aligned_register_operand (operands[0], E_VNx16SImode)
          || GET_MODE (x1) != E_VNx16SImode)
        return -1;
      return 14;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[0], E_VNx32BFmode)
          || GET_MODE (x1) != E_VNx32BFmode)
        return -1;
      return 15;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[0], E_VNx32HFmode)
          || GET_MODE (x1) != E_VNx32HFmode)
        return -1;
      return 16;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x1) != E_VNx16SFmode)
        return -1;
      return 17;

    default:
      return -1;
    }
}

int
pattern1266 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern1273 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[3] = x5;
  x6 = XVECEXP (x3, 0, 3);
  x7 = XVECEXP (x6, 0, 0);
  operands[4] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[5] = x8;
  return pattern1247 (x1, 
i1); /* [-1, 7] */
}

int
pattern1279 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  if (!scratch_operand (operands[5], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  switch (GET_CODE (x7))
    {
    case PLUS:
      return pattern1275 (x6); /* [-1, 3] */

    case MINUS:
      res = pattern1275 (x6);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case IOR:
      res = pattern1277 (x6);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case XOR:
      res = pattern1277 (x6);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    case AND:
      res = pattern1277 (x6);
      if (res >= 0)
        return res + 16; /* [16, 19] */
      return -1;

    case NOT:
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != AND)
        return -1;
      x9 = XEXP (x8, 1);
      operands[2] = x9;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern1278 (x6, 
E_QImode) != 0)
            return -1;
          return 20;

        case E_HImode:
          if (pattern1278 (x6, 
E_HImode) != 0)
            return -1;
          return 21;

        case E_SImode:
          if (pattern1278 (x6, 
E_SImode) != 0)
            return -1;
          return 22;

        case E_DImode:
          if (pattern1278 (x6, 
E_DImode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1309 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx2SImode))
    return -1;
  return pattern1308 (x1); /* [-1, 7] */
}

int
pattern1315 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern1321 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V2SImode:
      if (!register_operand (operands[2], E_V2SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1329 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[2], E_VNx8HImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1336 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XVECEXP (x4, 0, 2);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case SET:
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != UNSPEC
          || XVECLEN (x9, 0) != 3
          || XINT (x9, 1) != 126)
        return -1;
      x10 = XVECEXP (x9, 0, 2);
      if (GET_CODE (x10) != i1)
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      x12 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x12, operands[6]))
        return -1;
      x13 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x13, operands[7]))
        return -1;
      x14 = XEXP (x10, 0);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XEXP (x10, 1);
      if (!rtx_equal_p (x15, operands[3]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (GET_MODE (x5) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx16QImode)
              || !register_operand (operands[0], E_VNx16BImode)
              || GET_MODE (x9) != E_VNx16BImode
              || GET_MODE (x10) != E_VNx16BImode)
            return -1;
          return 0;

        case E_VNx8BImode:
          if (GET_MODE (x5) != E_VNx8BImode
              || !register_operand (operands[0], E_VNx8BImode)
              || GET_MODE (x9) != E_VNx8BImode
              || GET_MODE (x10) != E_VNx8BImode)
            return -1;
          res = pattern1333 ();
          if (res >= 0)
            return res + 1; /* [1, 2] */
          return -1;

        case E_VNx4BImode:
          if (GET_MODE (x5) != E_VNx4BImode
              || !register_operand (operands[0], E_VNx4BImode)
              || GET_MODE (x9) != E_VNx4BImode
              || GET_MODE (x10) != E_VNx4BImode)
            return -1;
          res = pattern1334 ();
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        case E_VNx2BImode:
          if (GET_MODE (x5) != E_VNx2BImode
              || !register_operand (operands[0], E_VNx2BImode)
              || GET_MODE (x9) != E_VNx2BImode
              || GET_MODE (x10) != E_VNx2BImode)
            return -1;
          res = pattern1335 ();
          if (res >= 0)
            return res + 6; /* [6, 9] */
          return -1;

        default:
          return -1;
        }

    case CLOBBER:
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (GET_MODE (x5) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx16QImode)
              || !scratch_operand (operands[0], E_VNx16BImode))
            return -1;
          return 10;

        case E_VNx8BImode:
          if (GET_MODE (x5) != E_VNx8BImode
              || !scratch_operand (operands[0], E_VNx8BImode))
            return -1;
          res = pattern1333 ();
          if (res >= 0)
            return res + 11; /* [11, 12] */
          return -1;

        case E_VNx4BImode:
          if (GET_MODE (x5) != E_VNx4BImode
              || !scratch_operand (operands[0], E_VNx4BImode))
            return -1;
          res = pattern1334 ();
          if (res >= 0)
            return res + 13; /* [13, 15] */
          return -1;

        case E_VNx2BImode:
          if (GET_MODE (x5) != E_VNx2BImode
              || !scratch_operand (operands[0], E_VNx2BImode))
            return -1;
          res = pattern1335 ();
          if (res >= 0)
            return res + 16; /* [16, 19] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  switch (pattern938 (x2))
    {
    case 0:
      if (!
#line 6702 "../../gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (SImode, UINTVAL (operands[2]),
				      UINTVAL (operands[4]),
				      HOST_WIDE_INT_M1U << UINTVAL (operands[4]) )))
        return -1;
      return 896; /* *aarch64_bfisi4_noand */

    case 1:
      if (!
#line 6702 "../../gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (DImode, UINTVAL (operands[2]),
				      UINTVAL (operands[4]),
				      HOST_WIDE_INT_M1U << UINTVAL (operands[4]) )))
        return -1;
      return 897; /* *aarch64_bfidi4_noand */

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x8QImode:
      if (!register_operand (operands[0], E_V3x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8QImode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4686; /* aarch64_ld1_x3_v8qi */

    case E_V3x4HImode:
      if (!register_operand (operands[0], E_V3x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4HImode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4687; /* aarch64_ld1_x3_v4hi */

    case E_V3x2SImode:
      if (!register_operand (operands[0], E_V3x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2SImode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4688; /* aarch64_ld1_x3_v2si */

    case E_V3x1DImode:
      if (!register_operand (operands[0], E_V3x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x1DImode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4689; /* aarch64_ld1_x3_di */

    case E_V3x4HFmode:
      if (!register_operand (operands[0], E_V3x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4HFmode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4690; /* aarch64_ld1_x3_v4hf */

    case E_V3x2SFmode:
      if (!register_operand (operands[0], E_V3x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2SFmode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4691; /* aarch64_ld1_x3_v2sf */

    case E_V3x1DFmode:
      if (!register_operand (operands[0], E_V3x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x1DFmode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4692; /* aarch64_ld1_x3_df */

    case E_V3x4BFmode:
      if (!register_operand (operands[0], E_V3x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4BFmode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4693; /* aarch64_ld1_x3_v4bf */

    case E_V3x16QImode:
      if (!register_operand (operands[0], E_V3x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x16QImode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4694; /* aarch64_ld1_x3_v16qi */

    case E_V3x8HImode:
      if (!register_operand (operands[0], E_V3x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8HImode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4695; /* aarch64_ld1_x3_v8hi */

    case E_V3x4SImode:
      if (!register_operand (operands[0], E_V3x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4SImode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4696; /* aarch64_ld1_x3_v4si */

    case E_V3x2DImode:
      if (!register_operand (operands[0], E_V3x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2DImode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4697; /* aarch64_ld1_x3_v2di */

    case E_V3x8HFmode:
      if (!register_operand (operands[0], E_V3x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8HFmode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4698; /* aarch64_ld1_x3_v8hf */

    case E_V3x4SFmode:
      if (!register_operand (operands[0], E_V3x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4SFmode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4699; /* aarch64_ld1_x3_v4sf */

    case E_V3x2DFmode:
      if (!register_operand (operands[0], E_V3x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2DFmode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4700; /* aarch64_ld1_x3_v2df */

    case E_V3x8BFmode:
      if (!register_operand (operands[0], E_V3x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8BFmode)
          || !
#line 8056 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4701; /* aarch64_ld1_x3_v8bf */

    case E_V4x8QImode:
      if (!register_operand (operands[0], E_V4x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8QImode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4702; /* aarch64_ld1_x4_v8qi */

    case E_V4x4HImode:
      if (!register_operand (operands[0], E_V4x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4HImode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4703; /* aarch64_ld1_x4_v4hi */

    case E_V4x2SImode:
      if (!register_operand (operands[0], E_V4x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2SImode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4704; /* aarch64_ld1_x4_v2si */

    case E_V4x1DImode:
      if (!register_operand (operands[0], E_V4x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x1DImode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4705; /* aarch64_ld1_x4_di */

    case E_V4x4HFmode:
      if (!register_operand (operands[0], E_V4x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4HFmode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4706; /* aarch64_ld1_x4_v4hf */

    case E_V4x2SFmode:
      if (!register_operand (operands[0], E_V4x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2SFmode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4707; /* aarch64_ld1_x4_v2sf */

    case E_V4x1DFmode:
      if (!register_operand (operands[0], E_V4x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x1DFmode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4708; /* aarch64_ld1_x4_df */

    case E_V4x4BFmode:
      if (!register_operand (operands[0], E_V4x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4BFmode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4709; /* aarch64_ld1_x4_v4bf */

    case E_V4x16QImode:
      if (!register_operand (operands[0], E_V4x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x16QImode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4710; /* aarch64_ld1_x4_v16qi */

    case E_V4x8HImode:
      if (!register_operand (operands[0], E_V4x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8HImode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4711; /* aarch64_ld1_x4_v8hi */

    case E_V4x4SImode:
      if (!register_operand (operands[0], E_V4x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4SImode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4712; /* aarch64_ld1_x4_v4si */

    case E_V4x2DImode:
      if (!register_operand (operands[0], E_V4x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2DImode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4713; /* aarch64_ld1_x4_v2di */

    case E_V4x8HFmode:
      if (!register_operand (operands[0], E_V4x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8HFmode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4714; /* aarch64_ld1_x4_v8hf */

    case E_V4x4SFmode:
      if (!register_operand (operands[0], E_V4x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4SFmode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4715; /* aarch64_ld1_x4_v4sf */

    case E_V4x2DFmode:
      if (!register_operand (operands[0], E_V4x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2DFmode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4716; /* aarch64_ld1_x4_v2df */

    case E_V4x8BFmode:
      if (!register_operand (operands[0], E_V4x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8BFmode)
          || !
#line 8076 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4717; /* aarch64_ld1_x4_v8bf */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V8QImode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4767; /* aarch64_be_ld1v8qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V16QImode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4768; /* aarch64_be_ld1v16qi */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V4HImode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4769; /* aarch64_be_ld1v4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V8HImode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4770; /* aarch64_be_ld1v8hi */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2SImode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4771; /* aarch64_be_ld1v2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V4SImode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4772; /* aarch64_be_ld1v4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2DImode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4773; /* aarch64_be_ld1v2di */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4HFmode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4774; /* aarch64_be_ld1v4hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V8HFmode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4775; /* aarch64_be_ld1v8hf */

    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4BFmode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4776; /* aarch64_be_ld1v4bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V8BFmode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4777; /* aarch64_be_ld1v8bf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2SFmode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4778; /* aarch64_be_ld1v2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4SFmode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4779; /* aarch64_be_ld1v4sf */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2DFmode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4780; /* aarch64_be_ld1v2df */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !aarch64_simd_struct_operand (operands[1], E_DImode)
          || !
#line 8156 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4781; /* aarch64_be_ld1di */

    case E_V2x8QImode:
      if (!register_operand (operands[0], E_V2x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8QImode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5183; /* aarch64_simd_ld1v8qi_x2 */

    case E_V2x4HImode:
      if (!register_operand (operands[0], E_V2x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HImode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5184; /* aarch64_simd_ld1v4hi_x2 */

    case E_V2x2SImode:
      if (!register_operand (operands[0], E_V2x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SImode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5185; /* aarch64_simd_ld1v2si_x2 */

    case E_V2x1DImode:
      if (!register_operand (operands[0], E_V2x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DImode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5186; /* aarch64_simd_ld1di_x2 */

    case E_V2x4HFmode:
      if (!register_operand (operands[0], E_V2x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HFmode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5187; /* aarch64_simd_ld1v4hf_x2 */

    case E_V2x2SFmode:
      if (!register_operand (operands[0], E_V2x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SFmode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5188; /* aarch64_simd_ld1v2sf_x2 */

    case E_V2x1DFmode:
      if (!register_operand (operands[0], E_V2x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DFmode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5189; /* aarch64_simd_ld1df_x2 */

    case E_V2x4BFmode:
      if (!register_operand (operands[0], E_V2x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4BFmode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5190; /* aarch64_simd_ld1v4bf_x2 */

    case E_V2x16QImode:
      if (!register_operand (operands[0], E_V2x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x16QImode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5191; /* aarch64_simd_ld1v16qi_x2 */

    case E_V2x8HImode:
      if (!register_operand (operands[0], E_V2x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8HImode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5192; /* aarch64_simd_ld1v8hi_x2 */

    case E_V2x4SImode:
      if (!register_operand (operands[0], E_V2x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4SImode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5193; /* aarch64_simd_ld1v4si_x2 */

    case E_V2x2DImode:
      if (!register_operand (operands[0], E_V2x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2DImode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5194; /* aarch64_simd_ld1v2di_x2 */

    case E_V2x8HFmode:
      if (!register_operand (operands[0], E_V2x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8HFmode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5195; /* aarch64_simd_ld1v8hf_x2 */

    case E_V2x4SFmode:
      if (!register_operand (operands[0], E_V2x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4SFmode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5196; /* aarch64_simd_ld1v4sf_x2 */

    case E_V2x2DFmode:
      if (!register_operand (operands[0], E_V2x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2DFmode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5197; /* aarch64_simd_ld1v2df_x2 */

    case E_V2x8BFmode:
      if (!register_operand (operands[0], E_V2x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8BFmode)
          || !
#line 8877 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5198; /* aarch64_simd_ld1v8bf_x2 */

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern715 (x2))
    {
    case 0:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6635; /* aarch64_pred_popcountvnx16qi */

    case 1:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6644; /* aarch64_pred_popcountvnx8qi */

    case 2:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6653; /* aarch64_pred_popcountvnx4qi */

    case 3:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6662; /* aarch64_pred_popcountvnx2qi */

    case 4:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6671; /* aarch64_pred_popcountvnx8hi */

    case 5:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6680; /* aarch64_pred_popcountvnx4hi */

    case 6:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6689; /* aarch64_pred_popcountvnx2hi */

    case 7:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6698; /* aarch64_pred_popcountvnx4si */

    case 8:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6707; /* aarch64_pred_popcountvnx2si */

    case 9:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6716; /* aarch64_pred_popcountvnx2di */

    case 10:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6725; /* aarch64_pred_popcountv8qi */

    case 11:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6734; /* aarch64_pred_popcountv16qi */

    case 12:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6743; /* aarch64_pred_popcountv4hi */

    case 13:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6752; /* aarch64_pred_popcountv8hi */

    case 14:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6761; /* aarch64_pred_popcountv2si */

    case 15:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6770; /* aarch64_pred_popcountv4si */

    case 16:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6779; /* aarch64_pred_popcountv2di */

    case 17:
      if (!
#line 3254 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6788; /* aarch64_pred_popcountv1di */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern481 (x2))
    {
    case 0:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
        return -1;
      return 5842; /* aarch64_load_extendvnx8hivnx8qi */

    case 1:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
        return -1;
      return 5844; /* aarch64_load_extendvnx8hivnx4qi */

    case 2:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
        return -1;
      return 5846; /* aarch64_load_extendvnx8hivnx2qi */

    case 3:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
        return -1;
      return 5848; /* aarch64_load_extendvnx8hivnx4hi */

    case 4:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
        return -1;
      return 5850; /* aarch64_load_extendvnx8hivnx2hi */

    case 5:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
        return -1;
      return 5852; /* aarch64_load_extendvnx8hivnx2si */

    case 6:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
        return -1;
      return 5854; /* aarch64_load_extendvnx4hivnx8qi */

    case 7:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
        return -1;
      return 5856; /* aarch64_load_extendvnx4hivnx4qi */

    case 8:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
        return -1;
      return 5858; /* aarch64_load_extendvnx4hivnx2qi */

    case 9:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
        return -1;
      return 5860; /* aarch64_load_extendvnx4hivnx4hi */

    case 10:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
        return -1;
      return 5862; /* aarch64_load_extendvnx4hivnx2hi */

    case 11:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
        return -1;
      return 5864; /* aarch64_load_extendvnx4hivnx2si */

    case 12:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
        return -1;
      return 5866; /* aarch64_load_extendvnx2hivnx8qi */

    case 13:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
        return -1;
      return 5868; /* aarch64_load_extendvnx2hivnx4qi */

    case 14:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
        return -1;
      return 5870; /* aarch64_load_extendvnx2hivnx2qi */

    case 15:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
        return -1;
      return 5872; /* aarch64_load_extendvnx2hivnx4hi */

    case 16:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
        return -1;
      return 5874; /* aarch64_load_extendvnx2hivnx2hi */

    case 17:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
        return -1;
      return 5876; /* aarch64_load_extendvnx2hivnx2si */

    case 18:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
        return -1;
      return 5878; /* aarch64_load_extendvnx4sivnx8qi */

    case 19:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
        return -1;
      return 5880; /* aarch64_load_extendvnx4sivnx4qi */

    case 20:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
        return -1;
      return 5882; /* aarch64_load_extendvnx4sivnx2qi */

    case 21:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
        return -1;
      return 5884; /* aarch64_load_extendvnx4sivnx4hi */

    case 22:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
        return -1;
      return 5886; /* aarch64_load_extendvnx4sivnx2hi */

    case 23:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
        return -1;
      return 5888; /* aarch64_load_extendvnx4sivnx2si */

    case 24:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
        return -1;
      return 5890; /* aarch64_load_extendvnx2sivnx8qi */

    case 25:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
        return -1;
      return 5892; /* aarch64_load_extendvnx2sivnx4qi */

    case 26:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
        return -1;
      return 5894; /* aarch64_load_extendvnx2sivnx2qi */

    case 27:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
        return -1;
      return 5896; /* aarch64_load_extendvnx2sivnx4hi */

    case 28:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
        return -1;
      return 5898; /* aarch64_load_extendvnx2sivnx2hi */

    case 29:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
        return -1;
      return 5900; /* aarch64_load_extendvnx2sivnx2si */

    case 30:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
        return -1;
      return 5902; /* aarch64_load_extendvnx2divnx8qi */

    case 31:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
        return -1;
      return 5904; /* aarch64_load_extendvnx2divnx4qi */

    case 32:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
        return -1;
      return 5906; /* aarch64_load_extendvnx2divnx2qi */

    case 33:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
        return -1;
      return 5908; /* aarch64_load_extendvnx2divnx4hi */

    case 34:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
        return -1;
      return 5910; /* aarch64_load_extendvnx2divnx2hi */

    case 35:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
        return -1;
      return 5912; /* aarch64_load_extendvnx2divnx2si */

    case 36:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0))
        return -1;
      return 6002; /* aarch64_ldff1_extendvnx8hivnx8qi */

    case 37:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0))
        return -1;
      return 6006; /* aarch64_ldff1_extendvnx8hivnx4qi */

    case 38:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0))
        return -1;
      return 6010; /* aarch64_ldff1_extendvnx8hivnx2qi */

    case 39:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0))
        return -1;
      return 6014; /* aarch64_ldff1_extendvnx8hivnx4hi */

    case 40:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0))
        return -1;
      return 6018; /* aarch64_ldff1_extendvnx8hivnx2hi */

    case 41:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0))
        return -1;
      return 6022; /* aarch64_ldff1_extendvnx8hivnx2si */

    case 42:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0))
        return -1;
      return 6026; /* aarch64_ldff1_extendvnx4hivnx8qi */

    case 43:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 6030; /* aarch64_ldff1_extendvnx4hivnx4qi */

    case 44:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0))
        return -1;
      return 6034; /* aarch64_ldff1_extendvnx4hivnx2qi */

    case 45:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 6038; /* aarch64_ldff1_extendvnx4hivnx4hi */

    case 46:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0))
        return -1;
      return 6042; /* aarch64_ldff1_extendvnx4hivnx2hi */

    case 47:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0))
        return -1;
      return 6046; /* aarch64_ldff1_extendvnx4hivnx2si */

    case 48:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0))
        return -1;
      return 6050; /* aarch64_ldff1_extendvnx2hivnx8qi */

    case 49:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0))
        return -1;
      return 6054; /* aarch64_ldff1_extendvnx2hivnx4qi */

    case 50:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6058; /* aarch64_ldff1_extendvnx2hivnx2qi */

    case 51:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0))
        return -1;
      return 6062; /* aarch64_ldff1_extendvnx2hivnx4hi */

    case 52:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6066; /* aarch64_ldff1_extendvnx2hivnx2hi */

    case 53:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6070; /* aarch64_ldff1_extendvnx2hivnx2si */

    case 54:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 6074; /* aarch64_ldff1_extendvnx4sivnx8qi */

    case 55:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6078; /* aarch64_ldff1_extendvnx4sivnx4qi */

    case 56:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 6082; /* aarch64_ldff1_extendvnx4sivnx2qi */

    case 57:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6086; /* aarch64_ldff1_extendvnx4sivnx4hi */

    case 58:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 6090; /* aarch64_ldff1_extendvnx4sivnx2hi */

    case 59:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 6094; /* aarch64_ldff1_extendvnx4sivnx2si */

    case 60:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0))
        return -1;
      return 6098; /* aarch64_ldff1_extendvnx2sivnx8qi */

    case 61:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0))
        return -1;
      return 6102; /* aarch64_ldff1_extendvnx2sivnx4qi */

    case 62:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6106; /* aarch64_ldff1_extendvnx2sivnx2qi */

    case 63:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0))
        return -1;
      return 6110; /* aarch64_ldff1_extendvnx2sivnx4hi */

    case 64:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6114; /* aarch64_ldff1_extendvnx2sivnx2hi */

    case 65:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6118; /* aarch64_ldff1_extendvnx2sivnx2si */

    case 66:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 6122; /* aarch64_ldff1_extendvnx2divnx8qi */

    case 67:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 6126; /* aarch64_ldff1_extendvnx2divnx4qi */

    case 68:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6130; /* aarch64_ldff1_extendvnx2divnx2qi */

    case 69:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 6134; /* aarch64_ldff1_extendvnx2divnx4hi */

    case 70:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6138; /* aarch64_ldff1_extendvnx2divnx2hi */

    case 71:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6142; /* aarch64_ldff1_extendvnx2divnx2si */

    case 72:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0))
        return -1;
      return 6003; /* aarch64_ldnf1_extendvnx8hivnx8qi */

    case 73:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0))
        return -1;
      return 6007; /* aarch64_ldnf1_extendvnx8hivnx4qi */

    case 74:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0))
        return -1;
      return 6011; /* aarch64_ldnf1_extendvnx8hivnx2qi */

    case 75:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0))
        return -1;
      return 6015; /* aarch64_ldnf1_extendvnx8hivnx4hi */

    case 76:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0))
        return -1;
      return 6019; /* aarch64_ldnf1_extendvnx8hivnx2hi */

    case 77:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0))
        return -1;
      return 6023; /* aarch64_ldnf1_extendvnx8hivnx2si */

    case 78:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0))
        return -1;
      return 6027; /* aarch64_ldnf1_extendvnx4hivnx8qi */

    case 79:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 6031; /* aarch64_ldnf1_extendvnx4hivnx4qi */

    case 80:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0))
        return -1;
      return 6035; /* aarch64_ldnf1_extendvnx4hivnx2qi */

    case 81:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 6039; /* aarch64_ldnf1_extendvnx4hivnx4hi */

    case 82:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0))
        return -1;
      return 6043; /* aarch64_ldnf1_extendvnx4hivnx2hi */

    case 83:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0))
        return -1;
      return 6047; /* aarch64_ldnf1_extendvnx4hivnx2si */

    case 84:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0))
        return -1;
      return 6051; /* aarch64_ldnf1_extendvnx2hivnx8qi */

    case 85:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0))
        return -1;
      return 6055; /* aarch64_ldnf1_extendvnx2hivnx4qi */

    case 86:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6059; /* aarch64_ldnf1_extendvnx2hivnx2qi */

    case 87:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0))
        return -1;
      return 6063; /* aarch64_ldnf1_extendvnx2hivnx4hi */

    case 88:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6067; /* aarch64_ldnf1_extendvnx2hivnx2hi */

    case 89:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6071; /* aarch64_ldnf1_extendvnx2hivnx2si */

    case 90:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 6075; /* aarch64_ldnf1_extendvnx4sivnx8qi */

    case 91:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6079; /* aarch64_ldnf1_extendvnx4sivnx4qi */

    case 92:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 6083; /* aarch64_ldnf1_extendvnx4sivnx2qi */

    case 93:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6087; /* aarch64_ldnf1_extendvnx4sivnx4hi */

    case 94:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 6091; /* aarch64_ldnf1_extendvnx4sivnx2hi */

    case 95:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 6095; /* aarch64_ldnf1_extendvnx4sivnx2si */

    case 96:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0))
        return -1;
      return 6099; /* aarch64_ldnf1_extendvnx2sivnx8qi */

    case 97:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0))
        return -1;
      return 6103; /* aarch64_ldnf1_extendvnx2sivnx4qi */

    case 98:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6107; /* aarch64_ldnf1_extendvnx2sivnx2qi */

    case 99:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0))
        return -1;
      return 6111; /* aarch64_ldnf1_extendvnx2sivnx4hi */

    case 100:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6115; /* aarch64_ldnf1_extendvnx2sivnx2hi */

    case 101:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6119; /* aarch64_ldnf1_extendvnx2sivnx2si */

    case 102:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 6123; /* aarch64_ldnf1_extendvnx2divnx8qi */

    case 103:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 6127; /* aarch64_ldnf1_extendvnx2divnx4qi */

    case 104:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6131; /* aarch64_ldnf1_extendvnx2divnx2qi */

    case 105:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 6135; /* aarch64_ldnf1_extendvnx2divnx4hi */

    case 106:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6139; /* aarch64_ldnf1_extendvnx2divnx2hi */

    case 107:
      if (!
#line 1471 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6143; /* aarch64_ldnf1_extendvnx2divnx2si */

    case 108:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
        return -1;
      return 5914; /* *aarch64_load_extend_movvnx8hivnx8qi */

    case 109:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
        return -1;
      return 5916; /* *aarch64_load_extend_movvnx8hivnx4qi */

    case 110:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
        return -1;
      return 5918; /* *aarch64_load_extend_movvnx8hivnx2qi */

    case 111:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
        return -1;
      return 5920; /* *aarch64_load_extend_movvnx8hivnx4hi */

    case 112:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
        return -1;
      return 5922; /* *aarch64_load_extend_movvnx8hivnx2hi */

    case 113:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
        return -1;
      return 5924; /* *aarch64_load_extend_movvnx8hivnx2si */

    case 114:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
        return -1;
      return 5926; /* *aarch64_load_extend_movvnx4hivnx8qi */

    case 115:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
        return -1;
      return 5928; /* *aarch64_load_extend_movvnx4hivnx4qi */

    case 116:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
        return -1;
      return 5930; /* *aarch64_load_extend_movvnx4hivnx2qi */

    case 117:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
        return -1;
      return 5932; /* *aarch64_load_extend_movvnx4hivnx4hi */

    case 118:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
        return -1;
      return 5934; /* *aarch64_load_extend_movvnx4hivnx2hi */

    case 119:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
        return -1;
      return 5936; /* *aarch64_load_extend_movvnx4hivnx2si */

    case 120:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
        return -1;
      return 5938; /* *aarch64_load_extend_movvnx2hivnx8qi */

    case 121:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
        return -1;
      return 5940; /* *aarch64_load_extend_movvnx2hivnx4qi */

    case 122:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
        return -1;
      return 5942; /* *aarch64_load_extend_movvnx2hivnx2qi */

    case 123:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
        return -1;
      return 5944; /* *aarch64_load_extend_movvnx2hivnx4hi */

    case 124:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
        return -1;
      return 5946; /* *aarch64_load_extend_movvnx2hivnx2hi */

    case 125:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
        return -1;
      return 5948; /* *aarch64_load_extend_movvnx2hivnx2si */

    case 126:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
        return -1;
      return 5950; /* *aarch64_load_extend_movvnx4sivnx8qi */

    case 127:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
        return -1;
      return 5952; /* *aarch64_load_extend_movvnx4sivnx4qi */

    case 128:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
        return -1;
      return 5954; /* *aarch64_load_extend_movvnx4sivnx2qi */

    case 129:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
        return -1;
      return 5956; /* *aarch64_load_extend_movvnx4sivnx4hi */

    case 130:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
        return -1;
      return 5958; /* *aarch64_load_extend_movvnx4sivnx2hi */

    case 131:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
        return -1;
      return 5960; /* *aarch64_load_extend_movvnx4sivnx2si */

    case 132:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
        return -1;
      return 5962; /* *aarch64_load_extend_movvnx2sivnx8qi */

    case 133:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
        return -1;
      return 5964; /* *aarch64_load_extend_movvnx2sivnx4qi */

    case 134:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
        return -1;
      return 5966; /* *aarch64_load_extend_movvnx2sivnx2qi */

    case 135:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
        return -1;
      return 5968; /* *aarch64_load_extend_movvnx2sivnx4hi */

    case 136:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
        return -1;
      return 5970; /* *aarch64_load_extend_movvnx2sivnx2hi */

    case 137:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
        return -1;
      return 5972; /* *aarch64_load_extend_movvnx2sivnx2si */

    case 138:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
        return -1;
      return 5974; /* *aarch64_load_extend_movvnx2divnx8qi */

    case 139:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
        return -1;
      return 5976; /* *aarch64_load_extend_movvnx2divnx4qi */

    case 140:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
        return -1;
      return 5978; /* *aarch64_load_extend_movvnx2divnx2qi */

    case 141:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
        return -1;
      return 5980; /* *aarch64_load_extend_movvnx2divnx4hi */

    case 142:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
        return -1;
      return 5982; /* *aarch64_load_extend_movvnx2divnx2hi */

    case 143:
      if (!
#line 1407 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
        return -1;
      return 5984; /* *aarch64_load_extend_movvnx2divnx2si */

    case 144:
      if (!
#line 1699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 6200; /* aarch64_gather_load_extendvnx4hivnx4qi */

    case 145:
      if (!
#line 1699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 6204; /* aarch64_gather_load_extendvnx4hivnx4hi */

    case 146:
      if (!
#line 1699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6202; /* aarch64_gather_load_extendvnx4sivnx4qi */

    case 147:
      if (!
#line 1699 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6206; /* aarch64_gather_load_extendvnx4sivnx4hi */

    case 148:
      if (!
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6208; /* aarch64_gather_load_extendvnx2hivnx2qi */

    case 149:
      if (!
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6214; /* aarch64_gather_load_extendvnx2hivnx2hi */

    case 150:
      if (!
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6220; /* aarch64_gather_load_extendvnx2hivnx2si */

    case 151:
      if (!
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6210; /* aarch64_gather_load_extendvnx2sivnx2qi */

    case 152:
      if (!
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6216; /* aarch64_gather_load_extendvnx2sivnx2hi */

    case 153:
      if (!
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6222; /* aarch64_gather_load_extendvnx2sivnx2si */

    case 154:
      if (!
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6212; /* aarch64_gather_load_extendvnx2divnx2qi */

    case 155:
      if (!
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6218; /* aarch64_gather_load_extendvnx2divnx2hi */

    case 156:
      if (!
#line 1739 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6224; /* aarch64_gather_load_extendvnx2divnx2si */

    case 157:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6226; /* *aarch64_gather_load_extendvnx2hivnx2qi_sxtw_unpacked */

    case 158:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6238; /* *aarch64_gather_load_extendvnx2hivnx2hi_sxtw_unpacked */

    case 159:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6250; /* *aarch64_gather_load_extendvnx2hivnx2si_sxtw_unpacked */

    case 160:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6230; /* *aarch64_gather_load_extendvnx2sivnx2qi_sxtw_unpacked */

    case 161:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6242; /* *aarch64_gather_load_extendvnx2sivnx2hi_sxtw_unpacked */

    case 162:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6254; /* *aarch64_gather_load_extendvnx2sivnx2si_sxtw_unpacked */

    case 163:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6234; /* *aarch64_gather_load_extendvnx2divnx2qi_sxtw_unpacked */

    case 164:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6246; /* *aarch64_gather_load_extendvnx2divnx2hi_sxtw_unpacked */

    case 165:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6258; /* *aarch64_gather_load_extendvnx2divnx2si_sxtw_unpacked */

    case 166:
      if (!
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6262; /* *aarch64_gather_load_extendvnx2hivnx2qi_sxtw */

    case 167:
      if (!
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6268; /* *aarch64_gather_load_extendvnx2hivnx2hi_sxtw */

    case 168:
      if (!
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6274; /* *aarch64_gather_load_extendvnx2hivnx2si_sxtw */

    case 169:
      if (!
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6264; /* *aarch64_gather_load_extendvnx2sivnx2qi_sxtw */

    case 170:
      if (!
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6270; /* *aarch64_gather_load_extendvnx2sivnx2hi_sxtw */

    case 171:
      if (!
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6276; /* *aarch64_gather_load_extendvnx2sivnx2si_sxtw */

    case 172:
      if (!
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6266; /* *aarch64_gather_load_extendvnx2divnx2qi_sxtw */

    case 173:
      if (!
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6272; /* *aarch64_gather_load_extendvnx2divnx2hi_sxtw */

    case 174:
      if (!
#line 1816 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6278; /* *aarch64_gather_load_extendvnx2divnx2si_sxtw */

    case 175:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6228; /* *aarch64_gather_load_extendvnx2hivnx2qi_uxtw_unpacked */

    case 176:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6240; /* *aarch64_gather_load_extendvnx2hivnx2hi_uxtw_unpacked */

    case 177:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6252; /* *aarch64_gather_load_extendvnx2hivnx2si_uxtw_unpacked */

    case 178:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6232; /* *aarch64_gather_load_extendvnx2sivnx2qi_uxtw_unpacked */

    case 179:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6244; /* *aarch64_gather_load_extendvnx2sivnx2hi_uxtw_unpacked */

    case 180:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6256; /* *aarch64_gather_load_extendvnx2sivnx2si_uxtw_unpacked */

    case 181:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6236; /* *aarch64_gather_load_extendvnx2divnx2qi_uxtw_unpacked */

    case 182:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6248; /* *aarch64_gather_load_extendvnx2divnx2hi_uxtw_unpacked */

    case 183:
      if (!
#line 1778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6260; /* *aarch64_gather_load_extendvnx2divnx2si_uxtw_unpacked */

    case 184:
      if (!
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6280; /* *aarch64_gather_load_extendvnx2hivnx2qi_uxtw */

    case 185:
      if (!
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6286; /* *aarch64_gather_load_extendvnx2hivnx2hi_uxtw */

    case 186:
      if (!
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6292; /* *aarch64_gather_load_extendvnx2hivnx2si_uxtw */

    case 187:
      if (!
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6282; /* *aarch64_gather_load_extendvnx2sivnx2qi_uxtw */

    case 188:
      if (!
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6288; /* *aarch64_gather_load_extendvnx2sivnx2hi_uxtw */

    case 189:
      if (!
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6294; /* *aarch64_gather_load_extendvnx2sivnx2si_uxtw */

    case 190:
      if (!
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6284; /* *aarch64_gather_load_extendvnx2divnx2qi_uxtw */

    case 191:
      if (!
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6290; /* *aarch64_gather_load_extendvnx2divnx2hi_uxtw */

    case 192:
      if (!
#line 1851 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6296; /* *aarch64_gather_load_extendvnx2divnx2si_uxtw */

    case 193:
      if (!
#line 2088 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6316; /* *aarch64_ldff1_gather_extendvnx2divnx2qi_sxtw */

    case 194:
      if (!
#line 2088 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6318; /* *aarch64_ldff1_gather_extendvnx2divnx2hi_sxtw */

    case 195:
      if (!
#line 2088 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6320; /* *aarch64_ldff1_gather_extendvnx2divnx2si_sxtw */

    case 196:
      if (!
#line 2120 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6322; /* *aarch64_ldff1_gather_extendvnx2divnx2qi_uxtw */

    case 197:
      if (!
#line 2120 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6324; /* *aarch64_ldff1_gather_extendvnx2divnx2hi_uxtw */

    case 198:
      if (!
#line 2120 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6326; /* *aarch64_ldff1_gather_extendvnx2divnx2si_uxtw */

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern144 (x1))
    {
    case 0:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13080; /* aarch64_sve_zipqvnx32qi */

    case 1:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13082; /* aarch64_sve_zipqvnx16hi */

    case 2:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13084; /* aarch64_sve_zipqvnx8si */

    case 3:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13086; /* aarch64_sve_zipqvnx4di */

    case 4:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13088; /* aarch64_sve_zipqvnx16bf */

    case 5:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13090; /* aarch64_sve_zipqvnx16hf */

    case 6:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13092; /* aarch64_sve_zipqvnx8sf */

    case 7:
      if (!
#line 3878 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13094; /* aarch64_sve_zipqvnx4df */

    default:
      return -1;
    }
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern100 (x1))
    {
    case 0:
      if (!
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3690; /* aarch64_ushlv8qi */

    case 1:
      if (!
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3700; /* aarch64_ushlv16qi */

    case 2:
      if (!
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3706; /* aarch64_ushlv4hi */

    case 3:
      if (!
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3716; /* aarch64_ushlv8hi */

    case 4:
      if (!
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3722; /* aarch64_ushlv2si */

    case 5:
      if (!
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3732; /* aarch64_ushlv4si */

    case 6:
      if (!
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3736; /* aarch64_ushlv2di */

    case 7:
      if (!
#line 6557 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3742; /* aarch64_ushldi */

    default:
      return -1;
    }
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      return 1080; /* fcvtzusf3 */

    case 1:
      if (!
#line 7395 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1088; /* fcvtzuhfsi3 */

    case 2:
      return 1082; /* fcvtzudf3 */

    case 3:
      if (!
#line 7395 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1090; /* fcvtzuhfdi3 */

    case 4:
      if (!
#line 7415 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 1096; /* fcvtzuhf3 */

    case 5:
      if (!(
#line 3145 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2675; /* fcvtzuv4hf3 */

    case 6:
      if (!(
#line 3145 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2677; /* fcvtzuv8hf3 */

    case 7:
      if (!
#line 3145 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2679; /* fcvtzuv2sf3 */

    case 8:
      if (!
#line 3145 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2681; /* fcvtzuv4sf3 */

    case 9:
      if (!
#line 3145 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2683; /* fcvtzuv2df3 */

    default:
      return -1;
    }
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern129 (x1))
    {
    case 0:
      if (!
#line 2266 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12333; /* aarch64_sve_umullbvnx8hi */

    case 1:
      if (!
#line 2266 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12354; /* aarch64_sve_umullbvnx4si */

    case 2:
      if (!
#line 2266 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12375; /* aarch64_sve_umullbvnx2di */

    case 3:
      if (!
#line 2279 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12383; /* aarch64_sve_umullb_lane_vnx4si */

    case 4:
      if (!
#line 2279 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12389; /* aarch64_sve_umullb_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern135 (x1))
    {
    case 0:
      if (!
#line 3915 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 13129; /* aarch64_sve_bextvnx16qi */

    case 1:
      if (!
#line 3915 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 13132; /* aarch64_sve_bextvnx8hi */

    case 2:
      if (!
#line 3915 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 13135; /* aarch64_sve_bextvnx4si */

    case 3:
      if (!
#line 3915 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 13138; /* aarch64_sve_bextvnx2di */

    default:
      return -1;
    }
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern135 (x1))
    {
    case 0:
      if (!
#line 2977 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12742; /* aarch64_sve_sqcadd270vnx16qi */

    case 1:
      if (!
#line 2977 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12746; /* aarch64_sve_sqcadd270vnx8hi */

    case 2:
      if (!
#line 2977 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12750; /* aarch64_sve_sqcadd270vnx4si */

    case 3:
      if (!
#line 2977 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12754; /* aarch64_sve_sqcadd270vnx2di */

    default:
      return -1;
    }
}

 int
recog_191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern120 (x1))
    {
    case 0:
      if (!
#line 9108 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 8))
        return -1;
      return 10494; /* aarch64_pred_reduc_sadd_vnx16qi */

    case 1:
      if (!
#line 9108 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
        return -1;
      return 10496; /* aarch64_pred_reduc_sadd_vnx8hi */

    case 2:
      if (!
#line 9108 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
        return -1;
      return 10498; /* aarch64_pred_reduc_sadd_vnx4si */

    case 3:
      if (!
#line 9108 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
        return -1;
      return 10500; /* aarch64_pred_reduc_sadd_vnx2di */

    default:
      return -1;
    }
}

 int
recog_203 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1121 (x2))
        {
        case 0:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10995; /* *cond_fix_trunc_nontruncvnx8hfvnx8hi_relaxed */
          break;

        case 1:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10997; /* *cond_fix_trunc_nontruncvnx4sfvnx8hi_relaxed */
          break;

        case 2:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10999; /* *cond_fix_trunc_nontruncvnx2dfvnx8hi_relaxed */
          break;

        case 3:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 11001; /* *cond_fix_trunc_nontruncvnx8hfvnx4si_relaxed */
          break;

        case 4:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 11003; /* *cond_fix_trunc_nontruncvnx4sfvnx4si_relaxed */
          break;

        case 5:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 11005; /* *cond_fix_trunc_nontruncvnx2dfvnx4si_relaxed */
          break;

        case 6:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 11007; /* *cond_fix_trunc_nontruncvnx8hfvnx2di_relaxed */
          break;

        case 7:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 11009; /* *cond_fix_trunc_nontruncvnx4sfvnx2di_relaxed */
          break;

        case 8:
          if (
#line 9644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 11011; /* *cond_fix_trunc_nontruncvnx2dfvnx2di_relaxed */
          break;

        default:
          break;
        }
      break;

    case 1L:
      switch (pattern1122 (x2))
        {
        case 0:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 11013; /* *cond_fix_trunc_nontruncvnx8hfvnx8hi_strict */
          break;

        case 1:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 11015; /* *cond_fix_trunc_nontruncvnx4sfvnx8hi_strict */
          break;

        case 2:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 11017; /* *cond_fix_trunc_nontruncvnx2dfvnx8hi_strict */
          break;

        case 3:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 11019; /* *cond_fix_trunc_nontruncvnx8hfvnx4si_strict */
          break;

        case 4:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 11021; /* *cond_fix_trunc_nontruncvnx4sfvnx4si_strict */
          break;

        case 5:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 11023; /* *cond_fix_trunc_nontruncvnx2dfvnx4si_strict */
          break;

        case 6:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 11025; /* *cond_fix_trunc_nontruncvnx8hfvnx2di_strict */
          break;

        case 7:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 11027; /* *cond_fix_trunc_nontruncvnx4sfvnx2di_strict */
          break;

        case 8:
          if (
#line 9667 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 11029; /* *cond_fix_trunc_nontruncvnx2dfvnx2di_strict */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
      || pattern1123 (x2, 
E_VNx2DFmode, 
E_VNx4SImode) != 0
      || !
#line 9701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
    return -1;
  return 11031; /* *cond_fix_trunc_truncvnx2dfvnx4si */
}

 int
recog_212 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1251 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 12016; /* *cond_uqshlvnx16qi_2 */
    }
  if (register_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1278 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 12024; /* *cond_uqshlvnx16qi_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1303 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 12032; /* *cond_uqshlvnx16qi_any */
}

 int
recog_220 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1049 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11867; /* *cond_urshlvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1074 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11914; /* *cond_urshlvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11954; /* *cond_urshlvnx16qi_any */
}

 int
recog_226 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1049 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11889; /* *cond_uqrshlvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1074 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11932; /* *cond_uqrshlvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11972; /* *cond_uqrshlvnx4si_any */
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1049 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11875; /* *cond_uhaddvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1074 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11920; /* *cond_uhaddvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11960; /* *cond_uhaddvnx8hi_any */
}

 int
recog_245 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1049 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11895; /* *cond_sqrshlvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1074 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11937; /* *cond_sqrshlvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11977; /* *cond_sqrshlvnx2di_any */
}

 int
recog_255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1108 (x2))
        {
        case 0:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8609; /* *cond_subvnx8bf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8755; /* *cond_subvnx8bf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8859; /* *cond_subvnx8bf_any_relaxed */

        case 1:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8622; /* *cond_subvnx8hf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
            return 8768; /* *cond_subvnx8hf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8872; /* *cond_subvnx8hf_any_relaxed */

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8635; /* *cond_subvnx4sf_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
            return 8781; /* *cond_subvnx4sf_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8885; /* *cond_subvnx4sf_any_relaxed */

        case 3:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8648; /* *cond_subvnx2df_2_relaxed */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
            return 8794; /* *cond_subvnx2df_3_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8898; /* *cond_subvnx2df_any_relaxed */

        case 4:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 6243 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9043; /* *cond_subvnx8hf_3_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 6287 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 9049; /* *cond_subvnx8hf_const_relaxed */

        case 5:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 6243 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9044; /* *cond_subvnx4sf_3_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 6287 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 9050; /* *cond_subvnx4sf_const_relaxed */

        case 6:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 6243 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9045; /* *cond_subvnx2df_3_const_relaxed */
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 6287 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 9051; /* *cond_subvnx2df_const_relaxed */

        default:
          return -1;
        }

    case 1L:
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (pattern1108 (x2))
        {
        case 0:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8661; /* *cond_subvnx8bf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8807; /* *cond_subvnx8bf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8911; /* *cond_subvnx8bf_any_strict */

        case 1:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8674; /* *cond_subvnx8hf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
            return 8820; /* *cond_subvnx8hf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8924; /* *cond_subvnx8hf_any_strict */

        case 2:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8687; /* *cond_subvnx4sf_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
            return 8833; /* *cond_subvnx4sf_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8937; /* *cond_subvnx4sf_any_strict */

        case 3:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 5644 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 8700; /* *cond_subvnx2df_2_strict */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 5730 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
            return 8846; /* *cond_subvnx2df_3_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
            return -1;
          return 8950; /* *cond_subvnx2df_any_strict */

        case 4:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 6266 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9046; /* *cond_subvnx8hf_3_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !
#line 6323 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 9052; /* *cond_subvnx8hf_const_strict */

        case 5:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 6266 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9047; /* *cond_subvnx4sf_3_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !
#line 6323 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 9053; /* *cond_subvnx4sf_const_strict */

        case 6:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && 
#line 6266 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9048; /* *cond_subvnx2df_3_const_strict */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !
#line 6323 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 9054; /* *cond_subvnx2df_const_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 4);
  operands[4] = x7;
  switch (XINT (x3, 1))
    {
    case 376:
      switch (pattern1126 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9333; /* *cond_fmavnx8hf_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9361; /* *cond_fmavnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9393; /* *cond_fmavnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9337; /* *cond_fmavnx4sf_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9365; /* *cond_fmavnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9397; /* *cond_fmavnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9341; /* *cond_fmavnx2df_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9369; /* *cond_fmavnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9401; /* *cond_fmavnx2df_any_relaxed */

        case 3:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && (
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 9357; /* *cond_fmavnx8bf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
              || !(
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 9389; /* *cond_fmavnx8bf_any_relaxed */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9345; /* *cond_fmavnx8hf_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9377; /* *cond_fmavnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9409; /* *cond_fmavnx8hf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9349; /* *cond_fmavnx4sf_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9381; /* *cond_fmavnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9413; /* *cond_fmavnx4sf_any_strict */

        case 6:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9353; /* *cond_fmavnx2df_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9385; /* *cond_fmavnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9417; /* *cond_fmavnx2df_any_strict */

        case 7:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && (
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 9373; /* *cond_fmavnx8bf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
              || !(
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 9405; /* *cond_fmavnx8bf_any_strict */

        default:
          return -1;
        }

    case 377:
      switch (pattern1126 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9334; /* *cond_fnmavnx8hf_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9362; /* *cond_fnmavnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9394; /* *cond_fnmavnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9338; /* *cond_fnmavnx4sf_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9366; /* *cond_fnmavnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9398; /* *cond_fnmavnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7655 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9342; /* *cond_fnmavnx2df_2_relaxed */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9370; /* *cond_fnmavnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9402; /* *cond_fnmavnx2df_any_relaxed */

        case 3:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && (
#line 7701 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 9358; /* *cond_fnmavnx8bf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
              || !(
#line 7747 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 9390; /* *cond_fnmavnx8bf_any_relaxed */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9346; /* *cond_fnmavnx8hf_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9378; /* *cond_fnmavnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9410; /* *cond_fnmavnx8hf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9350; /* *cond_fnmavnx4sf_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9382; /* *cond_fnmavnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9414; /* *cond_fnmavnx4sf_any_strict */

        case 6:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[2])
              && 
#line 7679 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9354; /* *cond_fnmavnx2df_2_strict */
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
            return 9386; /* *cond_fnmavnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9418; /* *cond_fnmavnx2df_any_strict */

        case 7:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && (
#line 7725 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 9374; /* *cond_fnmavnx8bf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
              || !(
#line 7793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 9406; /* *cond_fnmavnx8bf_any_strict */

        default:
          return -1;
        }

    case 381:
      return recog_267 (x1, insn, pnum_clobbers);

    case 382:
      return recog_266 (x1, insn, pnum_clobbers);

    case 360:
      switch (pattern1127 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9441; /* *cond_fcmlavnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9465; /* *cond_fcmlavnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9445; /* *cond_fcmlavnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9469; /* *cond_fcmlavnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9449; /* *cond_fcmlavnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9473; /* *cond_fcmlavnx2df_any_relaxed */

        case 3:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9453; /* *cond_fcmlavnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9477; /* *cond_fcmlavnx8hf_any_strict */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9457; /* *cond_fcmlavnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9481; /* *cond_fcmlavnx4sf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9461; /* *cond_fcmlavnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9485; /* *cond_fcmlavnx2df_any_strict */

        default:
          return -1;
        }

    case 361:
      switch (pattern1127 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9442; /* *cond_fcmla90vnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9466; /* *cond_fcmla90vnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9446; /* *cond_fcmla90vnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9470; /* *cond_fcmla90vnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9450; /* *cond_fcmla90vnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9474; /* *cond_fcmla90vnx2df_any_relaxed */

        case 3:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9454; /* *cond_fcmla90vnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9478; /* *cond_fcmla90vnx8hf_any_strict */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9458; /* *cond_fcmla90vnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9482; /* *cond_fcmla90vnx4sf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9462; /* *cond_fcmla90vnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9486; /* *cond_fcmla90vnx2df_any_strict */

        default:
          return -1;
        }

    case 362:
      switch (pattern1127 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9443; /* *cond_fcmla180vnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9467; /* *cond_fcmla180vnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9447; /* *cond_fcmla180vnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9471; /* *cond_fcmla180vnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9451; /* *cond_fcmla180vnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9475; /* *cond_fcmla180vnx2df_any_relaxed */

        case 3:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9455; /* *cond_fcmla180vnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9479; /* *cond_fcmla180vnx8hf_any_strict */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9459; /* *cond_fcmla180vnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9483; /* *cond_fcmla180vnx4sf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9463; /* *cond_fcmla180vnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9487; /* *cond_fcmla180vnx2df_any_strict */

        default:
          return -1;
        }

    case 363:
      switch (pattern1127 (x2))
        {
        case 0:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9444; /* *cond_fcmla270vnx8hf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9468; /* *cond_fcmla270vnx8hf_any_relaxed */

        case 1:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9448; /* *cond_fcmla270vnx4sf_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9472; /* *cond_fcmla270vnx4sf_any_relaxed */

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          operands[5] = x8;
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9452; /* *cond_fcmla270vnx2df_4_relaxed */
          operands[6] = x8;
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 7994 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9476; /* *cond_fcmla270vnx2df_any_relaxed */

        case 3:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9456; /* *cond_fcmla270vnx8hf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9480; /* *cond_fcmla270vnx8hf_any_strict */

        case 4:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9460; /* *cond_fcmla270vnx4sf_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9484; /* *cond_fcmla270vnx4sf_any_strict */

        case 5:
          x9 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x9, operands[4])
              && 
#line 7973 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9464; /* *cond_fcmla270vnx2df_4_strict */
          operands[5] = x9;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
              || !
#line 8032 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9488; /* *cond_fcmla270vnx2df_any_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_286 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern735 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7555; /* *cond_iorvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7725; /* *cond_iorvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7895; /* *cond_iorvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7572; /* *cond_iorvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7742; /* *cond_iorvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7912; /* *cond_iorvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7589; /* *cond_iorvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7759; /* *cond_iorvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7929; /* *cond_iorvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7606; /* *cond_iorvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7776; /* *cond_iorvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7946; /* *cond_iorvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7623; /* *cond_iorvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7793; /* *cond_iorvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7963; /* *cond_iorvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7640; /* *cond_iorvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7810; /* *cond_iorvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7980; /* *cond_iorvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7657; /* *cond_iorvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7827; /* *cond_iorvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7997; /* *cond_iorvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7674; /* *cond_iorvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7844; /* *cond_iorvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8014; /* *cond_iorvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7691; /* *cond_iorvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7861; /* *cond_iorvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8031; /* *cond_iorvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4151 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7708; /* *cond_iorvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4168 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7878; /* *cond_iorvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8048; /* *cond_iorvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_295 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern598 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6797; /* *cond_popcountvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6887; /* *cond_popcountvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6806; /* *cond_popcountvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6896; /* *cond_popcountvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6815; /* *cond_popcountvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6905; /* *cond_popcountvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6824; /* *cond_popcountvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6914; /* *cond_popcountvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6833; /* *cond_popcountvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6923; /* *cond_popcountvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6842; /* *cond_popcountvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6932; /* *cond_popcountvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6851; /* *cond_popcountvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6941; /* *cond_popcountvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6860; /* *cond_popcountvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6950; /* *cond_popcountvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6869; /* *cond_popcountvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6959; /* *cond_popcountvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3282 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6878; /* *cond_popcountvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !
#line 3304 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6968; /* *cond_popcountvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_302 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4x8QImode:
      if (!register_operand (operands[0], E_V4x8QImode)
          || GET_MODE (x3) != E_V4x8QImode
          || !register_operand (operands[2], E_V4x8QImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4590; /* aarch64_vec_load_lanesv4x8qi_lanev8qi */

    case E_V4x4HImode:
      if (!register_operand (operands[0], E_V4x4HImode)
          || GET_MODE (x3) != E_V4x4HImode
          || !register_operand (operands[2], E_V4x4HImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4591; /* aarch64_vec_load_lanesv4x4hi_lanev4hi */

    case E_V4x2SImode:
      if (!register_operand (operands[0], E_V4x2SImode)
          || GET_MODE (x3) != E_V4x2SImode
          || !register_operand (operands[2], E_V4x2SImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4592; /* aarch64_vec_load_lanesv4x2si_lanev2si */

    case E_V4x1DImode:
      if (!register_operand (operands[0], E_V4x1DImode)
          || GET_MODE (x3) != E_V4x1DImode
          || !register_operand (operands[2], E_V4x1DImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4593; /* aarch64_vec_load_lanesv4x1di_lanedi */

    case E_V4x4HFmode:
      if (!register_operand (operands[0], E_V4x4HFmode)
          || GET_MODE (x3) != E_V4x4HFmode
          || !register_operand (operands[2], E_V4x4HFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4594; /* aarch64_vec_load_lanesv4x4hf_lanev4hf */

    case E_V4x2SFmode:
      if (!register_operand (operands[0], E_V4x2SFmode)
          || GET_MODE (x3) != E_V4x2SFmode
          || !register_operand (operands[2], E_V4x2SFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4595; /* aarch64_vec_load_lanesv4x2sf_lanev2sf */

    case E_V4x1DFmode:
      if (!register_operand (operands[0], E_V4x1DFmode)
          || GET_MODE (x3) != E_V4x1DFmode
          || !register_operand (operands[2], E_V4x1DFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4596; /* aarch64_vec_load_lanesv4x1df_lanedf */

    case E_V4x4BFmode:
      if (!register_operand (operands[0], E_V4x4BFmode)
          || GET_MODE (x3) != E_V4x4BFmode
          || !register_operand (operands[2], E_V4x4BFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4597; /* aarch64_vec_load_lanesv4x4bf_lanev4bf */

    case E_V4x16QImode:
      if (!register_operand (operands[0], E_V4x16QImode)
          || GET_MODE (x3) != E_V4x16QImode
          || !register_operand (operands[2], E_V4x16QImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4598; /* aarch64_vec_load_lanesv4x16qi_lanev16qi */

    case E_V4x8HImode:
      if (!register_operand (operands[0], E_V4x8HImode)
          || GET_MODE (x3) != E_V4x8HImode
          || !register_operand (operands[2], E_V4x8HImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4599; /* aarch64_vec_load_lanesv4x8hi_lanev8hi */

    case E_V4x4SImode:
      if (!register_operand (operands[0], E_V4x4SImode)
          || GET_MODE (x3) != E_V4x4SImode
          || !register_operand (operands[2], E_V4x4SImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4600; /* aarch64_vec_load_lanesv4x4si_lanev4si */

    case E_V4x2DImode:
      if (!register_operand (operands[0], E_V4x2DImode)
          || GET_MODE (x3) != E_V4x2DImode
          || !register_operand (operands[2], E_V4x2DImode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4601; /* aarch64_vec_load_lanesv4x2di_lanev2di */

    case E_V4x8HFmode:
      if (!register_operand (operands[0], E_V4x8HFmode)
          || GET_MODE (x3) != E_V4x8HFmode
          || !register_operand (operands[2], E_V4x8HFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4602; /* aarch64_vec_load_lanesv4x8hf_lanev8hf */

    case E_V4x4SFmode:
      if (!register_operand (operands[0], E_V4x4SFmode)
          || GET_MODE (x3) != E_V4x4SFmode
          || !register_operand (operands[2], E_V4x4SFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4603; /* aarch64_vec_load_lanesv4x4sf_lanev4sf */

    case E_V4x2DFmode:
      if (!register_operand (operands[0], E_V4x2DFmode)
          || GET_MODE (x3) != E_V4x2DFmode
          || !register_operand (operands[2], E_V4x2DFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4604; /* aarch64_vec_load_lanesv4x2df_lanev2df */

    case E_V4x8BFmode:
      if (!register_operand (operands[0], E_V4x8BFmode)
          || GET_MODE (x3) != E_V4x8BFmode
          || !register_operand (operands[2], E_V4x8BFmode)
          || !
#line 7834 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4605; /* aarch64_vec_load_lanesv4x8bf_lanev8bf */

    default:
      return -1;
    }
}

 int
recog_308 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern182 (x1))
    {
    case 0:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
        return -1;
      return 11033; /* aarch64_sve_float_nonextendvnx8hivnx8hf */

    case 1:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
        return -1;
      return 11039; /* aarch64_sve_float_nonextendvnx4sivnx8hf */

    case 2:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
        return -1;
      return 11045; /* aarch64_sve_float_nonextendvnx2divnx8hf */

    case 3:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
        return -1;
      return 11035; /* aarch64_sve_float_nonextendvnx8hivnx4sf */

    case 4:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
        return -1;
      return 11041; /* aarch64_sve_float_nonextendvnx4sivnx4sf */

    case 5:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
        return -1;
      return 11047; /* aarch64_sve_float_nonextendvnx2divnx4sf */

    case 6:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
        return -1;
      return 11037; /* aarch64_sve_float_nonextendvnx8hivnx2df */

    case 7:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
        return -1;
      return 11043; /* aarch64_sve_float_nonextendvnx4sivnx2df */

    case 8:
      if (!
#line 9778 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
        return -1;
      return 11049; /* aarch64_sve_float_nonextendvnx2divnx2df */

    case 9:
      if (!
#line 9809 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 11087; /* aarch64_sve_float_extendvnx4sivnx2df */

    case 10:
      if (aarch64_predicate_operand (operands[1], E_VNx8BImode)
          && register_operand (operands[2], E_VNx8HImode)
          && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x82 | 0x81) & 0x22) == 0))
        return 11051; /* *aarch64_sve_float_nonextendvnx8hivnx2hf */
      if (aarch64_predicate_operand (operands[1], E_VNx4BImode))
        {
          switch (GET_MODE (operands[2]))
            {
            case E_VNx4HImode:
              if (register_operand (operands[2], E_VNx4HImode)
                  && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x42 | 0x41) & 0x22) == 0))
                return 11057; /* *aarch64_sve_float_nonextendvnx4hivnx2hf */
              break;

            case E_VNx4SImode:
              if (register_operand (operands[2], E_VNx4SImode)
                  && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x44 | 0x43) & 0x22) == 0))
                return 11069; /* *aarch64_sve_float_nonextendvnx4sivnx2hf */
              break;

            default:
              break;
            }
        }
      if (!aarch64_predicate_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (pattern1063 ())
        {
        case 0:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x22 | 0x21) & 0x22) == 0))
            return -1;
          return 11063; /* *aarch64_sve_float_nonextendvnx2hivnx2hf */

        case 1:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x24 | 0x23) & 0x22) == 0))
            return -1;
          return 11075; /* *aarch64_sve_float_nonextendvnx2sivnx2hf */

        case 2:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x28 | 0x27) & 0x22) == 0))
            return -1;
          return 11081; /* *aarch64_sve_float_nonextendvnx2divnx2hf */

        default:
          return -1;
        }

    case 11:
      if (aarch64_predicate_operand (operands[1], E_VNx8BImode)
          && register_operand (operands[2], E_VNx8HImode)
          && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x82 | 0x81) & 0x42) == 0))
        return 11053; /* *aarch64_sve_float_nonextendvnx8hivnx4hf */
      if (aarch64_predicate_operand (operands[1], E_VNx4BImode))
        {
          switch (GET_MODE (operands[2]))
            {
            case E_VNx4HImode:
              if (register_operand (operands[2], E_VNx4HImode)
                  && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x42 | 0x41) & 0x42) == 0))
                return 11059; /* *aarch64_sve_float_nonextendvnx4hivnx4hf */
              break;

            case E_VNx4SImode:
              if (register_operand (operands[2], E_VNx4SImode)
                  && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x44 | 0x43) & 0x42) == 0))
                return 11071; /* *aarch64_sve_float_nonextendvnx4sivnx4hf */
              break;

            default:
              break;
            }
        }
      if (!aarch64_predicate_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (pattern1063 ())
        {
        case 0:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x22 | 0x21) & 0x42) == 0))
            return -1;
          return 11065; /* *aarch64_sve_float_nonextendvnx2hivnx4hf */

        case 1:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x24 | 0x23) & 0x42) == 0))
            return -1;
          return 11077; /* *aarch64_sve_float_nonextendvnx2sivnx4hf */

        case 2:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x28 | 0x27) & 0x42) == 0))
            return -1;
          return 11083; /* *aarch64_sve_float_nonextendvnx2divnx4hf */

        default:
          return -1;
        }

    case 12:
      if (aarch64_predicate_operand (operands[1], E_VNx8BImode)
          && register_operand (operands[2], E_VNx8HImode)
          && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x82 | 0x81) & 0x24) == 0))
        return 11055; /* *aarch64_sve_float_nonextendvnx8hivnx2sf */
      if (aarch64_predicate_operand (operands[1], E_VNx4BImode))
        {
          switch (GET_MODE (operands[2]))
            {
            case E_VNx4HImode:
              if (register_operand (operands[2], E_VNx4HImode)
                  && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x42 | 0x41) & 0x24) == 0))
                return 11061; /* *aarch64_sve_float_nonextendvnx4hivnx2sf */
              break;

            case E_VNx4SImode:
              if (register_operand (operands[2], E_VNx4SImode)
                  && 
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x44 | 0x43) & 0x24) == 0))
                return 11073; /* *aarch64_sve_float_nonextendvnx4sivnx2sf */
              break;

            default:
              break;
            }
        }
      if (!aarch64_predicate_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (pattern1063 ())
        {
        case 0:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x22 | 0x21) & 0x24) == 0))
            return -1;
          return 11067; /* *aarch64_sve_float_nonextendvnx2hivnx2sf */

        case 1:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x24 | 0x23) & 0x24) == 0))
            return -1;
          return 11079; /* *aarch64_sve_float_nonextendvnx2sivnx2sf */

        case 2:
          if (!
#line 9793 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (~(0x28 | 0x27) & 0x24) == 0))
            return -1;
          return 11085; /* *aarch64_sve_float_nonextendvnx2divnx2sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      switch (pattern798 (x3, 
E_V8QImode))
        {
        case 0:
          if (!
#line 8586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4874; /* aarch64_qtbx1v8qi */

        case 1:
          if (!
#line 8609 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4878; /* aarch64_qtbx2v8qi */

        case 2:
          if (!
#line 8632 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4882; /* aarch64_qtbx3v8qi */

        case 3:
          if (!
#line 8655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4886; /* aarch64_qtbx4v8qi */

        default:
          return -1;
        }

    case E_V16QImode:
      switch (pattern798 (x3, 
E_V16QImode))
        {
        case 0:
          if (!
#line 8586 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4875; /* aarch64_qtbx1v16qi */

        case 1:
          if (!
#line 8609 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4879; /* aarch64_qtbx2v16qi */

        case 2:
          if (!
#line 8632 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4883; /* aarch64_qtbx3v16qi */

        case 3:
          if (!
#line 8655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4887; /* aarch64_qtbx4v16qi */

        default:
          return -1;
        }

    case E_VNx16QImode:
      if (pattern199 (x3, 
E_VNx16QImode) != 0
          || !
#line 3850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13048; /* aarch64_sve_tbxvnx16qi */

    case E_VNx8HImode:
      if (pattern199 (x3, 
E_VNx8HImode) != 0
          || !
#line 3850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13050; /* aarch64_sve_tbxvnx8hi */

    case E_VNx4SImode:
      if (pattern199 (x3, 
E_VNx4SImode) != 0
          || !
#line 3850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13052; /* aarch64_sve_tbxvnx4si */

    case E_VNx2DImode:
      if (pattern199 (x3, 
E_VNx2DImode) != 0
          || !
#line 3850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13054; /* aarch64_sve_tbxvnx2di */

    case E_VNx8BFmode:
      if (pattern797 (x3, 
E_VNx8HImode, 
E_VNx8BFmode) != 0
          || !
#line 3850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13056; /* aarch64_sve_tbxvnx8bf */

    case E_VNx8HFmode:
      if (pattern797 (x3, 
E_VNx8HImode, 
E_VNx8HFmode) != 0
          || !
#line 3850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13058; /* aarch64_sve_tbxvnx8hf */

    case E_VNx4SFmode:
      if (pattern797 (x3, 
E_VNx4SImode, 
E_VNx4SFmode) != 0
          || !
#line 3850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13060; /* aarch64_sve_tbxvnx4sf */

    case E_VNx2DFmode:
      if (pattern797 (x3, 
E_VNx2DImode, 
E_VNx2DFmode) != 0
          || !
#line 3850 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 13062; /* aarch64_sve_tbxvnx2df */

    default:
      return -1;
    }
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern173 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10045; /* while_gesivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10055; /* while_gedivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10065; /* while_gesivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10075; /* while_gedivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10085; /* while_gesivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10095; /* while_gedivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10105; /* while_gesivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10115; /* while_gedivnx2bi */

    default:
      return -1;
    }
}

 int
recog_333 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern803 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6397; /* aarch64_stnt1vnx16qi */

    case E_VNx8HImode:
      if (pattern803 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6398; /* aarch64_stnt1vnx8hi */

    case E_VNx4SImode:
      if (pattern803 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6399; /* aarch64_stnt1vnx4si */

    case E_VNx2DImode:
      if (pattern803 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6400; /* aarch64_stnt1vnx2di */

    case E_VNx8BFmode:
      if (pattern803 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6401; /* aarch64_stnt1vnx8bf */

    case E_VNx8HFmode:
      if (pattern803 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6402; /* aarch64_stnt1vnx8hf */

    case E_VNx4SFmode:
      if (pattern803 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6403; /* aarch64_stnt1vnx4sf */

    case E_VNx2DFmode:
      if (pattern803 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 2449 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6404; /* aarch64_stnt1vnx2df */

    default:
      return -1;
    }
}

 int
recog_341 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern801 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6146; /* aarch64_ldnt1vnx16qi */

    case E_VNx8HImode:
      if (pattern801 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6147; /* aarch64_ldnt1vnx8hi */

    case E_VNx4SImode:
      if (pattern801 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6148; /* aarch64_ldnt1vnx4si */

    case E_VNx2DImode:
      if (pattern801 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6149; /* aarch64_ldnt1vnx2di */

    case E_VNx8BFmode:
      if (pattern801 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6150; /* aarch64_ldnt1vnx8bf */

    case E_VNx8HFmode:
      if (pattern801 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6151; /* aarch64_ldnt1vnx8hf */

    case E_VNx4SFmode:
      if (pattern801 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6152; /* aarch64_ldnt1vnx4sf */

    case E_VNx2DFmode:
      if (pattern801 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 1499 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6153; /* aarch64_ldnt1vnx2df */

    default:
      return -1;
    }
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern806 (x3, 
E_VNx16QImode) != 0
          || !
#line 1999 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12248; /* aarch64_sve_slivnx16qi */

    case E_VNx8HImode:
      if (pattern806 (x3, 
E_VNx8HImode) != 0
          || !
#line 1999 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12250; /* aarch64_sve_slivnx8hi */

    case E_VNx4SImode:
      if (pattern806 (x3, 
E_VNx4SImode) != 0
          || !
#line 1999 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12252; /* aarch64_sve_slivnx4si */

    case E_VNx2DImode:
      if (pattern806 (x3, 
E_VNx2DImode) != 0
          || !
#line 1999 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12254; /* aarch64_sve_slivnx2di */

    default:
      return -1;
    }
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern201 (x1))
    {
    case 0:
      if (!
#line 3009 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12762; /* aarch64_sve_sqrdcmlah270vnx16qi */

    case 1:
      if (!
#line 3009 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12770; /* aarch64_sve_sqrdcmlah270vnx8hi */

    case 2:
      if (!
#line 3009 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12778; /* aarch64_sve_sqrdcmlah270vnx4si */

    case 3:
      if (!
#line 3009 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12786; /* aarch64_sve_sqrdcmlah270vnx2di */

    case 4:
      if (!
#line 3026 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12794; /* aarch64_sqrdcmlah270_lane_vnx8hi */

    case 5:
      if (!
#line 3026 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12802; /* aarch64_sqrdcmlah270_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[3] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (pattern804 (x3, 
E_VNx8HFmode, 
E_HFmode, 
E_VNx8BImode) != 0
          || !
#line 9205 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10545; /* mask_fold_left_plus_vnx8hf */

    case E_SFmode:
      if (pattern804 (x3, 
E_VNx4SFmode, 
E_SFmode, 
E_VNx4BImode) != 0
          || !
#line 9205 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10546; /* mask_fold_left_plus_vnx4sf */

    case E_DFmode:
      if (pattern804 (x3, 
E_VNx2DFmode, 
E_DFmode, 
E_VNx2BImode) != 0
          || !
#line 9205 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10547; /* mask_fold_left_plus_vnx2df */

    default:
      return -1;
    }
}

 int
recog_373 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern203 (x1))
    {
    case 0:
      if (!
#line 3089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12803; /* aarch64_sve_cdotvnx4si */

    case 1:
      if (!
#line 3089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12807; /* aarch64_sve_cdotvnx2di */

    case 2:
      if (!
#line 3106 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12811; /* aarch64_cdot_lane_vnx4si */

    case 3:
      if (!
#line 3106 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12815; /* aarch64_cdot_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_383 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      if (!
#line 1460 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12066; /* aarch64_sve_adcltvnx16qi */

    case 1:
      if (!
#line 1460 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12074; /* aarch64_sve_adcltvnx8hi */

    case 2:
      if (!
#line 1460 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12082; /* aarch64_sve_adcltvnx4si */

    case 3:
      if (!
#line 1460 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12090; /* aarch64_sve_adcltvnx2di */

    default:
      return -1;
    }
}

 int
recog_393 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 2);
  operands[2] = x8;
  switch (GET_MODE (x3))
    {
    case E_VNx16BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10209; /* while_rwsivnx16bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10219; /* while_rwdivnx16bi_ptest */

    case E_VNx8BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10229; /* while_rwsivnx8bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10239; /* while_rwdivnx8bi_ptest */

    case E_VNx4BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10249; /* while_rwsivnx4bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10259; /* while_rwdivnx4bi_ptest */

    case E_VNx2BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10269; /* while_rwsivnx2bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10279; /* while_rwdivnx2bi_ptest */

    default:
      return -1;
    }
}

 int
recog_403 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern222 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[1] = x4;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4BImode:
          if (!register_operand (operands[0], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_VNx4SImode:
              if (!register_operand (operands[3], E_VNx4SImode)
                  || !
#line 566 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11598; /* aarch64_scatter_stntvnx4si */

            case E_VNx4SFmode:
              if (!register_operand (operands[3], E_VNx4SFmode)
                  || !
#line 566 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11600; /* aarch64_scatter_stntvnx4sf */

            default:
              return -1;
            }

        case E_VNx2BImode:
          if (!register_operand (operands[0], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[3], E_VNx2DImode)
                  || !
#line 566 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11599; /* aarch64_scatter_stntvnx2di */

            case E_VNx2DFmode:
              if (!register_operand (operands[3], E_VNx2DFmode)
                  || !
#line 566 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11601; /* aarch64_scatter_stntvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4BImode:
          switch (pattern1174 (x6, 
E_VNx4SImode, 
E_VNx4BImode))
            {
            case 0:
              if (!
#line 583 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
                return -1;
              return 11602; /* aarch64_scatter_stnt_vnx4sivnx8qi */

            case 1:
              if (!
#line 583 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
                return -1;
              return 11603; /* aarch64_scatter_stnt_vnx4sivnx4qi */

            case 2:
              if (!
#line 583 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
                return -1;
              return 11604; /* aarch64_scatter_stnt_vnx4sivnx2qi */

            case 3:
              if (!
#line 583 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
                return -1;
              return 11605; /* aarch64_scatter_stnt_vnx4sivnx4hi */

            case 4:
              if (!
#line 583 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
                return -1;
              return 11606; /* aarch64_scatter_stnt_vnx4sivnx2hi */

            case 5:
              if (!
#line 583 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
                return -1;
              return 11607; /* aarch64_scatter_stnt_vnx4sivnx2si */

            default:
              return -1;
            }

        case E_VNx2BImode:
          switch (pattern1174 (x6, 
E_VNx2DImode, 
E_VNx2BImode))
            {
            case 0:
              if (!
#line 583 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
                return -1;
              return 11608; /* aarch64_scatter_stnt_vnx2divnx8qi */

            case 1:
              if (!
#line 583 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
                return -1;
              return 11609; /* aarch64_scatter_stnt_vnx2divnx4qi */

            case 2:
              if (!
#line 583 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
                return -1;
              return 11610; /* aarch64_scatter_stnt_vnx2divnx2qi */

            case 3:
              if (!
#line 583 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
                return -1;
              return 11611; /* aarch64_scatter_stnt_vnx2divnx4hi */

            case 4:
              if (!
#line 583 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
                return -1;
              return 11612; /* aarch64_scatter_stnt_vnx2divnx2hi */

            case 5:
              if (!
#line 583 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
                return -1;
              return 11613; /* aarch64_scatter_stnt_vnx2divnx2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_411 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern229 (x1))
    {
    case 0:
      if (!
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13638; /* aarch64_sme_fsubvnx8sf */

    case 1:
      if (!
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13640; /* aarch64_sme_fsubvnx16sf */

    case 2:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 751 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13642; /* aarch64_sme_fsubvnx4df */

    case 3:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 752 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13644; /* aarch64_sme_fsubvnx8df */

    case 4:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 753 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13646; /* aarch64_sme_fsubvnx16hf */

    case 5:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 754 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13648; /* aarch64_sme_fsubvnx32hf */

    case 6:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 755 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13650; /* aarch64_sme_fsubvnx16bf */

    case 7:
      if (!(
#line 1186 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 756 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13652; /* aarch64_sme_fsubvnx32bf */

    case 8:
      if (!
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13654; /* *aarch64_sme_fsubvnx8sf_plus */

    case 9:
      if (!
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13656; /* *aarch64_sme_fsubvnx16sf_plus */

    case 10:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 751 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13658; /* *aarch64_sme_fsubvnx4df_plus */

    case 11:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 752 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_F64F64)))
        return -1;
      return 13660; /* *aarch64_sme_fsubvnx8df_plus */

    case 12:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 753 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13662; /* *aarch64_sme_fsubvnx16hf_plus */

    case 13:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 754 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_F16F16)))
        return -1;
      return 13664; /* *aarch64_sme_fsubvnx32hf_plus */

    case 14:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 755 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13666; /* *aarch64_sme_fsubvnx16bf_plus */

    case 15:
      if (!(
#line 1199 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 756 "../../gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME_B16B16)))
        return -1;
      return 13668; /* *aarch64_sme_fsubvnx32bf_plus */

    default:
      return -1;
    }
}

 int
recog_422 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 2);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (pattern193 (x2, 
E_V8QImode, 
E_V4HFmode) != 0
          || !
#line 203 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT2))
        return -1;
      return 5388; /* aarch64_fdotv4hf */

    case E_V8HFmode:
      if (pattern193 (x2, 
E_V16QImode, 
E_V8HFmode) != 0
          || !
#line 204 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT2))
        return -1;
      return 5389; /* aarch64_fdotv8hf */

    case E_V2SFmode:
      if (pattern193 (x2, 
E_V8QImode, 
E_V2SFmode) != 0
          || !
#line 205 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT4))
        return -1;
      return 5390; /* aarch64_fdotv2sf */

    case E_V4SFmode:
      if (pattern193 (x2, 
E_V16QImode, 
E_V4SFmode) != 0
          || !
#line 206 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP8DOT4))
        return -1;
      return 5391; /* aarch64_fdotv4sf */

    default:
      return -1;
    }
}

 int
recog_427 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern228 (x1))
    {
    case 0:
      if (!
#line 1161 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13622; /* aarch64_sme_subvnx8si */

    case 1:
      if (!(
#line 1161 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13624; /* aarch64_sme_subvnx4di */

    case 2:
      if (!
#line 1161 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13626; /* aarch64_sme_subvnx16si */

    case 3:
      if (!(
#line 1161 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 748 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13628; /* aarch64_sme_subvnx8di */

    case 4:
      if (!
#line 1174 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13630; /* *aarch64_sme_subvnx8si_plus */

    case 5:
      if (!(
#line 1174 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13632; /* *aarch64_sme_subvnx4di_plus */

    case 6:
      if (!
#line 1174 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13634; /* *aarch64_sme_subvnx16si_plus */

    case 7:
      if (!(
#line 1174 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 748 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13636; /* *aarch64_sme_subvnx8di_plus */

    default:
      return -1;
    }
}

 int
recog_435 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pattern86 (x1, 
E_VNx4SImode, 
93, 
89) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 3);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 4);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16BFmode:
              if (!aligned_register_operand (operands[1], E_VNx16BFmode)
                  || !aligned_register_operand (operands[2], E_VNx16BFmode)
                  || !
#line 1770 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14143; /* aarch64_sme_fdotvnx4sivnx16bf */

            case E_VNx32BFmode:
              if (!aligned_register_operand (operands[1], E_VNx32BFmode)
                  || !aligned_register_operand (operands[2], E_VNx32BFmode)
                  || !
#line 1770 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14144; /* aarch64_sme_fdotvnx4sivnx32bf */

            case E_VNx16HFmode:
              if (!aligned_register_operand (operands[1], E_VNx16HFmode)
                  || !aligned_register_operand (operands[2], E_VNx16HFmode)
                  || !
#line 1770 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14145; /* aarch64_sme_fdotvnx4sivnx16hf */

            case E_VNx32HFmode:
              if (!aligned_register_operand (operands[1], E_VNx32HFmode)
                  || !aligned_register_operand (operands[2], E_VNx32HFmode)
                  || !
#line 1770 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14146; /* aarch64_sme_fdotvnx4sivnx32hf */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (pattern254 (x5))
            {
            case 0:
              if (!
#line 1798 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14151; /* aarch64_sme_single_fdotvnx4sivnx16bf */

            case 1:
              if (!
#line 1798 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14152; /* aarch64_sme_single_fdotvnx4sivnx32bf */

            case 2:
              if (!
#line 1798 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14153; /* aarch64_sme_single_fdotvnx4sivnx16hf */

            case 3:
              if (!
#line 1798 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14154; /* aarch64_sme_single_fdotvnx4sivnx32hf */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 168)
            return -1;
          x7 = XVECEXP (x5, 0, 0);
          operands[2] = x7;
          x8 = XVECEXP (x5, 0, 1);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1343 (x5))
            {
            case 0:
              if (!
#line 1829 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14159; /* aarch64_sme_lane_fdotvnx4sivnx16bf */

            case 1:
              if (!
#line 1829 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14161; /* aarch64_sme_lane_fdotvnx4sivnx32bf */

            case 2:
              if (!
#line 1829 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14163; /* aarch64_sme_lane_fdotvnx4sivnx16hf */

            case 3:
              if (!
#line 1829 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14165; /* aarch64_sme_lane_fdotvnx4sivnx32hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[1] = x10;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 3);
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 4);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[3] = x5;
          switch (pattern1327 ())
            {
            case 0:
              if (!
#line 1784 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14147; /* *aarch64_sme_fdotvnx4sivnx16bf_plus */

            case 1:
              if (!
#line 1784 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14148; /* *aarch64_sme_fdotvnx4sivnx32bf_plus */

            case 2:
              if (!
#line 1784 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14149; /* *aarch64_sme_fdotvnx4sivnx16hf_plus */

            case 3:
              if (!
#line 1784 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14150; /* *aarch64_sme_fdotvnx4sivnx32hf_plus */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          switch (pattern258 (x5))
            {
            case 0:
              if (!
#line 1813 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14155; /* *aarch64_sme_single_fdotvnx4sivnx16bf_plus */

            case 1:
              if (!
#line 1813 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14156; /* *aarch64_sme_single_fdotvnx4sivnx32bf_plus */

            case 2:
              if (!
#line 1813 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14157; /* *aarch64_sme_single_fdotvnx4sivnx16hf_plus */

            case 3:
              if (!
#line 1813 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14158; /* *aarch64_sme_single_fdotvnx4sivnx32hf_plus */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 168)
            return -1;
          x7 = XVECEXP (x5, 0, 0);
          operands[3] = x7;
          x8 = XVECEXP (x5, 0, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (pattern1356 (x5))
            {
            case 0:
              if (!
#line 1846 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14167; /* *aarch64_sme_lane_fdotvnx4sivnx16bf_plus */

            case 1:
              if (!
#line 1846 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14169; /* *aarch64_sme_lane_fdotvnx4sivnx32bf_plus */

            case 2:
              if (!
#line 1846 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14171; /* *aarch64_sme_lane_fdotvnx4sivnx16hf_plus */

            case 3:
              if (!
#line 1846 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 14173; /* *aarch64_sme_lane_fdotvnx4sivnx32hf_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_437 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern250 (x1))
    {
    case 0:
      if (!
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13701; /* aarch64_sme_sdotvnx4sivnx32qi */

    case 1:
      if (!
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13704; /* aarch64_sme_sdotvnx4sivnx64qi */

    case 2:
      if (!
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13707; /* aarch64_sme_sdotvnx4sivnx16hi */

    case 3:
      if (!
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13710; /* aarch64_sme_sdotvnx4sivnx32hi */

    case 4:
      if (!(
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13713; /* aarch64_sme_sdotvnx2divnx32qi */

    case 5:
      if (!(
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13716; /* aarch64_sme_sdotvnx2divnx64qi */

    case 6:
      if (!(
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13719; /* aarch64_sme_sdotvnx2divnx16hi */

    case 7:
      if (!(
#line 1290 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13722; /* aarch64_sme_sdotvnx2divnx32hi */

    case 8:
      if (!
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13749; /* aarch64_sme_single_sdotvnx4sivnx32qi */

    case 9:
      if (!
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13752; /* aarch64_sme_single_sdotvnx4sivnx64qi */

    case 10:
      if (!
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13755; /* aarch64_sme_single_sdotvnx4sivnx16hi */

    case 11:
      if (!
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13758; /* aarch64_sme_single_sdotvnx4sivnx32hi */

    case 12:
      if (!(
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13761; /* aarch64_sme_single_sdotvnx2divnx32qi */

    case 13:
      if (!(
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13764; /* aarch64_sme_single_sdotvnx2divnx64qi */

    case 14:
      if (!(
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13767; /* aarch64_sme_single_sdotvnx2divnx16hi */

    case 15:
      if (!(
#line 1322 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13770; /* aarch64_sme_single_sdotvnx2divnx32hi */

    case 16:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13801; /* aarch64_sme_lane_sdotvnx4sivnx32qi */

    case 17:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13809; /* aarch64_sme_lane_sdotvnx4sivnx64qi */

    case 18:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13817; /* aarch64_sme_lane_sdotvnx4sivnx16hi */

    case 19:
      if (!
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13825; /* aarch64_sme_lane_sdotvnx4sivnx32hi */

    case 20:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13833; /* aarch64_sme_lane_sdotvnx2divnx32qi */

    case 21:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13841; /* aarch64_sme_lane_sdotvnx2divnx64qi */

    case 22:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13849; /* aarch64_sme_lane_sdotvnx2divnx16hi */

    case 23:
      if (!(
#line 1387 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13857; /* aarch64_sme_lane_sdotvnx2divnx32hi */

    case 24:
      if (!
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13725; /* *aarch64_sme_sdotvnx4sivnx32qi_plus */

    case 25:
      if (!
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13728; /* *aarch64_sme_sdotvnx4sivnx64qi_plus */

    case 26:
      if (!
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13731; /* *aarch64_sme_sdotvnx4sivnx16hi_plus */

    case 27:
      if (!
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13734; /* *aarch64_sme_sdotvnx4sivnx32hi_plus */

    case 28:
      if (!(
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13737; /* *aarch64_sme_sdotvnx2divnx32qi_plus */

    case 29:
      if (!(
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13740; /* *aarch64_sme_sdotvnx2divnx64qi_plus */

    case 30:
      if (!(
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13743; /* *aarch64_sme_sdotvnx2divnx16hi_plus */

    case 31:
      if (!(
#line 1306 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13746; /* *aarch64_sme_sdotvnx2divnx32hi_plus */

    case 32:
      if (!
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13773; /* *aarch64_sme_single_sdotvnx4sivnx32qi_plus */

    case 33:
      if (!
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13776; /* *aarch64_sme_single_sdotvnx4sivnx64qi_plus */

    case 34:
      if (!
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13779; /* *aarch64_sme_single_sdotvnx4sivnx16hi_plus */

    case 35:
      if (!
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13782; /* *aarch64_sme_single_sdotvnx4sivnx32hi_plus */

    case 36:
      if (!(
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13785; /* *aarch64_sme_single_sdotvnx2divnx32qi_plus */

    case 37:
      if (!(
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13788; /* *aarch64_sme_single_sdotvnx2divnx64qi_plus */

    case 38:
      if (!(
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13791; /* *aarch64_sme_single_sdotvnx2divnx16hi_plus */

    case 39:
      if (!(
#line 1339 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13794; /* *aarch64_sme_single_sdotvnx2divnx32hi_plus */

    case 40:
      if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13865; /* *aarch64_sme_lane_sdotvnx4sivnx32qi_plus */

    case 41:
      if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13873; /* *aarch64_sme_lane_sdotvnx4sivnx64qi_plus */

    case 42:
      if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13881; /* *aarch64_sme_lane_sdotvnx4sivnx16hi_plus */

    case 43:
      if (!
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13889; /* *aarch64_sme_lane_sdotvnx4sivnx32hi_plus */

    case 44:
      if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13897; /* *aarch64_sme_lane_sdotvnx2divnx32qi_plus */

    case 45:
      if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13905; /* *aarch64_sme_lane_sdotvnx2divnx64qi_plus */

    case 46:
      if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13913; /* *aarch64_sme_lane_sdotvnx2divnx16hi_plus */

    case 47:
      if (!(
#line 1406 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 729 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13921; /* *aarch64_sme_lane_sdotvnx2divnx32hi_plus */

    default:
      return -1;
    }
}

 int
recog_452 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  operands[1] = x3;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      switch (pattern951 (x4, 
E_SImode))
        {
        case 0:
          if (!
#line 6606 "../../gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 32))
            return -1;
          return 871; /* *aarch64_bfisihi_16 */

        case 1:
          if (!
#line 6606 "../../gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 32))
            return -1;
          return 875; /* *aarch64_bfisisi_16 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern951 (x4, 
E_DImode))
        {
        case 0:
          if (!
#line 6606 "../../gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
            return -1;
          return 873; /* *aarch64_bfidihi_16 */

        case 1:
          if (!
#line 6606 "../../gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
            return -1;
          return 878; /* *aarch64_bfidisi_16 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_453 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!cc_register (operands[2], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[3] = x8;
  if (!aarch64_reg_zero_or_m1_or_1 (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x3, 2);
  operands[4] = x9;
  if (!aarch64_reg_zero_or_m1_or_1 (operands[4], E_SImode)
      || !
#line 4740 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
    return -1;
  return 501; /* *cmovsi_insn_uxtw */
}

 int
recog_455 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      switch (XINT (x4, 1))
        {
        case 39:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != LO_SUM
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!aarch64_valid_symref (operands[2], E_DImode)
              || !
#line 7857 "../../gcc/config/aarch64/aarch64.md"
(TARGET_ILP32))
            return -1;
          return 1171; /* ldr_got_small_28k_sidi */

        case 41:
          if (GET_MODE (x4) != E_SImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!aarch64_valid_symref (operands[1], E_DImode)
              || !
#line 7876 "../../gcc/config/aarch64/aarch64.md"
(TARGET_ILP32))
            return -1;
          return 1174; /* ldr_got_tiny_sidi */

        case 40:
          if (pattern493 (x3) != 0)
            return -1;
          return 1180; /* tlsie_small_sidi */

        case 205:
          x5 = XVECEXP (x4, 0, 0);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  switch (pattern811 (x3, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 3422 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2774; /* aarch64_zero_extendsi_reduc_plus_v8qi */

                    case 1:
                      if (!
#line 3422 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2776; /* aarch64_zero_extendsi_reduc_plus_v16qi */

                    case 2:
                      if (!
#line 3422 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2778; /* aarch64_zero_extendsi_reduc_plus_v4hi */

                    case 3:
                      if (!
#line 3422 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2780; /* aarch64_zero_extendsi_reduc_plus_v8hi */

                    default:
                      return -1;
                    }

                case E_DImode:
                  switch (pattern811 (x3, 
E_DImode))
                    {
                    case 0:
                      if (!
#line 3422 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2775; /* aarch64_zero_extenddi_reduc_plus_v8qi */

                    case 1:
                      if (!
#line 3422 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2777; /* aarch64_zero_extenddi_reduc_plus_v16qi */

                    case 2:
                      if (!
#line 3422 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2779; /* aarch64_zero_extenddi_reduc_plus_v4hi */

                    case 3:
                      if (!
#line 3422 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2781; /* aarch64_zero_extenddi_reduc_plus_v8hi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern607 (x3))
                {
                case 0:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2812; /* *aarch64_saddlvv8qi_zesi */

                case 1:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2816; /* *aarch64_saddlvv16qi_zesi */

                case 2:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2820; /* *aarch64_saddlvv4hi_zesi */

                case 3:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2824; /* *aarch64_saddlvv8hi_zesi */

                case 4:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2828; /* *aarch64_saddlvv4si_zesi */

                case 5:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2832; /* *aarch64_saddlvv2si_zesi */

                case 6:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2814; /* *aarch64_saddlvv8qi_zedi */

                case 7:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2818; /* *aarch64_saddlvv16qi_zedi */

                case 8:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2822; /* *aarch64_saddlvv4hi_zedi */

                case 9:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2826; /* *aarch64_saddlvv8hi_zedi */

                case 10:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2830; /* *aarch64_saddlvv4si_zedi */

                case 11:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2834; /* *aarch64_saddlvv2si_zedi */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern607 (x3))
                {
                case 0:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2813; /* *aarch64_uaddlvv8qi_zesi */

                case 1:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2817; /* *aarch64_uaddlvv16qi_zesi */

                case 2:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2821; /* *aarch64_uaddlvv4hi_zesi */

                case 3:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2825; /* *aarch64_uaddlvv8hi_zesi */

                case 4:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2829; /* *aarch64_uaddlvv4si_zesi */

                case 5:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2833; /* *aarch64_uaddlvv2si_zesi */

                case 6:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2815; /* *aarch64_uaddlvv8qi_zedi */

                case 7:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2819; /* *aarch64_uaddlvv16qi_zedi */

                case 8:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2823; /* *aarch64_uaddlvv4hi_zedi */

                case 9:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2827; /* *aarch64_uaddlvv8hi_zedi */

                case 10:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2831; /* *aarch64_uaddlvv4si_zedi */

                case 11:
                  if (!
#line 3528 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2835; /* *aarch64_uaddlvv2si_zedi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x4, 1) != 42
          || pattern493 (x3) != 0)
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 1183; /* tlsie_tiny_sidi */

    case 3:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      x10 = XVECEXP (x4, 0, 2);
      operands[3] = x10;
      switch (XINT (x4, 1))
        {
        case 169:
          if (!const_int_operand (operands[1], E_DImode)
              || !const_int_operand (operands[2], E_DImode)
              || !const_int_operand (operands[3], E_DImode)
              || !
#line 10630 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11212; /* aarch64_sve_cnt_pat */

        case 307:
          if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16BImode:
              if (!register_operand (operands[1], E_VNx16BImode)
                  || !register_operand (operands[3], E_VNx16BImode)
                  || !
#line 10952 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11243; /* aarch64_pred_cntpvnx16bi */

            case E_VNx8BImode:
              if (!register_operand (operands[1], E_VNx8BImode)
                  || !register_operand (operands[3], E_VNx8BImode)
                  || !
#line 10952 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11244; /* aarch64_pred_cntpvnx8bi */

            case E_VNx4BImode:
              if (!register_operand (operands[1], E_VNx4BImode)
                  || !register_operand (operands[3], E_VNx4BImode)
                  || !
#line 10952 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11245; /* aarch64_pred_cntpvnx4bi */

            case E_VNx2BImode:
              if (!register_operand (operands[1], E_VNx2BImode)
                  || !register_operand (operands[3], E_VNx2BImode)
                  || !
#line 10952 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11246; /* aarch64_pred_cntpvnx2bi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_458 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case NEG:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (!aarch64_comparison_operator (x6, E_SImode))
        return -1;
      operands[1] = x6;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (!cc_register (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!general_operand (operands[3], E_SImode))
        return -1;
      return 533; /* *cmov_uxtw_insn_insv */

    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!aarch64_logical_operand (operands[2], E_SImode))
        return -1;
      return 554; /* *xorsi3_uxtw */

    case ASHIFT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (pattern810 (x3))
        {
        case 0:
          return 605; /* *xor_ashlsi3_uxtw */

        case 1:
          if (!
#line 6411 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < 32 &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == 32)))
            return -1;
          return 833; /* *extrsi5_insn_uxtw */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern736 (x3) != 0)
        return -1;
      return 608; /* *xor_ashrsi3_uxtw */

    case LSHIFTRT:
      switch (pattern737 (x3))
        {
        case 0:
          return 611; /* *xor_lshrsi3_uxtw */

        case 1:
          if (!
#line 6425 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < 32 &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == 32)))
            return -1;
          return 836; /* *extrsi5_insn_uxtw_alt */

        default:
          return -1;
        }

    case ROTATERT:
      if (pattern736 (x3) != 0)
        return -1;
      return 614; /* *xor_rotrsi3_uxtw */

    case ROTATE:
      if (pattern736 (x3) != 0)
        return -1;
      return 617; /* *xor_rotlsi3_uxtw */

    case NOT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x6))
        {
        case ASHIFT:
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x6, 1);
          operands[2] = x7;
          if (!aarch64_shift_imm_si (operands[2], E_QImode))
            return -1;
          return 677; /* xor_one_cmpl_ashlsidi_uxtw */

        case ASHIFTRT:
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x6, 1);
          operands[2] = x7;
          if (!aarch64_shift_imm_si (operands[2], E_QImode))
            return -1;
          return 680; /* xor_one_cmpl_ashrsidi_uxtw */

        case LSHIFTRT:
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x6, 1);
          operands[2] = x7;
          if (!aarch64_shift_imm_si (operands[2], E_QImode))
            return -1;
          return 683; /* xor_one_cmpl_lshrsidi_uxtw */

        case ROTATERT:
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x6, 1);
          operands[2] = x7;
          if (!aarch64_shift_imm_si (operands[2], E_QImode))
            return -1;
          return 686; /* xor_one_cmpl_rotrsidi_uxtw */

        case ROTATE:
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x6, 1);
          operands[2] = x7;
          if (!aarch64_shift_imm_si (operands[2], E_QImode))
            return -1;
          return 689; /* xor_one_cmpl_rotlsidi_uxtw */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_462 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_POLY_INT:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          if (aarch64_pluslong_operand (operands[2], E_SImode))
            return 160; /* *addsi3_aarch64 */
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_SImode)
              || !
#line 2734 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx))
            return -1;
          return 163; /* *addsi3_poly_1 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (aarch64_pluslong_operand (operands[2], E_DImode))
            return 161; /* *adddi3_aarch64 */
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_DImode)
              || !
#line 2734 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx))
            return -1;
          return 164; /* *adddi3_poly_1 */

        case E_HFmode:
          if (pattern34 (x2, 
E_HFmode) != 0
              || !(
#line 7439 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return -1;
          return 1099; /* addhf3 */

        case E_SFmode:
          if (pattern34 (x2, 
E_SFmode) != 0
              || !
#line 7439 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1100; /* addsf3 */

        case E_DFmode:
          if (pattern34 (x2, 
E_DFmode) != 0
              || !
#line 7439 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1101; /* adddf3 */

        case E_V8QImode:
          if (pattern34 (x2, 
E_V8QImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1395; /* addv8qi3 */

        case E_V16QImode:
          if (pattern34 (x2, 
E_V16QImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1398; /* addv16qi3 */

        case E_V4HImode:
          if (pattern34 (x2, 
E_V4HImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1399; /* addv4hi3 */

        case E_V8HImode:
          if (pattern34 (x2, 
E_V8HImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1402; /* addv8hi3 */

        case E_V2SImode:
          if (pattern34 (x2, 
E_V2SImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1403; /* addv2si3 */

        case E_V4SImode:
          if (pattern34 (x2, 
E_V4SImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1406; /* addv4si3 */

        case E_V2DImode:
          if (pattern34 (x2, 
E_V2DImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1407; /* addv2di3 */

        case E_V4HFmode:
          if (pattern34 (x2, 
E_V4HFmode) != 0
              || !(
#line 2655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2402; /* addv4hf3 */

        case E_V8HFmode:
          if (pattern34 (x2, 
E_V8HFmode) != 0
              || !(
#line 2655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2405; /* addv8hf3 */

        case E_V2SFmode:
          if (pattern34 (x2, 
E_V2SFmode) != 0
              || !
#line 2655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2406; /* addv2sf3 */

        case E_V4SFmode:
          if (pattern34 (x2, 
E_V4SFmode) != 0
              || !
#line 2655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2409; /* addv4sf3 */

        case E_V2DFmode:
          if (pattern34 (x2, 
E_V2DFmode) != 0
              || !
#line 2655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2410; /* addv2df3 */

        case E_VNx16QImode:
          if (pattern741 (x2, 
E_VNx16QImode) != 0
              || !
#line 4227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8054; /* addvnx16qi3 */

        case E_VNx8QImode:
          if (pattern741 (x2, 
E_VNx8QImode) != 0
              || !
#line 4227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8055; /* addvnx8qi3 */

        case E_VNx4QImode:
          if (pattern741 (x2, 
E_VNx4QImode) != 0
              || !
#line 4227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8056; /* addvnx4qi3 */

        case E_VNx2QImode:
          if (pattern741 (x2, 
E_VNx2QImode) != 0
              || !
#line 4227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8057; /* addvnx2qi3 */

        case E_VNx8HImode:
          if (pattern741 (x2, 
E_VNx8HImode) != 0
              || !
#line 4227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8058; /* addvnx8hi3 */

        case E_VNx4HImode:
          if (pattern741 (x2, 
E_VNx4HImode) != 0
              || !
#line 4227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8059; /* addvnx4hi3 */

        case E_VNx2HImode:
          if (pattern741 (x2, 
E_VNx2HImode) != 0
              || !
#line 4227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8060; /* addvnx2hi3 */

        case E_VNx4SImode:
          if (pattern741 (x2, 
E_VNx4SImode) != 0
              || !
#line 4227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8061; /* addvnx4si3 */

        case E_VNx2SImode:
          if (pattern741 (x2, 
E_VNx2SImode) != 0
              || !
#line 4227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8062; /* addvnx2si3 */

        case E_VNx2DImode:
          if (pattern741 (x2, 
E_VNx2DImode) != 0
              || !
#line 4227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8063; /* addvnx2di3 */

        case E_VNx8BFmode:
          if (pattern34 (x2, 
E_VNx8BFmode) != 0
              || !(
#line 5519 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8569; /* *post_ra_faddvnx8bf3 */

        case E_VNx8HFmode:
          if (pattern34 (x2, 
E_VNx8HFmode) != 0
              || !
#line 5519 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8572; /* *post_ra_faddvnx8hf3 */

        case E_VNx4SFmode:
          if (pattern34 (x2, 
E_VNx4SFmode) != 0
              || !
#line 5519 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8575; /* *post_ra_faddvnx4sf3 */

        case E_VNx2DFmode:
          if (pattern34 (x2, 
E_VNx2DFmode) != 0
              || !
#line 5519 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8578; /* *post_ra_faddvnx2df3 */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern494 (x2, 
E_V4SFmode) != 0)
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (!register_operand (operands[2], E_V8BFmode))
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_V8BFmode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 584:
              if (!
#line 10051 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                return -1;
              return 5316; /* aarch64_bfmmlaqv4sf */

            case 580:
              if (!
#line 10063 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                return -1;
              return 5317; /* aarch64_bfmlalbv4sf */

            case 581:
              if (!
#line 10063 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                return -1;
              return 5318; /* aarch64_bfmlaltv4sf */

            default:
              return -1;
            }

        case 3:
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (!register_operand (operands[2], E_V8BFmode))
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[3] = x6;
          x7 = XVECEXP (x4, 0, 2);
          operands[4] = x7;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 580:
              switch (GET_MODE (operands[3]))
                {
                case E_V4BFmode:
                  if (!register_operand (operands[3], E_V4BFmode)
                      || !
#line 10075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5319; /* aarch64_bfmlalb_lanev4sf */

                case E_V8BFmode:
                  if (!register_operand (operands[3], E_V8BFmode)
                      || !
#line 10075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5321; /* aarch64_bfmlalb_lane_qv4sf */

                default:
                  return -1;
                }

            case 581:
              switch (GET_MODE (operands[3]))
                {
                case E_V4BFmode:
                  if (!register_operand (operands[3], E_V4BFmode)
                      || !
#line 10075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5320; /* aarch64_bfmlalt_lanev4sf */

                case E_V8BFmode:
                  if (!register_operand (operands[3], E_V8BFmode)
                      || !
#line 10075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5322; /* aarch64_bfmlalt_lane_qv4sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern38 (x2))
        {
        case 0:
          if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11678; /* aarch64_sve_single_addvnx32qi */

        case 1:
          if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11683; /* aarch64_sve_single_addvnx16hi */

        case 2:
          if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11688; /* aarch64_sve_single_addvnx8si */

        case 3:
          if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11693; /* aarch64_sve_single_addvnx4di */

        case 4:
          if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11698; /* aarch64_sve_single_addvnx64qi */

        case 5:
          if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11703; /* aarch64_sve_single_addvnx32hi */

        case 6:
          if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11708; /* aarch64_sve_single_addvnx16si */

        case 7:
          if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11713; /* aarch64_sve_single_addvnx8di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_467 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (aarch64_comparison_operation (operands[2], E_VOIDmode))
    {
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && register_operand (operands[1], E_SImode))
            return 515; /* *csinc2si_insn */
          break;

        case E_DImode:
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && register_operand (operands[1], E_DImode))
            return 516; /* *csinc2di_insn */
          break;

        default:
          break;
        }
    }
  if (GET_CODE (x3) != EQ)
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      x4 = XEXP (x2, 1);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern952 (x2, 
E_V8QImode) != 0
              || !
#line 7381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4256; /* aarch64_cmtstv8qi */

        case E_V16QImode:
          if (pattern952 (x2, 
E_V16QImode) != 0
              || !
#line 7381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4259; /* aarch64_cmtstv16qi */

        case E_V4HImode:
          if (pattern952 (x2, 
E_V4HImode) != 0
              || !
#line 7381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4260; /* aarch64_cmtstv4hi */

        case E_V8HImode:
          if (pattern952 (x2, 
E_V8HImode) != 0
              || !
#line 7381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4263; /* aarch64_cmtstv8hi */

        case E_V2SImode:
          if (pattern952 (x2, 
E_V2SImode) != 0
              || !
#line 7381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4264; /* aarch64_cmtstv2si */

        case E_V4SImode:
          if (pattern952 (x2, 
E_V4SImode) != 0
              || !
#line 7381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4267; /* aarch64_cmtstv4si */

        case E_V2DImode:
          if (pattern952 (x2, 
E_V2DImode) != 0
              || !
#line 7381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4268; /* aarch64_cmtstv2di */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern891 (x2, 
E_V8QImode) != 0
              || !
#line 7398 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4269; /* *aarch64_cmtst_same_v8qi */

        case E_V16QImode:
          if (pattern891 (x2, 
E_V16QImode) != 0
              || !
#line 7398 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4272; /* *aarch64_cmtst_same_v16qi */

        case E_V4HImode:
          if (pattern891 (x2, 
E_V4HImode) != 0
              || !
#line 7398 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4273; /* *aarch64_cmtst_same_v4hi */

        case E_V8HImode:
          if (pattern891 (x2, 
E_V8HImode) != 0
              || !
#line 7398 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4276; /* *aarch64_cmtst_same_v8hi */

        case E_V2SImode:
          if (pattern891 (x2, 
E_V2SImode) != 0
              || !
#line 7398 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4277; /* *aarch64_cmtst_same_v2si */

        case E_V4SImode:
          if (pattern891 (x2, 
E_V4SImode) != 0
              || !
#line 7398 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4280; /* *aarch64_cmtst_same_v4si */

        case E_V2DImode:
          if (pattern891 (x2, 
E_V2DImode) != 0
              || !
#line 7398 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4281; /* *aarch64_cmtst_same_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_472 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern34 (x2, 
E_SImode) == 0)
            return 417; /* mulsi3 */
          break;

        case E_DImode:
          if (pattern34 (x2, 
E_DImode) == 0)
            return 418; /* muldi3 */
          break;

        case E_HFmode:
          if (pattern34 (x2, 
E_HFmode) == 0
              && (
#line 7459 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return 1105; /* mulhf3 */
          break;

        case E_SFmode:
          if (pattern34 (x2, 
E_SFmode) == 0
              && 
#line 7459 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return 1106; /* mulsf3 */
          break;

        case E_DFmode:
          if (pattern34 (x2, 
E_DFmode) == 0
              && 
#line 7459 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return 1107; /* muldf3 */
          break;

        case E_V8QImode:
          if (pattern34 (x2, 
E_V8QImode) == 0
              && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1421; /* mulv8qi3 */
          break;

        case E_V16QImode:
          if (pattern34 (x2, 
E_V16QImode) == 0
              && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1424; /* mulv16qi3 */
          break;

        case E_V4HImode:
          if (pattern34 (x2, 
E_V4HImode) == 0
              && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1425; /* mulv4hi3 */
          break;

        case E_V8HImode:
          if (pattern34 (x2, 
E_V8HImode) == 0
              && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1428; /* mulv8hi3 */
          break;

        case E_V2SImode:
          if (pattern34 (x2, 
E_V2SImode) == 0
              && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1429; /* mulv2si3 */
          break;

        case E_V4SImode:
          if (pattern34 (x2, 
E_V4SImode) == 0
              && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1432; /* mulv4si3 */
          break;

        case E_V4HFmode:
          if (pattern34 (x2, 
E_V4HFmode) == 0
              && (
#line 2673 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return 2420; /* mulv4hf3 */
          break;

        case E_V8HFmode:
          if (pattern34 (x2, 
E_V8HFmode) == 0
              && (
#line 2673 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return 2423; /* mulv8hf3 */
          break;

        case E_V2SFmode:
          if (pattern34 (x2, 
E_V2SFmode) == 0
              && 
#line 2673 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2424; /* mulv2sf3 */
          break;

        case E_V4SFmode:
          if (pattern34 (x2, 
E_V4SFmode) == 0
              && 
#line 2673 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2427; /* mulv4sf3 */
          break;

        case E_V2DFmode:
          if (pattern34 (x2, 
E_V2DFmode) == 0
              && 
#line 2673 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2428; /* mulv2df3 */
          break;

        case E_VNx8BFmode:
          if (pattern34 (x2, 
E_VNx8BFmode) == 0
              && (
#line 5519 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8571; /* *post_ra_fmulvnx8bf3 */
          break;

        case E_VNx8HFmode:
          if (pattern34 (x2, 
E_VNx8HFmode) == 0
              && 
#line 5519 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 8574; /* *post_ra_fmulvnx8hf3 */
          break;

        case E_VNx4SFmode:
          if (pattern34 (x2, 
E_VNx4SFmode) == 0
              && 
#line 5519 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 8577; /* *post_ra_fmulvnx4sf3 */
          break;

        case E_VNx2DFmode:
          if (pattern34 (x2, 
E_VNx2DFmode) == 0
              && 
#line 5519 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 8580; /* *post_ra_fmulvnx2df3 */
          break;

        default:
          break;
        }
      break;

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern309 (x2, 
E_VNx16QImode) == 0
              && 
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7489; /* *post_ra_mulvnx16qi3 */
          break;

        case E_VNx8QImode:
          if (pattern309 (x2, 
E_VNx8QImode) == 0
              && 
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7494; /* *post_ra_mulvnx8qi3 */
          break;

        case E_VNx4QImode:
          if (pattern309 (x2, 
E_VNx4QImode) == 0
              && 
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7499; /* *post_ra_mulvnx4qi3 */
          break;

        case E_VNx2QImode:
          if (pattern309 (x2, 
E_VNx2QImode) == 0
              && 
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7504; /* *post_ra_mulvnx2qi3 */
          break;

        case E_VNx8HImode:
          if (pattern309 (x2, 
E_VNx8HImode) == 0
              && 
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7509; /* *post_ra_mulvnx8hi3 */
          break;

        case E_VNx4HImode:
          if (pattern309 (x2, 
E_VNx4HImode) == 0
              && 
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7514; /* *post_ra_mulvnx4hi3 */
          break;

        case E_VNx2HImode:
          if (pattern309 (x2, 
E_VNx2HImode) == 0
              && 
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7519; /* *post_ra_mulvnx2hi3 */
          break;

        case E_VNx4SImode:
          if (pattern309 (x2, 
E_VNx4SImode) == 0
              && 
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7524; /* *post_ra_mulvnx4si3 */
          break;

        case E_VNx2SImode:
          if (pattern309 (x2, 
E_VNx2SImode) == 0
              && 
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7529; /* *post_ra_mulvnx2si3 */
          break;

        case E_VNx2DImode:
          if (pattern309 (x2, 
E_VNx2DImode) == 0
              && 
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7534; /* *post_ra_mulvnx2di3 */
          break;

        case E_V2DImode:
          if (pattern309 (x2, 
E_V2DImode) == 0
              && 
#line 4121 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7539; /* *post_ra_mulv2di3 */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern640 (x2, 
E_VNx16QImode) != 0
          || !
#line 868 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11802; /* *aarch64_mul_unpredicated_vnx16qi */

    case E_VNx8QImode:
      if (pattern640 (x2, 
E_VNx8QImode) != 0
          || !
#line 868 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11803; /* *aarch64_mul_unpredicated_vnx8qi */

    case E_VNx4QImode:
      if (pattern640 (x2, 
E_VNx4QImode) != 0
          || !
#line 868 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11804; /* *aarch64_mul_unpredicated_vnx4qi */

    case E_VNx2QImode:
      if (pattern640 (x2, 
E_VNx2QImode) != 0
          || !
#line 868 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11805; /* *aarch64_mul_unpredicated_vnx2qi */

    case E_VNx8HImode:
      if (pattern640 (x2, 
E_VNx8HImode) != 0
          || !
#line 868 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11806; /* *aarch64_mul_unpredicated_vnx8hi */

    case E_VNx4HImode:
      if (pattern640 (x2, 
E_VNx4HImode) != 0
          || !
#line 868 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11807; /* *aarch64_mul_unpredicated_vnx4hi */

    case E_VNx2HImode:
      if (pattern640 (x2, 
E_VNx2HImode) != 0
          || !
#line 868 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11808; /* *aarch64_mul_unpredicated_vnx2hi */

    case E_VNx4SImode:
      if (pattern640 (x2, 
E_VNx4SImode) != 0
          || !
#line 868 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11809; /* *aarch64_mul_unpredicated_vnx4si */

    case E_VNx2SImode:
      if (pattern640 (x2, 
E_VNx2SImode) != 0
          || !
#line 868 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11810; /* *aarch64_mul_unpredicated_vnx2si */

    case E_VNx2DImode:
      if (pattern640 (x2, 
E_VNx2DImode) != 0
          || !
#line 868 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11811; /* *aarch64_mul_unpredicated_vnx2di */

    case E_V2DImode:
      if (pattern640 (x2, 
E_V2DImode) != 0
          || !
#line 868 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11812; /* *aarch64_mul_unpredicated_v2di */

    default:
      return -1;
    }
}

 int
recog_481 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              switch (pattern817 (x2))
                {
                case 0:
                  if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3124; /* *aarch64_shaddv8qi_insn */

                case 1:
                  if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3136; /* *aarch64_shaddv16qi_insn */

                case 2:
                  if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3140; /* *aarch64_shaddv4hi_insn */

                case 3:
                  if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3152; /* *aarch64_shaddv8hi_insn */

                case 4:
                  if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3156; /* *aarch64_shaddv2si_insn */

                case 5:
                  if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3168; /* *aarch64_shaddv4si_insn */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_VECTOR:
              switch (pattern758 (x2))
                {
                case 0:
                  if (pattern1010 (x2, 
E_V8QImode, 
E_V8HImode) != 0
                      || !
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3839; /* aarch64_srshr_nv8qi_insn */

                case 1:
                  if (pattern1010 (x2, 
E_V16QImode, 
E_V16HImode) != 0
                      || !
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3845; /* aarch64_srshr_nv16qi_insn */

                case 2:
                  if (pattern1011 (x2, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3847; /* aarch64_srshr_nv4hi_insn */

                case 3:
                  if (pattern1011 (x2, 
E_V8HImode, 
E_V8SImode) != 0
                      || !
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3853; /* aarch64_srshr_nv8hi_insn */

                case 4:
                  if (pattern1012 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                      || !
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3855; /* aarch64_srshr_nv2si_insn */

                case 5:
                  if (pattern1012 (x2, 
E_V4SImode, 
E_V4DImode) != 0
                      || !
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3861; /* aarch64_srshr_nv4si_insn */

                case 6:
                  if (pattern1013 (x2) != 0
                      || !
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3863; /* aarch64_srshr_nv2di_insn */

                case 7:
                  if (!
#line 6650 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3865; /* aarch64_srshr_ndi_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != ZERO_EXTEND)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          switch (pattern817 (x2))
            {
            case 0:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3130; /* *aarch64_uhaddv8qi_insn */

            case 1:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3138; /* *aarch64_uhaddv16qi_insn */

            case 2:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3146; /* *aarch64_uhaddv4hi_insn */

            case 3:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3154; /* *aarch64_uhaddv8hi_insn */

            case 4:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3162; /* *aarch64_uhaddv2si_insn */

            case 5:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3170; /* *aarch64_uhaddv4si_insn */

            default:
              return -1;
            }

        case PLUS:
          x7 = XEXP (x4, 1);
          operands[3] = x7;
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern819 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3172; /* *aarch64_srhaddv8qi_insn */

                case 1:
                  if (!
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3178; /* *aarch64_srhaddv16qi_insn */

                case 2:
                  if (!
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3180; /* *aarch64_srhaddv4hi_insn */

                case 3:
                  if (!
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3186; /* *aarch64_srhaddv8hi_insn */

                case 4:
                  if (!
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3188; /* *aarch64_srhaddv2si_insn */

                case 5:
                  if (!
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3194; /* *aarch64_srhaddv4si_insn */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern819 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3175; /* *aarch64_urhaddv8qi_insn */

                case 1:
                  if (!
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3179; /* *aarch64_urhaddv16qi_insn */

                case 2:
                  if (!
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3183; /* *aarch64_urhaddv4hi_insn */

                case 3:
                  if (!
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3187; /* *aarch64_urhaddv8hi_insn */

                case 4:
                  if (!
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3191; /* *aarch64_urhaddv2si_insn */

                case 5:
                  if (!
#line 4856 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3195; /* *aarch64_urhaddv4si_insn */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x6;
              x8 = XEXP (x5, 1);
              operands[2] = x8;
              switch (pattern901 (x2))
                {
                case 0:
                  if (!
#line 4884 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3214; /* aarch64_raddhnv8hi_insn */

                case 1:
                  if (!
#line 4884 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3220; /* aarch64_raddhnv4si_insn */

                case 2:
                  if (!
#line 4884 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3226; /* aarch64_raddhnv2di_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          x9 = XEXP (x3, 1);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern961 (x2, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 4870 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3196; /* aarch64_addhnv8hi_insn */

            case E_V4HImode:
              if (pattern961 (x2, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 4870 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3202; /* aarch64_addhnv4si_insn */

            case E_V2SImode:
              if (pattern961 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 4870 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3208; /* aarch64_addhnv2di_insn */

            default:
              return -1;
            }

        case MINUS:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          x7 = XEXP (x4, 1);
          operands[3] = x7;
          switch (pattern901 (x2))
            {
            case 0:
              if (!
#line 4884 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3217; /* aarch64_rsubhnv8hi_insn */

            case 1:
              if (!
#line 4884 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3223; /* aarch64_rsubhnv4si_insn */

            case 2:
              if (!
#line 4884 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3229; /* aarch64_rsubhnv2di_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          switch (pattern761 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3127; /* *aarch64_shsubv8qi_insn */

            case 1:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3137; /* *aarch64_shsubv16qi_insn */

            case 2:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3143; /* *aarch64_shsubv4hi_insn */

            case 3:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3153; /* *aarch64_shsubv8hi_insn */

            case 4:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3159; /* *aarch64_shsubv2si_insn */

            case 5:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3169; /* *aarch64_shsubv4si_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern761 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3133; /* *aarch64_uhsubv8qi_insn */

            case 1:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3139; /* *aarch64_uhsubv16qi_insn */

            case 2:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3149; /* *aarch64_uhsubv4hi_insn */

            case 3:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3155; /* *aarch64_uhsubv8hi_insn */

            case 4:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3165; /* *aarch64_uhsubv2si_insn */

            case 5:
              if (!
#line 4839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3171; /* *aarch64_uhsubv4si_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern961 (x2, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 4870 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3199; /* aarch64_subhnv8hi_insn */

            case E_V4HImode:
              if (pattern961 (x2, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 4870 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3205; /* aarch64_subhnv4si_insn */

            case E_V2SImode:
              if (pattern961 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 4870 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3211; /* aarch64_subhnv2di_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern342 (x2))
        {
        case 0:
          if (!
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
            return -1;
          return 3956; /* *aarch64_sshrn_nv8hi_insn */

        case 1:
          if (!
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
            return -1;
          return 3974; /* *aarch64_sshrn_nv4si_insn */

        case 2:
          if (!
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
            return -1;
          return 3992; /* *aarch64_sshrn_nv2di_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_488 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern423 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1397; /* addv8qi3_vec_concatz_be */

        case E_V8HImode:
          if (pattern423 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1401; /* addv4hi3_vec_concatz_be */

        case E_V4SImode:
          if (pattern423 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1405; /* addv2si3_vec_concatz_be */

        case E_V8HFmode:
          if (pattern423 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2404; /* addv4hf3_vec_concatz_be */

        case E_V4SFmode:
          if (pattern423 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2408; /* addv2sf3_vec_concatz_be */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XEXP (x2, 0);
          operands[4] = x5;
          switch (XINT (x4, 1))
            {
            case 407:
              switch (pattern829 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1462; /* aarch64_fcmla0v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1478; /* aarch64_fcmla0v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 408:
              switch (pattern829 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1465; /* aarch64_fcmla90v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1481; /* aarch64_fcmla90v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 409:
              switch (pattern829 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1468; /* aarch64_fcmla180v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1484; /* aarch64_fcmla180v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 410:
              switch (pattern829 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1471; /* aarch64_fcmla270v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1487; /* aarch64_fcmla270v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 279:
              if (pattern830 (x2) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                return -1;
              return 1554; /* sdot_prodv2siv8qi_vec_concatz_be */

            case 280:
              if (pattern830 (x2) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                return -1;
              return 1557; /* udot_prodv2siv8qi_vec_concatz_be */

            case 573:
              if (pattern830 (x2) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 591 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                return -1;
              return 1562; /* usdot_prodv2siv8qi_vec_concatz_be */

            default:
              return -1;
            }

        case 3:
          x5 = XEXP (x2, 0);
          operands[5] = x5;
          x7 = XVECEXP (x4, 0, 0);
          operands[2] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[3] = x8;
          x9 = XVECEXP (x4, 0, 2);
          operands[4] = x9;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          switch (XINT (x4, 1))
            {
            case 407:
              switch (pattern1079 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1498; /* aarch64_fcmla_lane0v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1534; /* aarch64_fcmla_laneq0v4hf_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1514; /* aarch64_fcmla_lane0v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 408:
              switch (pattern1079 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1501; /* aarch64_fcmla_lane90v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1537; /* aarch64_fcmla_laneq90v4hf_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1517; /* aarch64_fcmla_lane90v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 409:
              switch (pattern1079 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1504; /* aarch64_fcmla_lane180v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1540; /* aarch64_fcmla_laneq180v4hf_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1520; /* aarch64_fcmla_lane180v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 410:
              switch (pattern1079 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1507; /* aarch64_fcmla_lane270v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1543; /* aarch64_fcmla_laneq270v4hf_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1523; /* aarch64_fcmla_lane270v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 279:
              switch (pattern1080 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 606 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1566; /* aarch64_sdot_lanev8qi_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 622 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1574; /* aarch64_sdot_laneqv8qi_vec_concatz_be */

                default:
                  return -1;
                }

            case 280:
              switch (pattern1080 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 606 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1569; /* aarch64_udot_lanev8qi_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 622 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1577; /* aarch64_udot_laneqv8qi_vec_concatz_be */

                default:
                  return -1;
                }

            case 573:
              switch (pattern1080 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1582; /* aarch64_usdot_lanev8qi_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1590; /* aarch64_usdot_laneqv8qi_vec_concatz_be */

                default:
                  return -1;
                }

            case 578:
              switch (pattern1080 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1585; /* aarch64_sudot_lanev8qi_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1593; /* aarch64_sudot_laneqv8qi_vec_concatz_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) != VEC_SELECT)
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != VEC_SELECT)
        return -1;
      x5 = XEXP (x2, 0);
      operands[5] = x5;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      x13 = XEXP (x11, 1);
      operands[4] = x13;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      x14 = XEXP (x10, 0);
      switch (GET_CODE (x14))
        {
        case SIGN_EXTEND:
          switch (pattern1082 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1745; /* *aarch64_sadalpv8qi_vec_concatz_be_insn */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1753; /* *aarch64_sadalpv4hi_vec_concatz_be_insn */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1763; /* *aarch64_sadalpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1082 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1748; /* *aarch64_uadalpv8qi_vec_concatz_be_insn */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1756; /* *aarch64_uadalpv4hi_vec_concatz_be_insn */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1766; /* *aarch64_uadalpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x2, 0);
      operands[4] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case SMAX:
          switch (pattern832 (x2, 
SMIN))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1769; /* aarch64_sabav8qi_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1777; /* aarch64_sabav4hi_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1785; /* aarch64_sabav2si_vec_concatz_be */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern832 (x2, 
UMIN))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1772; /* aarch64_uabav8qi_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1780; /* aarch64_uabav4hi_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1788; /* aarch64_uabav2si_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[2] = x10;
          x5 = XEXP (x2, 0);
          operands[4] = x5;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1014 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1656 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2044; /* aarch64_mlav8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern1014 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1656 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2048; /* aarch64_mlav4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern1014 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1656 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2052; /* aarch64_mlav2si_vec_concatz_be */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x14 = XEXP (x10, 0);
          switch (GET_CODE (x14))
            {
            case VEC_SELECT:
              x15 = XEXP (x14, 1);
              if (GET_CODE (x15) != PARALLEL
                  || XVECLEN (x15, 0) != 1)
                return -1;
              x5 = XEXP (x2, 0);
              operands[5] = x5;
              x16 = XEXP (x14, 0);
              operands[1] = x16;
              x17 = XVECEXP (x15, 0, 0);
              operands[2] = x17;
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x4, 1);
              operands[3] = x11;
              x6 = XEXP (x3, 1);
              operands[4] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1236 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V4HImode:
                      if (!register_operand (operands[1], E_V4HImode)
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1671 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2056; /* *aarch64_mla_eltv4hi_vec_concatz_be */

                    case E_V8HImode:
                      if (!register_operand (operands[1], E_V8HImode)
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1689 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2064; /* *aarch64_mla_elt_to_128v4hi_vec_concatz_be */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  if (pattern1236 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V2SImode:
                      if (!register_operand (operands[1], E_V2SImode)
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1671 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2060; /* *aarch64_mla_eltv2si_vec_concatz_be */

                    case E_V4SImode:
                      if (!register_operand (operands[1], E_V4SImode)
                          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1689 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2068; /* *aarch64_mla_elt_to_128v2si_vec_concatz_be */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x14;
              x5 = XEXP (x2, 0);
              operands[4] = x5;
              x11 = XEXP (x4, 1);
              operands[2] = x11;
              x6 = XEXP (x3, 1);
              operands[1] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1083 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1705 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2072; /* aarch64_mla_nv4hi_vec_concatz_be */

                case E_V4SImode:
                  if (pattern1083 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                      || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1705 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2076; /* aarch64_mla_nv2si_vec_concatz_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_SELECT)
        return -1;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case SIGN_EXTEND:
          switch (pattern764 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3560 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2838; /* *aarch64_saddlpv8qi_vec_concatz_be_insn */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3560 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2846; /* *aarch64_saddlpv4hi_vec_concatz_be_insn */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3560 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2856; /* *aarch64_saddlpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern764 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3560 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2841; /* *aarch64_uaddlpv8qi_vec_concatz_be_insn */

            case 1:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3560 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2849; /* *aarch64_uaddlpv4hi_vec_concatz_be_insn */

            case 2:
              if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3560 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2859; /* *aarch64_uaddlpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        case VEC_CONCAT:
          x18 = XEXP (x6, 0);
          if (GET_CODE (x18) != VEC_CONCAT)
            return -1;
          x5 = XEXP (x2, 0);
          operands[5] = x5;
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x19 = XEXP (x6, 1);
          operands[4] = x19;
          x20 = XEXP (x18, 0);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x21 = XEXP (x18, 1);
          if (!rtx_equal_p (x21, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1237 (x2, 
E_V16QImode, 
E_V8QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4418; /* aarch64_addpv8qi_vec_concatz_be_insn */

            case E_V8HImode:
              if (pattern1237 (x2, 
E_V8HImode, 
E_V4HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4421; /* aarch64_addpv4hi_vec_concatz_be_insn */

            case E_V4SImode:
              if (pattern1237 (x2, 
E_V4SImode, 
E_V2SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4424; /* aarch64_addpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case AND:
          x5 = XEXP (x2, 0);
          operands[5] = x5;
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x6 = XEXP (x3, 1);
          operands[4] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1084 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4258; /* aarch64_cmtstv8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern1084 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4262; /* aarch64_cmtstv4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern1084 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7381 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4266; /* aarch64_cmtstv2si_vec_concatz_be */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x10;
          x5 = XEXP (x2, 0);
          operands[4] = x5;
          x11 = XEXP (x4, 1);
          operands[2] = x11;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1015 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7398 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4271; /* *aarch64_cmtst_same_v8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern1015 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7398 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4275; /* *aarch64_cmtst_same_v4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern1015 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7398 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4279; /* *aarch64_cmtst_same_v2si_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_504 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x3, 2);
      operands[3] = x6;
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern914 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2875 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2458; /* fmav4hf4_vec_concatz_le */

        case E_V4SFmode:
          if (pattern914 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2875 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2462; /* fmav2sf4_vec_concatz_le */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case VEC_SELECT:
          if (GET_MODE (x8) != E_SFmode)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != PARALLEL
              || XVECLEN (x9, 0) != 1
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || GET_MODE (x3) != E_V2SFmode
              || GET_MODE (x4) != E_V2SFmode)
            return -1;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          x11 = XVECEXP (x9, 0, 0);
          operands[2] = x11;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          x6 = XEXP (x3, 2);
          operands[4] = x6;
          if (!register_operand (operands[4], E_V2SFmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[5] = x7;
          if (!aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2SFmode:
              if (!register_operand (operands[1], E_V2SFmode)
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2889 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2467; /* *aarch64_fma4_eltv2sf_vec_concatz_le */

            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2906 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2472; /* *aarch64_fma4_elt_to_128v2sf_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x8;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          x6 = XEXP (x3, 2);
          operands[3] = x6;
          x7 = XEXP (x2, 1);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern971 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2476; /* *aarch64_fma4_elt_from_dupv4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern971 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2480; /* *aarch64_fma4_elt_from_dupv2si_vec_concatz_le */

            case E_V8HFmode:
              if (pattern971 (x2, 
E_V4HFmode, 
E_HFmode, 
E_V8HFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2484; /* *aarch64_fma4_elt_from_dupv4hf_vec_concatz_le */

            case E_V4SFmode:
              if (pattern971 (x2, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2488; /* *aarch64_fma4_elt_from_dupv2sf_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          x6 = XEXP (x3, 2);
          operands[3] = x6;
          x7 = XEXP (x2, 1);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern972 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2948 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2494; /* fnmav4hf4_vec_concatz_le */

            case E_V4SFmode:
              if (pattern972 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2948 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2498; /* fnmav2sf4_vec_concatz_le */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x12 = XEXP (x5, 0);
          switch (GET_CODE (x12))
            {
            case VEC_SELECT:
              if (GET_MODE (x12) != E_SFmode)
                return -1;
              x13 = XEXP (x12, 1);
              if (GET_CODE (x13) != PARALLEL
                  || XVECLEN (x13, 0) != 1
                  || !register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || GET_MODE (x3) != E_V2SFmode
                  || GET_MODE (x4) != E_V2SFmode)
                return -1;
              x8 = XEXP (x4, 0);
              operands[3] = x8;
              if (!register_operand (operands[3], E_V2SFmode)
                  || GET_MODE (x5) != E_V2SFmode)
                return -1;
              x14 = XEXP (x12, 0);
              operands[1] = x14;
              x15 = XVECEXP (x13, 0, 0);
              operands[2] = x15;
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              x6 = XEXP (x3, 2);
              operands[4] = x6;
              if (!register_operand (operands[4], E_V2SFmode))
                return -1;
              x7 = XEXP (x2, 1);
              operands[5] = x7;
              if (!aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (!register_operand (operands[1], E_V2SFmode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2963 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2503; /* *aarch64_fnma4_eltv2sf_vec_concatz_le */

                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2981 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2508; /* *aarch64_fnma4_elt_to_128v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x12;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              x6 = XEXP (x3, 2);
              operands[3] = x6;
              x7 = XEXP (x2, 1);
              operands[4] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1030 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2997 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2512; /* *aarch64_fnma4_elt_from_dupv4hi_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1030 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2997 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2516; /* *aarch64_fnma4_elt_from_dupv2si_vec_concatz_le */

                case E_V8HFmode:
                  if (pattern1030 (x2, 
E_V4HFmode, 
E_HFmode, 
E_V8HFmode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2997 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 2520; /* *aarch64_fnma4_elt_from_dupv4hf_vec_concatz_le */

                case E_V4SFmode:
                  if (pattern1030 (x2, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2997 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2524; /* *aarch64_fnma4_elt_from_dupv2sf_vec_concatz_le */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_507 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case IOR:
      switch (pattern317 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 328 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1370; /* iornv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 328 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1374; /* iornv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 328 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1378; /* iornv2si3_vec_concatz_le */

        case 3:
          if (pattern826 (x3, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1819; /* iorv8qi3_vec_concatz_le */

        case 4:
          if (pattern826 (x3, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1823; /* iorv4hi3_vec_concatz_le */

        case 5:
          if (pattern826 (x3, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1138 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1827; /* iorv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
      return recog_498 (x1, insn, pnum_clobbers);

    case AND:
      switch (pattern317 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1383; /* andnv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1387; /* andnv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 337 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1391; /* andnv2si3_vec_concatz_le */

        case 3:
          if (pattern835 (x3, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1806; /* andv8qi3_vec_concatz_le */

        case 4:
          if (pattern835 (x3, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1810; /* andv4hi3_vec_concatz_le */

        case 5:
          if (pattern835 (x3, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1814; /* andv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case PLUS:
      return recog_499 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_505 (x1, insn, pnum_clobbers);

    case MULT:
      switch (pattern320 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1422; /* mulv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1426; /* mulv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 364 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1430; /* mulv2si3_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2673 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2421; /* mulv4hf3_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2673 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2425; /* mulv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case BITREVERSE:
      if (pattern321 (x3) != 0
          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 380 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
        return -1;
      return 1439; /* aarch64_rbitv8qi_vec_concatz_le */

    case UNSPEC:
      return recog_502 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_503 (x1, insn, pnum_clobbers);

    case ABS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern428 (x3))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1655; /* absv8qi2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1659; /* absv4hi2_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1663; /* absv2si2_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2719 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2449; /* absv4hf2_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2719 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2453; /* absv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case MINUS:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XEXP (x3, 1);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern432 (x3, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 1792; /* fabdv4hf3_vec_concatz_le */

            case E_V4SFmode:
              if (pattern432 (x3, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1796; /* fabdv2sf3_vec_concatz_le */

            case E_V2DFmode:
              if (pattern432 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1803; /* fabddf3_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          x8 = XEXP (x3, 1);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern836 (x3, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1832; /* xorv8qi3_vec_concatz_le */

            case E_V8HImode:
              if (pattern836 (x3, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1836; /* xorv4hi3_vec_concatz_le */

            case E_V4SImode:
              if (pattern836 (x3, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1840; /* xorv2si3_vec_concatz_le */

            default:
              return -1;
            }

        case AND:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != XOR)
            return -1;
          x10 = XEXP (x6, 0);
          operands[3] = x10;
          x11 = XEXP (x6, 1);
          operands[2] = x11;
          x7 = XEXP (x5, 1);
          operands[1] = x7;
          x8 = XEXP (x3, 1);
          operands[4] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern970 (x3, 
E_V8QImode, 
E_V16QImode) != 0)
                return -1;
              x9 = XEXP (x4, 1);
              if (rtx_equal_p (x9, operands[3])
                  && (
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3751 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return 2933; /* aarch64_simd_bslv8qi_internal_vec_concatz_le */
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3775 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2946; /* *aarch64_simd_bslv8qi_alt_vec_concatz_le */

            case E_V8HImode:
              if (pattern970 (x3, 
E_V4HImode, 
E_V8HImode) != 0)
                return -1;
              x9 = XEXP (x4, 1);
              if (rtx_equal_p (x9, operands[3])
                  && (
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3751 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return 2937; /* aarch64_simd_bslv4hi_internal_vec_concatz_le */
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3775 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2950; /* *aarch64_simd_bslv4hi_alt_vec_concatz_le */

            case E_V4SImode:
              if (pattern970 (x3, 
E_V2SImode, 
E_V4SImode) != 0)
                return -1;
              x9 = XEXP (x4, 1);
              if (rtx_equal_p (x9, operands[3])
                  && (
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3751 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return 2941; /* aarch64_simd_bslv2si_internal_vec_concatz_le */
              if (!rtx_equal_p (x9, operands[2])
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3775 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2954; /* *aarch64_simd_bslv2si_alt_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      switch (pattern323 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1845; /* one_cmplv8qi2_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1849; /* one_cmplv4hi2_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1853; /* one_cmplv2si2_vec_concatz_le */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern325 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1271 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1910; /* aarch64_simd_lshrv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1271 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1914; /* aarch64_simd_lshrv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1271 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1918; /* aarch64_simd_lshrv2si_vec_concatz_le */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern325 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1280 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1923; /* aarch64_simd_ashrv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1280 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1927; /* aarch64_simd_ashrv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1280 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1931; /* aarch64_simd_ashrv2si_vec_concatz_le */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      switch (GET_CODE (operands[2]))
        {
        case CONST_VECTOR:
        case CONST:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern837 (x3, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1395 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1973; /* aarch64_simd_imm_shlv8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern837 (x3, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1395 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1977; /* aarch64_simd_imm_shlv4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern837 (x3, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1395 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1981; /* aarch64_simd_imm_shlv2si_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern318 (x3, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1406 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1986; /* aarch64_simd_reg_sshlv8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern318 (x3, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1406 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1990; /* aarch64_simd_reg_sshlv4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern318 (x3, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1406 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1994; /* aarch64_simd_reg_sshlv2si_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern326 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2115; /* smaxv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2131; /* smaxv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2147; /* smaxv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern326 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2118; /* sminv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2134; /* sminv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2150; /* sminv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern326 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2121; /* umaxv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2137; /* umaxv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2153; /* umaxv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern326 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2124; /* uminv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2140; /* uminv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1774 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2156; /* uminv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      return recog_501 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_500 (x1, insn, pnum_clobbers);

    case DIV:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern318 (x3, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2694 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2430; /* *divv4hf3_vec_concatz_le */

        case E_V4SFmode:
          if (pattern318 (x3, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2694 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2434; /* *divv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case FMA:
      return recog_504 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
          operands[2] = x8;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern558 (x3, 
E_V2SFmode, 
E_V2DFmode, 
E_V4SFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3273 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2703; /* truncv2dfv2sf2_vec_concatz_le */

            case E_V8HFmode:
              if (pattern558 (x3, 
E_V4HFmode, 
E_V4SFmode, 
E_V8HFmode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3273 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2706; /* truncv4sfv4hf2_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x8;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern556 (x3, 
E_V2SFmode, 
E_V2DFmode, 
E_V4SFmode) != 0
                  || !
#line 3295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 2710; /* aarch64_float_truncate_hi_v4sf_be */

            case E_V8HFmode:
              if (pattern556 (x3, 
E_V4HFmode, 
E_V4SFmode, 
E_V8HFmode) != 0
                  || !
#line 3295 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 2711; /* aarch64_float_truncate_hi_v8hf_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CLRSB:
      switch (pattern323 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3569 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2861; /* clrsbv8qi2_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3569 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2865; /* clrsbv4hi2_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3569 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2869; /* clrsbv2si2_vec_concatz_le */

        default:
          return -1;
        }

    case CLZ:
      switch (pattern323 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2873; /* clzv8qi2_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2877; /* clzv4hi2_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2881; /* clzv2si2_vec_concatz_le */

        default:
          return -1;
        }

    case POPCOUNT:
      if (pattern321 (x3) != 0
          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3585 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
        return -1;
      return 2885; /* popcountv8qi2_vec_concatz_le */

    case SS_PLUS:
      switch (pattern326 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3288; /* ssaddv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3304; /* ssaddv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3320; /* ssaddv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case US_PLUS:
      switch (pattern326 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3291; /* usaddv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3307; /* usaddv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3323; /* usaddv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern326 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3294; /* sssubv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3310; /* sssubv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3326; /* sssubv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern326 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3297; /* ussubv8qi3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3313; /* ussubv4hi3_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5220 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3329; /* ussubv2si3_vec_concatz_le */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x8 = XEXP (x3, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
              switch (pattern559 (x3))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5450 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3400; /* aarch64_sqmovnv8hi_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5450 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3406; /* aarch64_sqmovnv4si_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5450 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3412; /* aarch64_sqmovnv2di_vec_concatz_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern557 (x3))
                {
                case 0:
                  if (!
#line 5472 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3423; /* aarch64_sqxtn2v8hi_be */

                case 1:
                  if (!
#line 5472 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3425; /* aarch64_sqxtn2v4si_be */

                case 2:
                  if (!
#line 5472 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3427; /* aarch64_sqxtn2v2di_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern443 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3945; /* *aarch64_sqsshrn_nv8hi_insn_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3963; /* *aarch64_sqsshrn_nv4si_insn_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT))))
                return -1;
              return 3981; /* *aarch64_sqsshrn_nv2di_insn_vec_concatz_le */

            case 3:
              if (!
#line 7006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4073; /* aarch64_sqsshrn2_nv8hi_insn_be */

            case 4:
              if (!
#line 7006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4079; /* aarch64_sqsshrn2_nv4si_insn_be */

            case 5:
              if (!
#line 7006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, ASHIFTRT)))
                return -1;
              return 4085; /* aarch64_sqsshrn2_nv2di_insn_be */

            case 6:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 3999; /* *aarch64_sqrshrn_nv8hi_insn_vec_concatz_le */

            case 7:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 4008; /* *aarch64_sqrshrn_nv4si_insn_vec_concatz_le */

            case 8:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6770 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 4017; /* *aarch64_sqrshrn_nv2di_insn_vec_concatz_le */

            case 9:
              if (!
#line 7061 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4100; /* aarch64_sqrshrn2_nv8hi_insn_be */

            case 10:
              if (!
#line 7061 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4103; /* aarch64_sqrshrn2_nv4si_insn_be */

            case 11:
              if (!
#line 7061 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 4106; /* aarch64_sqrshrn2_nv2di_insn_be */

            default:
              return -1;
            }

        case LSHIFTRT:
          x8 = XEXP (x3, 1);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
              switch (pattern434 (x3))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT))))
                    return -1;
                  return 3948; /* *aarch64_sqshrn_nv8hi_insn_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT))))
                    return -1;
                  return 3966; /* *aarch64_sqshrn_nv4si_insn_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6743 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT))))
                    return -1;
                  return 3984; /* *aarch64_sqshrn_nv2di_insn_vec_concatz_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern435 (x3))
                {
                case 0:
                  if (!
#line 7006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                    return -1;
                  return 4074; /* aarch64_squshrn2_nv8hi_insn_be */

                case 1:
                  if (!
#line 7006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                    return -1;
                  return 4080; /* aarch64_squshrn2_nv4si_insn_be */

                case 2:
                  if (!
#line 7006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (SS_TRUNCATE, LSHIFTRT)))
                    return -1;
                  return 4086; /* aarch64_squshrn2_nv2di_insn_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case US_TRUNCATE:
      return recog_506 (x1, insn, pnum_clobbers);

    case SS_NEG:
      switch (pattern327 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3448; /* aarch64_sqnegv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3456; /* aarch64_sqnegv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3464; /* aarch64_sqnegv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3480; /* aarch64_sqnegdi_vec_concatz_le */

        default:
          return -1;
        }

    case SS_ABS:
      switch (pattern327 (x3))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3451; /* aarch64_sqabsv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3459; /* aarch64_sqabsv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3467; /* aarch64_sqabsv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5592 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3483; /* aarch64_sqabsdi_vec_concatz_le */

        default:
          return -1;
        }

    case SQRT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern322 (x3, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 7600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4430; /* *sqrtv4hf2_vec_concatz_le */

        case E_V4SFmode:
          if (pattern322 (x3, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 7600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4434; /* *sqrtv2sf2_vec_concatz_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_527 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern9 (x1))
    {
    case 0:
      if (!(
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 964; /* lbtruncuhfsi2 */

    case 1:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 984; /* lbtruncusfsi2 */

    case 2:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1004; /* lbtruncudfsi2 */

    case 3:
      if (!(
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 974; /* lbtruncuhfdi2 */

    case 4:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 994; /* lbtruncusfdi2 */

    case 5:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1014; /* lbtruncudfdi2 */

    case 6:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2597; /* lbtruncuv4hfv4hi2 */

    case 7:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2607; /* lbtruncuv8hfv8hi2 */

    case 8:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2617; /* lbtruncuv2sfv2si2 */

    case 9:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2627; /* lbtruncuv4sfv4si2 */

    case 10:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2637; /* lbtruncuv2dfv2di2 */

    case 11:
      if (!
#line 3047 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2647; /* lbtruncuhfhi2 */

    case 12:
      if (!
#line 3075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V2SFmode)))))
        return -1;
      return 2657; /* *aarch64_fcvtuv2sfv2si2_mult */

    case 13:
      if (!
#line 3075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V4SFmode)))))
        return -1;
      return 2659; /* *aarch64_fcvtuv4sfv4si2_mult */

    case 14:
      if (!
#line 3075 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V2DFmode)))))
        return -1;
      return 2661; /* *aarch64_fcvtuv2dfv2di2_mult */

    case 15:
      if (!(
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 965; /* lceiluhfsi2 */

    case 16:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 985; /* lceilusfsi2 */

    case 17:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1005; /* lceiludfsi2 */

    case 18:
      if (!(
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 975; /* lceiluhfdi2 */

    case 19:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 995; /* lceilusfdi2 */

    case 20:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1015; /* lceiludfdi2 */

    case 21:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2598; /* lceiluv4hfv4hi2 */

    case 22:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2608; /* lceiluv8hfv8hi2 */

    case 23:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2618; /* lceiluv2sfv2si2 */

    case 24:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2628; /* lceiluv4sfv4si2 */

    case 25:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2638; /* lceiluv2dfv2di2 */

    case 26:
      if (!
#line 3047 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2648; /* lceiluhfhi2 */

    case 27:
      if (!(
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 966; /* lflooruhfsi2 */

    case 28:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 986; /* lfloorusfsi2 */

    case 29:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1006; /* lfloorudfsi2 */

    case 30:
      if (!(
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 976; /* lflooruhfdi2 */

    case 31:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 996; /* lfloorusfdi2 */

    case 32:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1016; /* lfloorudfdi2 */

    case 33:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2599; /* lflooruv4hfv4hi2 */

    case 34:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2609; /* lflooruv8hfv8hi2 */

    case 35:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2619; /* lflooruv2sfv2si2 */

    case 36:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2629; /* lflooruv4sfv4si2 */

    case 37:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2639; /* lflooruv2dfv2di2 */

    case 38:
      if (!
#line 3047 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2649; /* lflooruhfhi2 */

    case 39:
      if (!(
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 967; /* lrounduhfsi2 */

    case 40:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 987; /* lroundusfsi2 */

    case 41:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1007; /* lroundudfsi2 */

    case 42:
      if (!(
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 977; /* lrounduhfdi2 */

    case 43:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 997; /* lroundusfdi2 */

    case 44:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1017; /* lroundudfdi2 */

    case 45:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2600; /* lrounduv4hfv4hi2 */

    case 46:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2610; /* lrounduv8hfv8hi2 */

    case 47:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2620; /* lrounduv2sfv2si2 */

    case 48:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2630; /* lrounduv4sfv4si2 */

    case 49:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2640; /* lrounduv2dfv2di2 */

    case 50:
      if (!
#line 3047 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2650; /* lrounduhfhi2 */

    case 51:
      if (!(
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 968; /* lfrintnuhfsi2 */

    case 52:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 988; /* lfrintnusfsi2 */

    case 53:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1008; /* lfrintnudfsi2 */

    case 54:
      if (!(
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 978; /* lfrintnuhfdi2 */

    case 55:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 998; /* lfrintnusfdi2 */

    case 56:
      if (!
#line 7034 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1018; /* lfrintnudfdi2 */

    case 57:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2601; /* lfrintnuv4hfv4hi2 */

    case 58:
      if (!(
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2611; /* lfrintnuv8hfv8hi2 */

    case 59:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2621; /* lfrintnuv2sfv2si2 */

    case 60:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2631; /* lfrintnuv4sfv4si2 */

    case 61:
      if (!
#line 3037 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2641; /* lfrintnuv2dfv2di2 */

    case 62:
      if (!
#line 3047 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2651; /* lfrintnuhfhi2 */

    case 63:
      if (!
#line 7045 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (SImode))))
        return -1;
      return 1020; /* *aarch64_fcvtusfsi2_mult */

    case 64:
      if (!
#line 7045 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (SImode))))
        return -1;
      return 1024; /* *aarch64_fcvtudfsi2_mult */

    case 65:
      if (!
#line 7045 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (DImode))))
        return -1;
      return 1022; /* *aarch64_fcvtusfdi2_mult */

    case 66:
      if (!
#line 7045 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (DImode))))
        return -1;
      return 1026; /* *aarch64_fcvtudfdi2_mult */

    case 67:
      if (!
#line 7207 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1046; /* fixuns_truncsfsi2 */

    case 68:
      if (!
#line 7219 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1050; /* fixuns_trunchfsi2 */

    case 69:
      if (!
#line 7230 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1054; /* fixuns_truncdfsi2 */

    case 70:
      if (!
#line 7207 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1048; /* fixuns_truncdfdi2 */

    case 71:
      if (!
#line 7219 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1052; /* fixuns_trunchfdi2 */

    case 72:
      if (!
#line 7230 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1056; /* fixuns_truncsfdi2 */

    case 73:
      if (!
#line 3055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2653; /* fixuns_trunchfhi2 */

    case 74:
      if (!
#line 3433 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12854; /* fixunsvnx8sfvnx8si2 */

    case 75:
      if (!
#line 3433 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12856; /* fixunsvnx16sfvnx16si2 */

    default:
      return -1;
    }
}

 int
recog_537 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case TRUNCATE:
      operands[1] = x4;
      switch (pattern394 (x3))
        {
        case 0:
          return 392; /* negsi2 */

        case 1:
          return 393; /* negdi2 */

        case 2:
          if ((
#line 7508 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return 1115; /* neghf2 */
          break;

        case 3:
          if (
#line 7508 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return 1116; /* negsf2 */
          break;

        case 4:
          if (
#line 7508 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return 1117; /* negdf2 */
          break;

        case 5:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1641; /* negv8qi2 */
          break;

        case 6:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1644; /* negv16qi2 */
          break;

        case 7:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1645; /* negv4hi2 */
          break;

        case 8:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1648; /* negv8hi2 */
          break;

        case 9:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1649; /* negv2si2 */
          break;

        case 10:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1652; /* negv4si2 */
          break;

        case 11:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1653; /* negv2di2 */
          break;

        case 12:
          if ((
#line 2702 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return 2438; /* negv4hf2 */
          break;

        case 13:
          if ((
#line 2702 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return 2441; /* negv8hf2 */
          break;

        case 14:
          if (
#line 2702 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2442; /* negv2sf2 */
          break;

        case 15:
          if (
#line 2702 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2445; /* negv4sf2 */
          break;

        case 16:
          if (
#line 2702 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2446; /* negv2df2 */
          break;

        default:
          break;
        }
      if (!subreg_lowpart_operator (x4, E_SImode))
        return -1;
      operands[4] = x4;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SIGN_EXTRACT
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      if (!aarch64_simd_shift_imm_offset_si (operands[3], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 2);
      operands[2] = x8;
      if (!aarch64_simd_shift_imm_offset_si (operands[2], E_VOIDmode)
          || !
#line 4265 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) + INTVAL (operands[3]) == 32))
        return -1;
      return 416; /* *neg_asr_si2_extr */

    case ASHIFT:
      switch (pattern297 (x3))
        {
        case 0:
          return 407; /* *neg_lsl_si2 */

        case 1:
          return 410; /* *neg_lsl_di2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern297 (x3))
        {
        case 0:
          return 408; /* *neg_asr_si2 */

        case 1:
          return 411; /* *neg_asr_di2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern297 (x3))
        {
        case 0:
          return 409; /* *neg_lsr_si2 */

        case 1:
          return 412; /* *neg_lsr_di2 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_471 (x1, insn, pnum_clobbers);

    case FMA:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x9 = XEXP (x4, 1);
      operands[3] = x9;
      x10 = XEXP (x4, 2);
      operands[1] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern752 (x3, 
E_SFmode) != 0
              || !
#line 7144 "../../gcc/config/aarch64/aarch64.md"
(!HONOR_SIGNED_ZEROS (SFmode) && TARGET_FLOAT))
            return -1;
          return 1037; /* *aarch64_fnmaddsf4 */

        case E_DFmode:
          if (pattern752 (x3, 
E_DFmode) != 0
              || !
#line 7144 "../../gcc/config/aarch64/aarch64.md"
(!HONOR_SIGNED_ZEROS (DFmode) && TARGET_FLOAT))
            return -1;
          return 1038; /* *aarch64_fnmadddf4 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern368 (x3, 
E_SFmode) != 0
              || !
#line 7479 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1110; /* *fnmulsf3 */

        case E_DFmode:
          if (pattern368 (x3, 
E_DFmode) != 0
              || !
#line 7479 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1111; /* *fnmuldf3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_542 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern31 (x3))
    {
    case 0:
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case SUBREG:
        case TRUNCATE:
          switch (pattern524 (x3))
            {
            case 0:
              if (
#line 6037 "../../gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0))
                return 761; /* *aarch64_ashr_reg_si3_mask1 */
              break;

            case 1:
              if (
#line 6037 "../../gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0))
                return 766; /* *aarch64_ashr_reg_di3_mask1 */
              break;

            case 2:
              if (
#line 6101 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                return 783; /* *aarch64_ashr_reg_di3_mask2 */
              break;

            case 3:
              if (
#line 6049 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)))
                return 771; /* *aarch64_ashr_reg_si3_neg_mask2 */
              break;

            case 4:
              if (
#line 6049 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                return 776; /* *aarch64_ashr_reg_di3_neg_mask2 */
              break;

            default:
              break;
            }
          break;

        case CONST_INT:
          switch (pattern525 (x3))
            {
            case 0:
              if (
#line 6365 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
                return 814; /* *ashrqi3_insn */
              break;

            case 1:
              if (
#line 6365 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
                return 817; /* *ashrhi3_insn */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[2] = x4;
      if (!aarch64_reg_or_shift_imm_di (operands[2], E_QImode))
        return -1;
      switch (pattern2 (x3))
        {
        case 0:
          return 797; /* *aarch64_ashr_sisd_or_int_si3 */

        case 1:
          return 798; /* *aarch64_ashr_sisd_or_int_di3 */

        default:
          return -1;
        }

    case 1:
      if (!
#line 6119 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)))
        return -1;
      return 788; /* *aarch64_ashr_reg_minussi3 */

    case 2:
      if (!
#line 6119 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)))
        return -1;
      return 791; /* *aarch64_ashr_reg_minusdi3 */

    case 3:
      if (!
#line 1280 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1922; /* aarch64_simd_ashrv8qi */

    case 4:
      if (!
#line 1280 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1925; /* aarch64_simd_ashrv16qi */

    case 5:
      if (!
#line 1280 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1926; /* aarch64_simd_ashrv4hi */

    case 6:
      if (!
#line 1280 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1929; /* aarch64_simd_ashrv8hi */

    case 7:
      if (!
#line 1280 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1930; /* aarch64_simd_ashrv2si */

    case 8:
      if (!
#line 1280 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1933; /* aarch64_simd_ashrv4si */

    case 9:
      if (!
#line 1280 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1934; /* aarch64_simd_ashrv2di */

    case 10:
      if (!
#line 5070 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8340; /* aarch64_vashrvnx16qi3_const */

    case 11:
      if (!
#line 5070 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8342; /* aarch64_vashrvnx8qi3_const */

    case 12:
      if (!
#line 5070 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8344; /* aarch64_vashrvnx4qi3_const */

    case 13:
      if (!
#line 5070 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8346; /* aarch64_vashrvnx2qi3_const */

    case 14:
      if (!
#line 5070 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8348; /* aarch64_vashrvnx8hi3_const */

    case 15:
      if (!
#line 5070 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8350; /* aarch64_vashrvnx4hi3_const */

    case 16:
      if (!
#line 5070 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8352; /* aarch64_vashrvnx2hi3_const */

    case 17:
      if (!
#line 5070 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8354; /* aarch64_vashrvnx4si3_const */

    case 18:
      if (!
#line 5070 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8356; /* aarch64_vashrvnx2si3_const */

    case 19:
      if (!
#line 5070 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8358; /* aarch64_vashrvnx2di3_const */

    default:
      return -1;
    }
}

 int
recog_575 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10207; /* while_ugtsivnx16bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10217; /* while_ugtdivnx16bi_ptest */
}

 int
recog_585 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3564 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10166; /* *while_gtsivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3564 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10176; /* *while_gtdivnx4bi_cc */
}

 int
recog_595 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10125; /* *while_gesivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10135; /* *while_gedivnx16bi_cc */
}

 int
recog_605 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern679 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10048; /* while_ugesivnx16bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10058; /* while_ugedivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10068; /* while_ugesivnx8bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10078; /* while_ugedivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10088; /* while_ugesivnx4bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10098; /* while_ugedivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10108; /* while_ugesivnx2bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8561 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10118; /* while_ugedivnx2bi */

    default:
      return -1;
    }
}

 int
recog_609 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (XWINT (x4, 0) != 0L)
    return -1;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != NEG
          || GET_MODE (x7) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x7, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      return 318; /* negdi_carryout */

    case PLUS:
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != ZERO_EXTEND)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != MINUS)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != NEG)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      x11 = XEXP (x5, 1);
      operands[2] = x11;
      x12 = XEXP (x7, 1);
      operands[3] = x12;
      x13 = XEXP (x8, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      switch (GET_MODE (x5))
        {
        case E_DImode:
          if (pattern1322 (x1, 
E_SImode, 
E_DImode) != 0)
            return -1;
          return 377; /* *usubsi3_carryinC_z1 */

        case E_TImode:
          if (pattern1322 (x1, 
E_DImode, 
E_TImode) != 0)
            return -1;
          return 378; /* *usubdi3_carryinC_z1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_611 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_NZmode
              || GET_MODE (x3) != E_CC_NZmode)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 1);
          switch (GET_CODE (x10))
            {
            case PLUS:
              switch (pattern1250 (x1))
                {
                case 0:
                  return 165; /* addsi3_compare0 */

                case 1:
                  return 166; /* adddi3_compare0 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern1190 (x1, 
PLUS) != 0
                  || !aarch64_plus_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_DImode))
                return -1;
              x11 = XEXP (x10, 0);
              x12 = XEXP (x11, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              x13 = XEXP (x11, 1);
              if (!rtx_equal_p (x13, operands[2]))
                return -1;
              return 167; /* *addsi3_compare0_uxtw */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Cmode
              || GET_MODE (x3) != E_CC_Cmode)
            return -1;
          switch (pattern1250 (x1))
            {
            case 0:
              return 170; /* addsi3_compareC */

            case 1:
              return 171; /* adddi3_compareC */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x14 = XEXP (x5, 0);
      operands[1] = x14;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
          operands[2] = x6;
          if (pattern1100 (x2) != 0)
            return -1;
          switch (pattern1268 (x1))
            {
            case 0:
              if (pattern1338 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 176; /* addsi3_compareV_imm */

            case 1:
              if (pattern1338 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 177; /* adddi3_compareV_imm */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern1100 (x2) != 0)
            return -1;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          switch (pattern1268 (x1))
            {
            case 0:
              if (pattern1339 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 178; /* addsi3_compareV */

            case 1:
              if (pattern1339 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 179; /* adddi3_compareV */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SIGN_EXTEND)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_NZmode
              || GET_MODE (x3) != E_CC_NZmode)
            return -1;
          switch (pattern1252 (x1))
            {
            case 0:
              return 192; /* *adds_extendqi_si */

            case 1:
              return 196; /* *adds_extendhi_si */

            case 2:
              return 200; /* *adds_extendsi_si */

            case 3:
              return 194; /* *adds_extendqi_di */

            case 4:
              return 198; /* *adds_extendhi_di */

            case 5:
              return 202; /* *adds_extendsi_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern917 (x1, 
ASHIFT) != 0)
        return -1;
      x16 = XEXP (x5, 1);
      operands[2] = x16;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x13 = XEXP (x11, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      x17 = XEXP (x10, 1);
      if (!rtx_equal_p (x17, operands[3]))
        return -1;
      x14 = XEXP (x5, 0);
      switch (GET_CODE (x14))
        {
        case REG:
        case SUBREG:
          operands[1] = x14;
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (pattern919 (x1))
            {
            case 0:
              return 180; /* *adds_shift_imm_si */

            case 1:
              return 183; /* *adds_shift_imm_di */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern1300 (x1, 
SIGN_EXTEND))
            {
            case 0:
              return 216; /* *adds_extendqi_shift_si */

            case 1:
              return 220; /* *adds_extendhi_shift_si */

            case 2:
              return 224; /* *adds_extendsi_shift_si */

            case 3:
              return 218; /* *adds_extendqi_shift_di */

            case 4:
              return 222; /* *adds_extendhi_shift_di */

            case 5:
              return 226; /* *adds_extendsi_shift_di */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1300 (x1, 
ZERO_EXTEND))
            {
            case 0:
              return 217; /* *adds_zero_extendqi_shift_si */

            case 1:
              return 221; /* *adds_zero_extendhi_shift_si */

            case 2:
              return 225; /* *adds_zero_extendsi_shift_si */

            case 3:
              return 219; /* *adds_zero_extendqi_shift_di */

            case 4:
              return 223; /* *adds_zero_extendhi_shift_di */

            case 5:
              return 227; /* *adds_zero_extendsi_shift_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern921 (x1, 
ASHIFTRT))
        {
        case 0:
          return 181; /* *adds_shift_imm_si */

        case 1:
          return 184; /* *adds_shift_imm_di */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern921 (x1, 
LSHIFTRT))
        {
        case 0:
          return 182; /* *adds_shift_imm_si */

        case 1:
          return 185; /* *adds_shift_imm_di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern917 (x1, 
ZERO_EXTEND) != 0)
        return -1;
      x14 = XEXP (x5, 0);
      operands[1] = x14;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (pattern1252 (x1))
        {
        case 0:
          return 193; /* *adds_zero_extendqi_si */

        case 1:
          return 197; /* *adds_zero_extendhi_si */

        case 2:
          return 201; /* *adds_zero_extendsi_si */

        case 3:
          return 195; /* *adds_zero_extendqi_di */

        case 4:
          return 199; /* *adds_zero_extendhi_di */

        case 5:
          return 203; /* *adds_zero_extendsi_di */

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[2] = x5;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_ADCmode
              || GET_MODE (x3) != E_CC_ADCmode)
            return -1;
          x15 = XEXP (x6, 0);
          operands[1] = x15;
          x7 = XEXP (x3, 1);
          operands[4] = x7;
          if (!const_scalar_int_operand (operands[4], E_VOIDmode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1312 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 3306 "../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[4], DImode)
   == (wi::shwi (1, DImode) << (unsigned) GET_MODE_BITSIZE (SImode))))
                return -1;
              return 294; /* *addsi3_carryinC_zero */

            case E_TImode:
              if (pattern1312 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 3306 "../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[4], TImode)
   == (wi::shwi (1, TImode) << (unsigned) GET_MODE_BITSIZE (DImode))))
                return -1;
              return 295; /* *adddi3_carryinC_zero */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x18 = XEXP (x7, 0);
          if (GET_CODE (x18) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Vmode
              || GET_MODE (x3) != E_CC_Vmode)
            return -1;
          x15 = XEXP (x6, 0);
          operands[1] = x15;
          x19 = XEXP (x18, 0);
          operands[3] = x19;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1340 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 298; /* *addsi3_carryinV_zero */

            case E_TImode:
              if (pattern1340 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 299; /* *adddi3_carryinV_zero */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != PLUS)
        return -1;
      x14 = XEXP (x5, 0);
      operands[3] = x14;
      x16 = XEXP (x5, 1);
      switch (GET_CODE (x16))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_ADCmode
              || GET_MODE (x3) != E_CC_ADCmode)
            return -1;
          x21 = XEXP (x16, 0);
          operands[1] = x21;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x7 = XEXP (x3, 1);
          operands[5] = x7;
          if (!const_scalar_int_operand (operands[5], E_VOIDmode))
            return -1;
          x12 = XEXP (x11, 0);
          operands[4] = x12;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1348 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 3326 "../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[5], DImode)
   == (wi::shwi (1, DImode) << (unsigned) GET_MODE_BITSIZE (SImode))))
                return -1;
              return 296; /* *addsi3_carryinC */

            case E_TImode:
              if (pattern1348 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 3326 "../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[5], TImode)
   == (wi::shwi (1, TImode) << (unsigned) GET_MODE_BITSIZE (DImode))))
                return -1;
              return 297; /* *adddi3_carryinC */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != SIGN_EXTEND)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x18 = XEXP (x7, 0);
          if (GET_CODE (x18) != PLUS)
            return -1;
          x19 = XEXP (x18, 0);
          if (GET_CODE (x19) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Vmode
              || GET_MODE (x3) != E_CC_Vmode)
            return -1;
          x21 = XEXP (x16, 0);
          operands[1] = x21;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x22 = XEXP (x19, 0);
          operands[4] = x22;
          x23 = XEXP (x19, 1);
          if (!rtx_equal_p (x23, operands[1]))
            return -1;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[2]))
            return -1;
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[4]))
            return -1;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1369 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 300; /* *addsi3_carryinV */

            case E_TImode:
              if (pattern1369 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 301; /* *adddi3_carryinV */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_618 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x4, 1))
        {
        case 17:
          if (pattern783 (x1) != 0
              || !
#line 8502 "../../gcc/config/aarch64/aarch64.md"
(TARGET_TME))
            return -1;
          return 1262; /* tstart */

        case 157:
          if (pattern783 (x1) != 0
              || !
#line 8511 "../../gcc/config/aarch64/aarch64.md"
(TARGET_TME))
            return -1;
          return 1263; /* ttest */

        case 20:
          if (pattern784 (x1, 
20) != 0
              || !
#line 8538 "../../gcc/config/aarch64/aarch64.md"
(TARGET_RNG))
            return -1;
          return 1266; /* aarch64_rndr */

        case 21:
          if (pattern784 (x1, 
21) != 0
              || !
#line 8548 "../../gcc/config/aarch64/aarch64.md"
(TARGET_RNG))
            return -1;
          return 1267; /* aarch64_rndrrs */

        case 66:
          if (pattern785 (x1, 
65) != 0
              || !
#line 8669 "../../gcc/config/aarch64/aarch64.md"
(TARGET_LS64))
            return -1;
          return 1276; /* st64bv */

        case 68:
          if (pattern785 (x1, 
67) != 0
              || !
#line 8681 "../../gcc/config/aarch64/aarch64.md"
(TARGET_LS64))
            return -1;
          return 1277; /* st64bv0 */

        case 23:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE
              || XINT (x7, 1) != 23
              || !register_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          switch (XVECLEN (x7, 0))
            {
            case 2:
              x9 = XVECEXP (x7, 0, 0);
              operands[2] = x9;
              x10 = XVECEXP (x7, 0, 1);
              operands[3] = x10;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_QImode)
                      || GET_MODE (x7) != E_QImode
                      || !aarch64_reg_or_zero (operands[2], E_QImode))
                    return -1;
                  return 5581; /* aarch64_store_exclusiveqi */

                case E_HImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_HImode)
                      || GET_MODE (x7) != E_HImode
                      || !aarch64_reg_or_zero (operands[2], E_HImode))
                    return -1;
                  return 5582; /* aarch64_store_exclusivehi */

                case E_SImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_SImode)
                      || GET_MODE (x7) != E_SImode
                      || !aarch64_reg_or_zero (operands[2], E_SImode))
                    return -1;
                  return 5583; /* aarch64_store_exclusivesi */

                case E_DImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_DImode)
                      || GET_MODE (x7) != E_DImode
                      || !aarch64_reg_or_zero (operands[2], E_DImode))
                    return -1;
                  return 5584; /* aarch64_store_exclusivedi */

                default:
                  return -1;
                }

            case 3:
              if (GET_MODE (x7) != E_TImode
                  || !aarch64_sync_memory_operand (operands[1], E_TImode))
                return -1;
              x9 = XVECEXP (x7, 0, 0);
              operands[2] = x9;
              if (!aarch64_reg_or_zero (operands[2], E_DImode))
                return -1;
              x10 = XVECEXP (x7, 0, 1);
              operands[3] = x10;
              if (!aarch64_reg_or_zero (operands[3], E_DImode))
                return -1;
              x11 = XVECEXP (x7, 0, 2);
              operands[4] = x11;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              return 5585; /* aarch64_store_exclusive_pair */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      operands[1] = x12;
      x13 = XVECEXP (x4, 0, 2);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      x5 = XVECEXP (x4, 0, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      switch (XINT (x4, 1))
        {
        case 32:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1156 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5456; /* aarch64_atomic_iorqi_lse */

            case E_HImode:
              if (pattern1156 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5460; /* aarch64_atomic_iorhi_lse */

            case E_SImode:
              if (pattern1156 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5464; /* aarch64_atomic_iorsi_lse */

            case E_DImode:
              if (pattern1156 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5468; /* aarch64_atomic_iordi_lse */

            default:
              return -1;
            }

        case 33:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1156 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5457; /* aarch64_atomic_bicqi_lse */

            case E_HImode:
              if (pattern1156 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5461; /* aarch64_atomic_bichi_lse */

            case E_SImode:
              if (pattern1156 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5465; /* aarch64_atomic_bicsi_lse */

            case E_DImode:
              if (pattern1156 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5469; /* aarch64_atomic_bicdi_lse */

            default:
              return -1;
            }

        case 34:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1156 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5458; /* aarch64_atomic_xorqi_lse */

            case E_HImode:
              if (pattern1156 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5462; /* aarch64_atomic_xorhi_lse */

            case E_SImode:
              if (pattern1156 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5466; /* aarch64_atomic_xorsi_lse */

            case E_DImode:
              if (pattern1156 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5470; /* aarch64_atomic_xordi_lse */

            default:
              return -1;
            }

        case 35:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1156 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5459; /* aarch64_atomic_addqi_lse */

            case E_HImode:
              if (pattern1156 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5463; /* aarch64_atomic_addhi_lse */

            case E_SImode:
              if (pattern1156 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5467; /* aarch64_atomic_addsi_lse */

            case E_DImode:
              if (pattern1156 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5471; /* aarch64_atomic_adddi_lse */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x4, 1) != 22
          || GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern786 (x6, 
E_DImode, 
22, 
2, 
UNSPEC_VOLATILE) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      if (!aarch64_sync_memory_operand (operands[2], E_TImode))
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      operands[3] = x12;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x6, 1);
      x9 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XVECEXP (x7, 0, 1);
      if (!rtx_equal_p (x10, operands[3]))
        return -1;
      return 5580; /* aarch64_load_exclusive_pair */

    default:
      return -1;
    }
}

 int
recog_627 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61;
  int res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      return recog_623 (x1, insn, pnum_clobbers);

    case 5:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case SUBREG:
        case MEM:
          x6 = XEXP (x4, 0);
          operands[4] = x6;
          if (scratch_operand (operands[4], E_DImode))
            {
              res = recog_619 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x8 = XEXP (x7, 1);
          if (GET_CODE (x8) != UNSPEC_VOLATILE
              || XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 31)
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 66
              || GET_MODE (x9) != E_CCmode)
            return -1;
          x10 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x11 = XEXP (x2, 0);
          operands[0] = x11;
          operands[1] = x5;
          x12 = XVECEXP (x8, 0, 1);
          operands[3] = x12;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1279 (x1))
            {
            case 0:
              return 5476; /* aarch64_atomic_fetch_addqi */

            case 1:
              return 5481; /* aarch64_atomic_fetch_addhi */

            case 2:
              return 5486; /* aarch64_atomic_fetch_addsi */

            case 3:
              return 5491; /* aarch64_atomic_fetch_adddi */

            case 4:
              return 5477; /* aarch64_atomic_fetch_subqi */

            case 5:
              return 5482; /* aarch64_atomic_fetch_subhi */

            case 6:
              return 5487; /* aarch64_atomic_fetch_subsi */

            case 7:
              return 5492; /* aarch64_atomic_fetch_subdi */

            case 8:
              return 5478; /* aarch64_atomic_fetch_orqi */

            case 9:
              return 5483; /* aarch64_atomic_fetch_orhi */

            case 10:
              return 5488; /* aarch64_atomic_fetch_orsi */

            case 11:
              return 5493; /* aarch64_atomic_fetch_ordi */

            case 12:
              return 5479; /* aarch64_atomic_fetch_xorqi */

            case 13:
              return 5484; /* aarch64_atomic_fetch_xorhi */

            case 14:
              return 5489; /* aarch64_atomic_fetch_xorsi */

            case 15:
              return 5494; /* aarch64_atomic_fetch_xordi */

            case 16:
              return 5480; /* aarch64_atomic_fetch_andqi */

            case 17:
              return 5485; /* aarch64_atomic_fetch_andhi */

            case 18:
              return 5490; /* aarch64_atomic_fetch_andsi */

            case 19:
              return 5495; /* aarch64_atomic_fetch_anddi */

            case 20:
              return 5512; /* atomic_fetch_nandqi */

            case 21:
              return 5513; /* atomic_fetch_nandhi */

            case 22:
              return 5514; /* atomic_fetch_nandsi */

            case 23:
              return 5515; /* atomic_fetch_nanddi */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x5, 0) != 0L)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 66
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x10 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x10) != SET)
            return -1;
          x13 = XEXP (x10, 1);
          if (GET_CODE (x13) != UNSPEC
              || XVECLEN (x13, 0) != 2)
            return -1;
          x14 = XVECEXP (x13, 0, 0);
          if (GET_CODE (x14) != MEM
              || GET_MODE (x14) != E_BLKmode)
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) != MEM
              || GET_MODE (x15) != E_BLKmode)
            return -1;
          x11 = XEXP (x2, 0);
          operands[2] = x11;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          x16 = XEXP (x7, 0);
          operands[0] = x16;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x9 = XEXP (x3, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_DImode)
              || GET_MODE (x13) != E_BLKmode)
            return -1;
          x17 = XEXP (x14, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          x18 = XVECEXP (x13, 0, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x19 = XEXP (x15, 0);
          if (!rtx_equal_p (x19, operands[0]))
            return -1;
          switch (XINT (x13, 1))
            {
            case 8:
              if (!
#line 2099 "../../gcc/config/aarch64/aarch64.md"
(TARGET_MOPS))
                return -1;
              return 125; /* *aarch64_cpymemdi */

            case 70:
              if (!
#line 2145 "../../gcc/config/aarch64/aarch64.md"
(TARGET_MOPS))
                return -1;
              return 126; /* *aarch64_movmemdi */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 98)
            return -1;
          x11 = XEXP (x2, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern453 (x7, 
30, 
E_DImode, 
CLOBBER) != 0)
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 66
              || GET_MODE (x9) != E_CCmode)
            return -1;
          x10 = XVECEXP (x1, 0, 4);
          if (pattern578 (x10, 
E_DImode, 
29, 
USE) != 0)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          operands[0] = x20;
          if (!aarch64_valid_symref (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!scratch_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (x11))
            {
            case E_SImode:
              if (GET_MODE (x5) != E_SImode
                  || !(
#line 8031 "../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && !TARGET_SVE) && 
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode)))
                return -1;
              return 1192; /* tlsdesc_small_advsimd_si */

            case E_DImode:
              if (GET_MODE (x5) != E_DImode
                  || !(
#line 8031 "../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && !TARGET_SVE) && 
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode)))
                return -1;
              return 1193; /* tlsdesc_small_advsimd_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      return recog_625 (x1, insn, pnum_clobbers);

    case 4:
      return recog_624 (x1, insn, pnum_clobbers);

    case 6:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE
          || pattern363 (x1, 
CLOBBER, 
E_TImode, 
0, 
684) != 0
          || pattern579 (x1, 
E_DImode, 
30, 
18, 
17, 
16) != 0)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      if (pattern1316 (x21, 
E_CCmode, 
66) != 0)
        return -1;
      return 13180; /* aarch64_get_sme_state */

    case 26:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != UNSPEC_VOLATILE
          || XVECLEN (x2, 0) != 1)
        return -1;
      x22 = XVECEXP (x2, 0, 0);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != USE
          || pattern579 (x1, 
E_V4x16QImode, 
40, 
36, 
32, 
67) != 0)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      if (pattern1316 (x21, 
E_V4x16QImode, 
44) != 0)
        return -1;
      x23 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x23) != CLOBBER)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != REG
          || REGNO (x24) != 48
          || GET_MODE (x24) != E_V4x16QImode)
        return -1;
      x25 = XVECEXP (x1, 0, 7);
      if (pattern1365 (x25, 
E_V4x16QImode, 
52) != 0)
        return -1;
      x26 = XVECEXP (x1, 0, 8);
      if (pattern1373 (x26, 
E_V4x16QImode, 
56) != 0)
        return -1;
      x27 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x27) != CLOBBER)
        return -1;
      x28 = XEXP (x27, 0);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 60
          || GET_MODE (x28) != E_V4x16QImode)
        return -1;
      x29 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x29) != CLOBBER)
        return -1;
      x30 = XEXP (x29, 0);
      if (GET_CODE (x30) != REG
          || REGNO (x30) != 68
          || GET_MODE (x30) != E_VNx16BImode)
        return -1;
      x31 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x31) != CLOBBER)
        return -1;
      x32 = XEXP (x31, 0);
      if (GET_CODE (x32) != REG
          || REGNO (x32) != 69
          || GET_MODE (x32) != E_VNx16BImode)
        return -1;
      x33 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x33) != CLOBBER)
        return -1;
      x34 = XEXP (x33, 0);
      if (GET_CODE (x34) != REG
          || REGNO (x34) != 70
          || GET_MODE (x34) != E_VNx16BImode)
        return -1;
      x35 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x35) != CLOBBER)
        return -1;
      x36 = XEXP (x35, 0);
      if (GET_CODE (x36) != REG
          || REGNO (x36) != 71
          || GET_MODE (x36) != E_VNx16BImode)
        return -1;
      x37 = XVECEXP (x1, 0, 14);
      if (GET_CODE (x37) != CLOBBER)
        return -1;
      x38 = XEXP (x37, 0);
      if (GET_CODE (x38) != REG
          || REGNO (x38) != 72
          || GET_MODE (x38) != E_VNx16BImode)
        return -1;
      x39 = XVECEXP (x1, 0, 15);
      if (GET_CODE (x39) != CLOBBER)
        return -1;
      x40 = XEXP (x39, 0);
      if (GET_CODE (x40) != REG
          || REGNO (x40) != 73
          || GET_MODE (x40) != E_VNx16BImode)
        return -1;
      x41 = XVECEXP (x1, 0, 16);
      if (GET_CODE (x41) != CLOBBER)
        return -1;
      x42 = XEXP (x41, 0);
      if (GET_CODE (x42) != REG
          || REGNO (x42) != 74
          || GET_MODE (x42) != E_VNx16BImode)
        return -1;
      x43 = XVECEXP (x1, 0, 17);
      if (GET_CODE (x43) != CLOBBER)
        return -1;
      x44 = XEXP (x43, 0);
      if (GET_CODE (x44) != REG
          || REGNO (x44) != 75
          || GET_MODE (x44) != E_VNx16BImode)
        return -1;
      x45 = XVECEXP (x1, 0, 18);
      if (GET_CODE (x45) != CLOBBER)
        return -1;
      x46 = XEXP (x45, 0);
      if (GET_CODE (x46) != REG
          || REGNO (x46) != 76
          || GET_MODE (x46) != E_VNx16BImode)
        return -1;
      x47 = XVECEXP (x1, 0, 19);
      if (GET_CODE (x47) != CLOBBER)
        return -1;
      x48 = XEXP (x47, 0);
      if (GET_CODE (x48) != REG
          || REGNO (x48) != 77
          || GET_MODE (x48) != E_VNx16BImode)
        return -1;
      x49 = XVECEXP (x1, 0, 20);
      if (GET_CODE (x49) != CLOBBER)
        return -1;
      x50 = XEXP (x49, 0);
      if (GET_CODE (x50) != REG
          || REGNO (x50) != 78
          || GET_MODE (x50) != E_VNx16BImode)
        return -1;
      x51 = XVECEXP (x1, 0, 21);
      if (GET_CODE (x51) != CLOBBER)
        return -1;
      x52 = XEXP (x51, 0);
      if (GET_CODE (x52) != REG
          || REGNO (x52) != 79
          || GET_MODE (x52) != E_VNx16BImode)
        return -1;
      x53 = XVECEXP (x1, 0, 22);
      if (GET_CODE (x53) != CLOBBER)
        return -1;
      x54 = XEXP (x53, 0);
      if (GET_CODE (x54) != REG
          || REGNO (x54) != 80
          || GET_MODE (x54) != E_VNx16BImode)
        return -1;
      x55 = XVECEXP (x1, 0, 23);
      if (GET_CODE (x55) != CLOBBER)
        return -1;
      x56 = XEXP (x55, 0);
      if (GET_CODE (x56) != REG
          || REGNO (x56) != 81
          || GET_MODE (x56) != E_VNx16BImode)
        return -1;
      x57 = XVECEXP (x1, 0, 24);
      if (GET_CODE (x57) != CLOBBER)
        return -1;
      x58 = XEXP (x57, 0);
      if (GET_CODE (x58) != REG
          || REGNO (x58) != 82
          || GET_MODE (x58) != E_VNx16BImode)
        return -1;
      x59 = XVECEXP (x1, 0, 25);
      if (GET_CODE (x59) != CLOBBER)
        return -1;
      x60 = XEXP (x59, 0);
      if (GET_CODE (x60) != REG
          || REGNO (x60) != 83
          || GET_MODE (x60) != E_VNx16BImode)
        return -1;
      switch (XINT (x2, 1))
        {
        case 686:
          return 13182; /* aarch64_smstart_sm */

        case 687:
          return 13183; /* aarch64_smstop_sm */

        default:
          return -1;
        }

    case 8:
      x2 = XVECEXP (x1, 0, 0);
      if (pattern13 (x2, 
89, 
690, 
2) != 0)
        return -1;
      x5 = XEXP (x2, 1);
      x61 = XVECEXP (x5, 0, 1);
      if (GET_CODE (x61) != REG
          || REGNO (x61) != 90
          || GET_MODE (x61) != E_DImode)
        return -1;
      x11 = XEXP (x2, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 91
          || GET_MODE (x11) != E_DImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER
          || pattern1255 (x1, 
16, 
15, 
14, 
E_DImode) != 0
          || pattern1366 (x1, 
E_CCmode, 
66, 
30, 
18, 
17) != 0)
        return -1;
      return 13184; /* aarch64_tpidr2_save */

    case 9:
      x2 = XVECEXP (x1, 0, 0);
      if (pattern13 (x2, 
0, 
691, 
1) != 0)
        return -1;
      x11 = XEXP (x2, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 92
          || pattern690 (x1, 
89, 
691, 
1) != 0
          || pattern1255 (x1, 
15, 
14, 
89, 
E_DImode) != 0
          || pattern1366 (x1, 
E_DImode, 
30, 
18, 
17, 
16) != 0)
        return -1;
      x26 = XVECEXP (x1, 0, 8);
      if (pattern1373 (x26, 
E_CCmode, 
66) != 0)
        return -1;
      return 13192; /* aarch64_tpidr2_restore */

    case 10:
      if (pattern14 (x1) != 0)
        return -1;
      return 13193; /* aarch64_restore_za */

    default:
      return -1;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern848 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3674 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return gen_split_1121 (insn, operands);
      operands[6] = x3;
      if (!aarch64_simd_reg_or_zero (operands[6], E_VNx16QImode)
          || !(
#line 3705 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[6])) && 
#line 3711 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_1131 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3674 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return gen_split_1122 (insn, operands);
      operands[6] = x3;
      if (!aarch64_simd_reg_or_zero (operands[6], E_VNx8QImode)
          || !(
#line 3705 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[6])) && 
#line 3711 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_1132 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3674 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return gen_split_1123 (insn, operands);
      operands[6] = x3;
      if (!aarch64_simd_reg_or_zero (operands[6], E_VNx4QImode)
          || !(
#line 3705 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[6])) && 
#line 3711 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_1133 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3674 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return gen_split_1124 (insn, operands);
      operands[6] = x3;
      if (!aarch64_simd_reg_or_zero (operands[6], E_VNx2QImode)
          || !(
#line 3705 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[6])) && 
#line 3711 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_1134 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3674 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return gen_split_1125 (insn, operands);
      operands[6] = x3;
      if (!aarch64_simd_reg_or_zero (operands[6], E_VNx8HImode)
          || !(
#line 3705 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[6])) && 
#line 3711 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_1135 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3674 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return gen_split_1126 (insn, operands);
      operands[6] = x3;
      if (!aarch64_simd_reg_or_zero (operands[6], E_VNx4HImode)
          || !(
#line 3705 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[6])) && 
#line 3711 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_1136 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3674 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return gen_split_1127 (insn, operands);
      operands[6] = x3;
      if (!aarch64_simd_reg_or_zero (operands[6], E_VNx2HImode)
          || !(
#line 3705 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[6])) && 
#line 3711 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_1137 (insn, operands);

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3674 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return gen_split_1128 (insn, operands);
      operands[6] = x3;
      if (!aarch64_simd_reg_or_zero (operands[6], E_VNx4SImode)
          || !(
#line 3705 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[6])) && 
#line 3711 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_1138 (insn, operands);

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3674 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return gen_split_1129 (insn, operands);
      operands[6] = x3;
      if (!aarch64_simd_reg_or_zero (operands[6], E_VNx2SImode)
          || !(
#line 3705 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[6])) && 
#line 3711 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_1139 (insn, operands);

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3674 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return gen_split_1130 (insn, operands);
      operands[6] = x3;
      if (!aarch64_simd_reg_or_zero (operands[6], E_VNx2DImode)
          || !(
#line 3705 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[6])) && 
#line 3711 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
        return NULL;
      return gen_split_1140 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern867 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3819 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3824 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1149 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3873 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1182 (insn, operands);

    case E_VNx4SFmode:
      if (pattern867 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3819 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3824 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1160 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3873 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1193 (insn, operands);

    case E_VNx2DFmode:
      if (pattern867 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3819 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3824 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1171 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3867 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3873 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1204 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx8HImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1251 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1258 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2951 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx8HImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1278 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1283 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2959 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx8HImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1303 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1317 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2967 (insn, operands);
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx8HImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1251 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1258 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2950 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx8HImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1278 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1283 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2958 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx8HImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1303 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1317 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2966 (insn, operands);
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1049 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1054 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2822 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1074 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1079 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2869 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1109 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2909 (insn, operands);
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1049 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1054 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2856 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1074 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1079 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2897 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1109 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2937 (insn, operands);
}

 rtx_insn *
split_33 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1049 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1054 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2843 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1074 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1079 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2886 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1109 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2926 (insn, operands);
}

 rtx_insn *
split_38 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1049 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1054 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2830 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1074 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1079 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2875 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1109 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2915 (insn, operands);
}

 rtx_insn *
split_43 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1049 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1054 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2816 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1074 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1079 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2864 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1109 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2904 (insn, operands);
}

 rtx_insn *
split_49 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1049 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1054 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2838 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1074 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1079 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2882 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1109 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2922 (insn, operands);
}

 rtx_insn *
split_55 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1049 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1054 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2813 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1074 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1079 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2861 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1109 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2901 (insn, operands);
}

 rtx_insn *
split_61 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1044 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1690 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1763 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1815 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1703 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1776 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1828 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1716 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1789 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1841 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1729 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1802 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1854 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5669 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1736 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5838 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1913 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5669 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1743 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5838 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1920 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5669 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1750 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5838 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1927 (insn, operands);

    case 7:
      if (!((
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1867 (insn, operands);

    case 8:
      if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1880 (insn, operands);

    case 9:
      if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1893 (insn, operands);

    case 10:
      if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1906 (insn, operands);

    case 11:
      if (!(
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5874 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1934 (insn, operands);

    case 12:
      if (!(
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5874 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1941 (insn, operands);

    case 13:
      if (!(
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5874 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1948 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_65 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1044 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1683 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1756 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1808 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1696 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1769 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1821 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1709 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1782 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1834 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5621 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5626 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1722 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5707 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5712 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1795 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5750 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5762 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1847 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5669 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1731 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5838 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1908 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5669 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1738 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5838 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1915 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5664 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5669 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1745 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5832 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5838 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1922 (insn, operands);

    case 7:
      if (!((
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1860 (insn, operands);

    case 8:
      if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1873 (insn, operands);

    case 9:
      if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1886 (insn, operands);

    case 10:
      if (!(
#line 5794 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5806 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1899 (insn, operands);

    case 11:
      if (!(
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5874 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1929 (insn, operands);

    case 12:
      if (!(
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5874 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1936 (insn, operands);

    case 13:
      if (!(
#line 5868 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5874 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1943 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_72 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[4] = x6;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern701 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1269 (insn, operands);

        case E_VNx8QImode:
          if (pattern701 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1286 (insn, operands);

        case E_VNx4QImode:
          if (pattern701 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1303 (insn, operands);

        case E_VNx2QImode:
          if (pattern701 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1320 (insn, operands);

        case E_VNx8HImode:
          if (pattern701 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1337 (insn, operands);

        case E_VNx4HImode:
          if (pattern701 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1354 (insn, operands);

        case E_VNx2HImode:
          if (pattern701 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1371 (insn, operands);

        case E_VNx4SImode:
          if (pattern701 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1388 (insn, operands);

        case E_VNx2SImode:
          if (pattern701 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1405 (insn, operands);

        case E_VNx2DImode:
          if (pattern701 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 4185 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4195 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1422 (insn, operands);

        default:
          return NULL;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1046 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1548 (insn, operands);

        case E_VNx8QImode:
          if (pattern1046 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1551 (insn, operands);

        case E_VNx4QImode:
          if (pattern1046 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1554 (insn, operands);

        case E_VNx2QImode:
          if (pattern1046 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1557 (insn, operands);

        case E_VNx8HImode:
          if (pattern1046 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1560 (insn, operands);

        case E_VNx4HImode:
          if (pattern1046 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1563 (insn, operands);

        case E_VNx2HImode:
          if (pattern1046 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1566 (insn, operands);

        case E_VNx4SImode:
          if (pattern1046 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1569 (insn, operands);

        case E_VNx2SImode:
          if (pattern1046 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1572 (insn, operands);

        case E_VNx2DImode:
          if (pattern1046 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 5101 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5107 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1575 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_76 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XINT (x2, 1) != 123
      || GET_MODE (x2) != E_BLKmode)
    return NULL;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 125
      || GET_MODE (x3) != E_VNx2DImode)
    return NULL;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return NULL;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return NULL;
  x6 = XVECEXP (x2, 0, 0);
  operands[5] = x6;
  if (!register_operand (operands[5], E_VNx2BImode))
    return NULL;
  x7 = XVECEXP (x2, 0, 1);
  operands[0] = x7;
  if (!register_operand (operands[0], E_DImode))
    return NULL;
  x8 = XVECEXP (x3, 0, 0);
  operands[6] = x8;
  x9 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x9) != E_VNx2DImode)
    return NULL;
  x10 = XVECEXP (x2, 0, 3);
  operands[2] = x10;
  if (!const_int_operand (operands[2], E_DImode))
    return NULL;
  x11 = XVECEXP (x2, 0, 4);
  operands[3] = x11;
  switch (pattern1311 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_1019 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1319 ())
            {
            case 0:
              if ((
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1021 (insn, operands);
              break;

            case 1:
              if ((
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1023 (insn, operands);
              break;

            case 2:
              if ((
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1025 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1027 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1029 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1031 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1033 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2565 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2570 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_1035 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1319 ())
            {
            case 0:
              if ((
#line 2565 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2570 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1036 (insn, operands);
              break;

            case 1:
              if ((
#line 2565 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2570 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1037 (insn, operands);
              break;

            case 2:
              if ((
#line 2565 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2570 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1038 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2565 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2570 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1039 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2565 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2570 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1040 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2565 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2570 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1041 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2565 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2570 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1042 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x12 = XVECEXP (x2, 0, 5);
      if (GET_MODE (x12) == E_VNx2QImode
          && aarch64_gather_scale_operand_b (operands[3], E_DImode))
        {
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          if (register_operand (operands[4], E_VNx2DImode)
              && (
#line 2669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2674 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
            return gen_split_1043 (insn, operands);
        }
      if (GET_MODE (x12) == E_VNx2HImode
          && aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          if (register_operand (operands[4], E_VNx2DImode)
              && (
#line 2669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2674 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
            return gen_split_1044 (insn, operands);
        }
      if (GET_MODE (x12) != E_VNx2SImode
          || !aarch64_gather_scale_operand_w (operands[3], E_DImode))
        return NULL;
      x13 = XEXP (x12, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], E_VNx2DImode)
          || !(
#line 2669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2674 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
        return NULL;
      return gen_split_1045 (insn, operands);

    case 3:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_1020 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1319 ())
            {
            case 0:
              if ((
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1022 (insn, operands);
              break;

            case 1:
              if ((
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1024 (insn, operands);
              break;

            case 2:
              if ((
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1026 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1028 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1030 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1032 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2537 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2542 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1034 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_79 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern693 (x3, 
E_SImode) != 0)
            return NULL;
          return gen_split_37 (insn, operands);

        case E_DImode:
          if (pattern693 (x3, 
E_DImode) != 0)
            return NULL;
          return gen_split_38 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case LSHIFTRT:
          switch (pattern455 (x3))
            {
            case 0:
              if (!
#line 5329 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   SImode)))
                return NULL;
              return gen_split_39 (insn, operands);

            case 1:
              if (!
#line 5329 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   DImode)))
                return NULL;
              return gen_split_43 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern456 (x3))
            {
            case 0:
              if (!
#line 5351 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[3]))
   && (AND != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_47 (insn, operands);

            case 1:
              if (!
#line 5351 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[3]))
   && (AND != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_51 (insn, operands);

            case 2:
              if (!
#line 5380 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[4]))
   && (AND != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_55 (insn, operands);

            case 3:
              if (!
#line 5380 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[4]))
   && (AND != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_59 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFT:
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != SIGN_EXTEND)
            return NULL;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_VOIDmode))
            return NULL;
          switch (pattern366 (x3))
            {
            case 0:
              if (!
#line 5403 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()))
                return NULL;
              return gen_split_63 (insn, operands);

            case 1:
              if (!
#line 5403 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()))
                return NULL;
              return gen_split_66 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !const_int_operand (operands[2], E_VOIDmode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !
#line 6867 "../../gcc/config/aarch64/aarch64.md"
(aarch64_mask_and_shift_for_ubfiz_p (DImode, operands[3], operands[2])
  && (INTVAL (operands[2]) + popcount_hwi (INTVAL (operands[3])))
      == GET_MODE_BITSIZE (SImode)))
            return NULL;
          return gen_split_126 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 2:
          switch (pattern410 (x3))
            {
            case 0:
              if (!(
#line 4880 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4882 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_1498 (insn, operands);

            case 1:
              if (!(
#line 4880 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4882 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_1499 (insn, operands);

            case 2:
              if (!(
#line 4880 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4882 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_1500 (insn, operands);

            case 3:
              if (!(
#line 4880 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4882 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_1501 (insn, operands);

            case 4:
              if (!(
#line 4880 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4882 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_1502 (insn, operands);

            case 5:
              if (!(
#line 4880 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4882 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_1503 (insn, operands);

            case 6:
              if (!(
#line 4880 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4882 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_1504 (insn, operands);

            case 7:
              if (!(
#line 4880 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4882 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_1505 (insn, operands);

            case 8:
              if (!(
#line 4880 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4882 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_1506 (insn, operands);

            case 9:
              if (!(
#line 4880 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4882 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_1507 (insn, operands);

            default:
              return NULL;
            }

        case 4:
          switch (pattern413 (x3))
            {
            case 0:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2577 (insn, operands);

            case 1:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2583 (insn, operands);

            case 2:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2589 (insn, operands);

            case 3:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2578 (insn, operands);

            case 4:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2584 (insn, operands);

            case 5:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2590 (insn, operands);

            case 6:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2579 (insn, operands);

            case 7:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2585 (insn, operands);

            case 8:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2591 (insn, operands);

            case 9:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2580 (insn, operands);

            case 10:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2586 (insn, operands);

            case 11:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2592 (insn, operands);

            case 12:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2581 (insn, operands);

            case 13:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2587 (insn, operands);

            case 14:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2593 (insn, operands);

            case 15:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2582 (insn, operands);

            case 16:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2588 (insn, operands);

            case 17:
              if (!(
#line 8697 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8699 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2594 (insn, operands);

            case 18:
              if (!(
#line 8720 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8722 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2595 (insn, operands);

            case 19:
              if (!(
#line 8720 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8722 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2596 (insn, operands);

            case 20:
              if (!(
#line 8720 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8722 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2597 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_86 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8614 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2526 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8614 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2536 (insn, operands);
}

 rtx_insn *
split_89 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2466 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3568 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2476 (insn, operands);
}

 rtx_insn *
split_92 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8614 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2565 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8614 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2575 (insn, operands);
}

 rtx_insn *
split_95 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8614 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2505 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8614 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2515 (insn, operands);
}

 rtx_insn *
split_99 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2425 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3567 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2435 (insn, operands);
}

 rtx_insn *
split_103 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8614 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2504 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3566 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8614 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2514 (insn, operands);
}

 rtx_insn *
split_109 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8614 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2543 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8610 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8614 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2553 (insn, operands);
}

 rtx_insn *
split_115 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2423 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3565 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2433 (insn, operands);
}

 rtx_insn *
split_121 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3564 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2462 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3564 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2472 (insn, operands);
}

 rtx_insn *
split_128 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2481 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8585 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3563 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8589 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2491 (insn, operands);
}

 rtx_insn *
split_135 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  switch (XINT (x4, 1))
    {
    case 126:
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[5] = x6;
      x7 = XVECEXP (x4, 0, 0);
      operands[6] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[7] = x8;
      x9 = XVECEXP (x4, 0, 2);
      switch (GET_CODE (x9))
        {
        case LT:
          switch (pattern1332 (x1, 
LT))
            {
            case 0:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2117 (insn, operands);

            case 1:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2127 (insn, operands);

            case 2:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2157 (insn, operands);

            case 3:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2137 (insn, operands);

            case 4:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2167 (insn, operands);

            case 5:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2187 (insn, operands);

            case 6:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2147 (insn, operands);

            case 7:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2177 (insn, operands);

            case 8:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2197 (insn, operands);

            case 9:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2207 (insn, operands);

            case 10:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2217 (insn, operands);

            case 11:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2227 (insn, operands);

            case 12:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2257 (insn, operands);

            case 13:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2237 (insn, operands);

            case 14:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2267 (insn, operands);

            case 15:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2287 (insn, operands);

            case 16:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2247 (insn, operands);

            case 17:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2277 (insn, operands);

            case 18:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2297 (insn, operands);

            case 19:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2307 (insn, operands);

            default:
              return NULL;
            }

        case LE:
          switch (pattern1332 (x1, 
LE))
            {
            case 0:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2118 (insn, operands);

            case 1:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2128 (insn, operands);

            case 2:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2158 (insn, operands);

            case 3:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2138 (insn, operands);

            case 4:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2168 (insn, operands);

            case 5:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2188 (insn, operands);

            case 6:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2148 (insn, operands);

            case 7:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2178 (insn, operands);

            case 8:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2198 (insn, operands);

            case 9:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2208 (insn, operands);

            case 10:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2218 (insn, operands);

            case 11:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2228 (insn, operands);

            case 12:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2258 (insn, operands);

            case 13:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2238 (insn, operands);

            case 14:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2268 (insn, operands);

            case 15:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2288 (insn, operands);

            case 16:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2248 (insn, operands);

            case 17:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2278 (insn, operands);

            case 18:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2298 (insn, operands);

            case 19:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2308 (insn, operands);

            default:
              return NULL;
            }

        case EQ:
          switch (pattern1332 (x1, 
EQ))
            {
            case 0:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2119 (insn, operands);

            case 1:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2129 (insn, operands);

            case 2:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2159 (insn, operands);

            case 3:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2139 (insn, operands);

            case 4:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2169 (insn, operands);

            case 5:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2189 (insn, operands);

            case 6:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2149 (insn, operands);

            case 7:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2179 (insn, operands);

            case 8:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2199 (insn, operands);

            case 9:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2209 (insn, operands);

            case 10:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2219 (insn, operands);

            case 11:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2229 (insn, operands);

            case 12:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2259 (insn, operands);

            case 13:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2239 (insn, operands);

            case 14:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2269 (insn, operands);

            case 15:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2289 (insn, operands);

            case 16:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2249 (insn, operands);

            case 17:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2279 (insn, operands);

            case 18:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2299 (insn, operands);

            case 19:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2309 (insn, operands);

            default:
              return NULL;
            }

        case NE:
          switch (pattern1332 (x1, 
NE))
            {
            case 0:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2120 (insn, operands);

            case 1:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2130 (insn, operands);

            case 2:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2160 (insn, operands);

            case 3:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2140 (insn, operands);

            case 4:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2170 (insn, operands);

            case 5:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2190 (insn, operands);

            case 6:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2150 (insn, operands);

            case 7:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2180 (insn, operands);

            case 8:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2200 (insn, operands);

            case 9:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2210 (insn, operands);

            case 10:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2220 (insn, operands);

            case 11:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2230 (insn, operands);

            case 12:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2260 (insn, operands);

            case 13:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2240 (insn, operands);

            case 14:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2270 (insn, operands);

            case 15:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2290 (insn, operands);

            case 16:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2250 (insn, operands);

            case 17:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2280 (insn, operands);

            case 18:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2300 (insn, operands);

            case 19:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2310 (insn, operands);

            default:
              return NULL;
            }

        case GE:
          switch (pattern1332 (x1, 
GE))
            {
            case 0:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2121 (insn, operands);

            case 1:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2131 (insn, operands);

            case 2:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2161 (insn, operands);

            case 3:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2141 (insn, operands);

            case 4:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2171 (insn, operands);

            case 5:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2191 (insn, operands);

            case 6:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2151 (insn, operands);

            case 7:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2181 (insn, operands);

            case 8:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2201 (insn, operands);

            case 9:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2211 (insn, operands);

            case 10:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2221 (insn, operands);

            case 11:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2231 (insn, operands);

            case 12:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2261 (insn, operands);

            case 13:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2241 (insn, operands);

            case 14:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2271 (insn, operands);

            case 15:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2291 (insn, operands);

            case 16:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2251 (insn, operands);

            case 17:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2281 (insn, operands);

            case 18:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2301 (insn, operands);

            case 19:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2311 (insn, operands);

            default:
              return NULL;
            }

        case GT:
          switch (pattern1332 (x1, 
GT))
            {
            case 0:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2122 (insn, operands);

            case 1:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2132 (insn, operands);

            case 2:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2162 (insn, operands);

            case 3:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2142 (insn, operands);

            case 4:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2172 (insn, operands);

            case 5:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2192 (insn, operands);

            case 6:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2152 (insn, operands);

            case 7:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2182 (insn, operands);

            case 8:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2202 (insn, operands);

            case 9:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2212 (insn, operands);

            case 10:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2222 (insn, operands);

            case 11:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2232 (insn, operands);

            case 12:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2262 (insn, operands);

            case 13:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2242 (insn, operands);

            case 14:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2272 (insn, operands);

            case 15:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2292 (insn, operands);

            case 16:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2252 (insn, operands);

            case 17:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2282 (insn, operands);

            case 18:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2302 (insn, operands);

            case 19:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2312 (insn, operands);

            default:
              return NULL;
            }

        case LTU:
          switch (pattern1336 (x1, 
LTU))
            {
            case 0:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2123 (insn, operands);

            case 1:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2133 (insn, operands);

            case 2:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2163 (insn, operands);

            case 3:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2143 (insn, operands);

            case 4:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2173 (insn, operands);

            case 5:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2193 (insn, operands);

            case 6:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2153 (insn, operands);

            case 7:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2183 (insn, operands);

            case 8:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2203 (insn, operands);

            case 9:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2213 (insn, operands);

            case 10:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2223 (insn, operands);

            case 11:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2233 (insn, operands);

            case 12:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2263 (insn, operands);

            case 13:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2243 (insn, operands);

            case 14:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2273 (insn, operands);

            case 15:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2293 (insn, operands);

            case 16:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2253 (insn, operands);

            case 17:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2283 (insn, operands);

            case 18:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2303 (insn, operands);

            case 19:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2313 (insn, operands);

            default:
              return NULL;
            }

        case LEU:
          switch (pattern1336 (x1, 
LEU))
            {
            case 0:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2124 (insn, operands);

            case 1:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2134 (insn, operands);

            case 2:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2164 (insn, operands);

            case 3:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2144 (insn, operands);

            case 4:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2174 (insn, operands);

            case 5:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2194 (insn, operands);

            case 6:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2154 (insn, operands);

            case 7:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2184 (insn, operands);

            case 8:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2204 (insn, operands);

            case 9:
              if (!(
#line 8366 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8376 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2214 (insn, operands);

            case 10:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2224 (insn, operands);

            case 11:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2234 (insn, operands);

            case 12:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2264 (insn, operands);

            case 13:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2244 (insn, operands);

            case 14:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2274 (insn, operands);

            case 15:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2294 (insn, operands);

            case 16:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2254 (insn, operands);

            case 17:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2284 (insn, operands);

            case 18:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2304 (insn, operands);

            case 19:
              if (!(
#line 8400 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8410 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
                return NULL;
              return gen_split_2314 (insn, operands);

            default:
              return NULL;
            }

        case GEU:
          return split_134 (x1, insn);

        case GTU:
          return split_133 (x1, insn);

        case UNSPEC:
          if (XVECLEN (x9, 0) != 2)
            return NULL;
          x10 = XVECEXP (x9, 0, 0);
          operands[2] = x10;
          x11 = XVECEXP (x9, 0, 1);
          operands[3] = x11;
          switch (XINT (x9, 1))
            {
            case 473:
              switch (pattern1364 (x1, 
473))
                {
                case 0:
                  if (!(
#line 4047 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4051 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3046 (insn, operands);

                case 1:
                  if (!(
#line 4047 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4051 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3048 (insn, operands);

                case 2:
                  if (!(
#line 4075 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4079 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3050 (insn, operands);

                case 3:
                  if (!(
#line 4075 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4079 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3052 (insn, operands);

                default:
                  return NULL;
                }

            case 474:
              switch (pattern1364 (x1, 
474))
                {
                case 0:
                  if (!(
#line 4047 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4051 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3047 (insn, operands);

                case 1:
                  if (!(
#line 4047 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4051 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3049 (insn, operands);

                case 2:
                  if (!(
#line 4075 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4079 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3051 (insn, operands);

                case 3:
                  if (!(
#line 4075 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 4079 "../../gcc/config/aarch64/aarch64-sve2.md"
( !rtx_equal_p (operands[4], operands[6]))))
                    return NULL;
                  return gen_split_3053 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 305:
      switch (pattern1273 (x1, 
305))
        {
        case 0:
          if (!(
#line 10568 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10572 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2690 (insn, operands);

        case 1:
          if (!(
#line 10568 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10572 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2692 (insn, operands);

        case 2:
          if (!(
#line 10568 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10572 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2694 (insn, operands);

        case 3:
          if (!(
#line 10568 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10572 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2696 (insn, operands);

        case 4:
          if (!(
#line 10593 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10597 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2698 (insn, operands);

        case 5:
          if (!(
#line 10593 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10597 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2700 (insn, operands);

        case 6:
          if (!(
#line 10593 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10597 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2702 (insn, operands);

        case 7:
          if (!(
#line 10593 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10597 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2704 (insn, operands);

        default:
          return NULL;
        }

    case 306:
      switch (pattern1273 (x1, 
306))
        {
        case 0:
          if (!(
#line 10568 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10572 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2691 (insn, operands);

        case 1:
          if (!(
#line 10568 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10572 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2693 (insn, operands);

        case 2:
          if (!(
#line 10568 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10572 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2695 (insn, operands);

        case 3:
          if (!(
#line 10568 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10572 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2697 (insn, operands);

        case 4:
          if (!(
#line 10593 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10597 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2699 (insn, operands);

        case 5:
          if (!(
#line 10593 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10597 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2701 (insn, operands);

        case 6:
          if (!(
#line 10593 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10597 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2703 (insn, operands);

        case 7:
          if (!(
#line 10593 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])) && 
#line 10597 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[2], operands[4]))))
            return NULL;
          return gen_split_2705 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
